module Csrf

type _val_any = { v : mutable any }

type _val_string = { v : mutable string }


val encode : any -> string
let encode (bag : any) : string =
  let (res : _val_string) = { v = "" } in
    (foreach (bag) (fun (k : string) ->
      let (v : string) = setTag string ((read (bag) (k))) in
        let (s : string) = String_concat (k) (String_concat ("=") (v)) in
          if ((res.v) = ("")) then 
            write res "v" (String_concat (res.v) (s))
          else
            write res "v" (String_concat (res.v) (String_concat ("&") (s)))));
    (res.v)

let csrfToken = 
  "%GENERATED_TOKEN%"

let targetOrigin = 
  "%TARGET_ORIGIN%"

val xhrGet : string -> string
let xhrGet (url : string) : string =
  (url)

val authRpc : string -> string -> string -> string
let authRpc (url : string) (apifun : string) (args : string) : string =
  if ((String_startsWith (url) (String_concat (targetOrigin) ("/"))) && (String_noQueryHash (url))) then 
    (let (m : _val_any) = { v = {methd = apifun; args = args; token = csrfToken} } in
       let (msg : _val_string) = { v = encode (m.v) } in
         (xhrGet (String_concat (url) (String_concat ("?") (msg.v)))))
  else
    ("unauthorized URL")

val test : unit -> string
let test (x : unit) : string =
  (authRpc ("%TARGET_ORIGIN%/") ("f") ("1"))


