module Csrfwhitelist

type _val_any = { v : mutable any }

type _val_bool = { v : mutable bool }

type _val_string = { v : mutable string }


val xhrGet : string -> string
let xhrGet (url : string) : string =
  (url)

val encode : any -> string
let encode (bag : any) : string =
  let (res : _val_string) = { v = "" } in
    (foreach (bag) (fun (k : string) ->
      let (v : string) = setTag string ((read (bag) (k))) in
        let (s : string) = String_concat (k) (String_concat ("=") (v)) in
          if ((res.v) = ("")) then 
            write res "v" (String_concat (res.v) (s))
          else
            write res "v" (String_concat (res.v) (String_concat ("&") (s)))));
    (res.v)

let csrfToken = 
  "%GENERATED_TOKEN%"

let whitelist = 
  let __gen_4 = emptyRecord () in write __gen_4 "http://login.W.com" true; write __gen_4 "http://apps.W.com" true; write __gen_4 "http://data.W.com" true; __gen_4

val whitelisted : string -> bool
let whitelisted (url : string) : bool =
  let (ret : _val_bool) = { v = false } in
    (foreach (whitelist) (fun (u : string) ->
      if ((String_startsWith (url) (String_concat (u) ("/"))) && (String_noQueryHash (url))) then 
        write ret "v" (true)
      else ()));
    (ret.v)

val authRpc : string -> string -> string -> string
let authRpc (url : string) (apifun : string) (args : string) : string =
  if (whitelisted (url)) then 
    (let (m : _val_any) = { v = {methd = apifun; args = args; token = csrfToken} } in
       let (msg : _val_string) = { v = encode (m.v) } in
         (xhrGet (String_concat (url) (String_concat ("?") (msg.v)))))
  else
    ("unauthorized URL")

val test : unit -> any
let test (x : unit) : any =
  authRpc ("http://login.W.com/") ("f") ("1")


