module Xdproxy

type _val_bool = { v : mutable bool }

type _val_string = { v : mutable string }


val checkOrigin : string -> string -> bool
let checkOrigin (given : string) (expected : string) : bool =
  ((given) = (expected))

val checkOrigins : string -> array string -> bool
let checkOrigins (given : string) (expected : array string) : bool =
  let (aout : _val_bool) = { v = false } in
    (foreach (expected) (fun (k : string) ->
      let (exp : _val_string) = { v = setTag string ((read (expected) (k))) } in
        if ((given) = (exp.v)) then 
          write aout "v" (true)
        else ()));
    (aout.v)

val proxyMessageString : string -> any -> string -> any
let proxyMessageString (host : string) (msg : any) (origin : string) : any =
  if (checkOrigin (host) (origin)) then 
    window_postMessage (msg) (host)
  else
    console_log ("denied")

val proxyMessageArray : string -> any -> array string -> any
let proxyMessageArray (host : string) (msg : any) (origins : array string) : any =
  if (checkOrigins (host) (origins)) then 
    window_postMessage (msg) (host)
  else
    console_log ("denied")

val checkOriginAny : string -> any -> bool
let checkOriginAny (given : string) (expected : any) : bool =
  if ((typeOf (expected)) = ("string")) then 
    (checkOrigin (given) (setTag string (expected)))
  else
    (checkOrigins (given) (setTag (array string) (expected)))

val proxyMessageAny : string -> any -> any -> any
let proxyMessageAny (host : string) (msg : any) (origins : any) : any =
  if (checkOriginAny (host) (origins)) then 
    window_postMessage (msg) (host)
  else
    console_log ("denied")

val test : unit -> any
let test (x : unit) : any =
  proxyMessageString ("honest.com") ("secret") ("honest.com")


