module JSBuiltIns

type PrimVal' =
  | PrimBool' : bool -> PrimVal'
  | PrimFunction' : (PrimVal' -> ST (ref PrimVal' -> ST PrimVal')) -> PrimVal'
  | PrimNull' : PrimVal'
  | PrimNum' : float -> PrimVal'
  | PrimObject' : list string -> PrimVal'
  | PrimString' : string -> PrimVal'
  | PrimUndefined' : PrimVal' 
  | PrimReturn' : PrimVal' -> PrimVal'
  | PrimBreak' : PrimVal' -> PrimVal'

val primToBool': PrimVal' -> ST bool
val primToFunction': PrimVal' -> ST ((PrimVal' -> ST (ref PrimVal' -> ST PrimVal')))
val primToNum' : PrimVal' -> ST float
val primToString' : PrimVal' -> ST string
val jsNewObject' : list (string * PrimVal') -> ST PrimVal'  
val jsGetField': PrimVal' -> ST (PrimVal' -> ST PrimVal')
val jsUpdateField' : PrimVal' -> ST (PrimVal' -> ST (PrimVal' -> ST PrimVal'))

val toNumber' : PrimVal' -> ST PrimVal' 
val toObject' : PrimVal' -> ST PrimVal'         
val toString' : PrimVal' -> ST PrimVal'         

val abstractEquality' : PrimVal' -> ST (PrimVal' -> ST PrimVal')
val addition' : PrimVal' -> ST (PrimVal' -> ST PrimVal')

val global' : ref PrimVal'
(* let global' = (ref(jsNewObject' [])) *)
