#monadic(RDST, iRetTx, bindTx)
module Fresh
open PRF

(* mref 'a 'P    (defined in prims-rrf.fst)
     is a monotonic reference to an 'a with update condition 'P

   MonoBoolT is an update condition for monotonic boolean flags.
*)
val bad : mref bool MonoBoolT

type block = fbytes 16
val sample: unit -> EnsuresUpTo bad block (fun h0 h1 u0 u1 h0' h1' => 
    ((h0=h0')
     && (h1=h1')
     && (u0=u1)
     && not (In u0 (Domain (SelHeap h0 (L log))))))
let sample () =
  let u = randomBytes 16 in
  if mem u (Domain !log) 
  then (mwrite bad true; u)
  else u

(* The probability of Bad is bounded by \sum_{sample} (length S)/2^l, or
   - if length S < N, #sample * L / 2^l
   - if S is the set of previously-fresh values, #sample^2 / 2^{l+1}
 *)


(* type t=fbytes 16 (\* concrete bytes of a fixed size; there are 2^l of them *\) *)
(* type Bad: heap -> heap -> E  *)

(* val sample: s:list t  *)
(*   -> r:t { (In r S ==> Bad)} *)

(* (\* private implementation *\)  *)

(* val bad: ref eq bool *)

(* assume forall h0 h1, Bad h0 h1 <=> (select h0 bad = true) *)

(* let sample 'Safe S =  *)
(*   let r = sample 'Safe  *)
(*   if r in S then bad:= true  *)

