module MixedList
(** mixed-level data structures *) 

type eq 'a = x:'a{| Eq (L x) (R x) |}
type tag = x: eq string { x = "H" || x = "L" }
type index = int
type value = string
type entry = t:tag * i:index * v:value {| L(t) = "L" ==> (L i) = (R i) && (L v) = (R v) |}
type entries = list entry 

logic val Low: entries -> eq entries

assume forall i v es. (Low (("H",i,v)::es)) = (Low es)
assume forall i v es. (Low (("L",i,v)::es)) = ("L",i,v)::(Low es)
assume Low([]) = [] 

let low = function 
  | ("H",_,_)::es -> es
  

(*
let i0 (e:preentry) = e

let empty = ([] : map)

let cons (e:entry) (es:map) = e :: es 

  let x = e 
  empty  
  // e :: es 


(* in this example, we assume that the two lists have the same size *) 

let rec high_assoc (es:mlist) idx = 
  match es with 
    | (t,i,data)::es -> if i = idx then Some(data) else high_assoc es idx
    | []             -> None

let rec low_assoc (es: mlist)  idx = 
  match es with
    | ("public",i,data)::es -> if i = idx then Some(data) else low_assoc es idx
    | _::es                 -> low_assoc es idx
    | []                    -> None

*)
