(* exercise:  [two encryptions by Bellare & Rogaway]

1. Prove that the following scheme is CPA, 
   knowing that f is a OWF (with a trapdoor) and G a RO.

   enc m r = f r | G r + m 

2. Prove that the following scheme is CCA2, 
   under the same assumptioms plus H another RO.

   enc m r = f r | G r + m | H (r | m)

3. Show that this works for any CPA algorithm (?)

*)


module OWF (* one-way function *)

(* there is a hidden key *)

type repr 
type random (* abstract to specify one-wayness *)

val r 
type challenge 

predicate Bad (* stateful? *)
logic function F: input -> challenge 

val f: i:input -> c:(;i) challenge { c = F(i) }

val guess: i:input -> (;i) challenge -> c:repr -> unit { c = F(i) => Bad } 

(* security assumption: Bad is negligible *)


module RO (* random oracle with disjoint domains up to bad *)

(* in our case, we need just an instance: *)

val hashE: i { i=r }  -> m:msg -> g:hash{ xor (L g) (L m) = xor (R g) (R m) }
val hashA: i { i=r => Bad } -> m:msg -> g:hash{ (L g) = (R g) || Bad }

module Enc

val enc: m:{

let enc m r = fE r | xor (hE r) m 


