module SQL 

(* fully spec'ed map; we need the same for fold *) 
type nat = i:int{i >= 0}
logic val Nth: list 'a -> nat -> option 'a
assume Nth_hd: forall (hd:'a) (tl:list 'a). Nth (hd::tl) 0 = Some hd
assume Nth_tl: forall (hd:'a) (tl:list 'a) i. i > 0 ==> Nth (hd::tl) i = Nth tl (i - 1)
assume Nt_nil: forall i. Nth [] i = None

(* logic val Map: ('a -> 'b) -> list 'a -> list 'b  *)
(* assume MapNil : forall lF. Map lF [] = [] *)
(* assume MapCons: forall lF x xs. Map lF (x::xs) = ((lF x):: (Map lF xs)) *)
(* type Map :: _ = fun ('a::*\) ('b::*\) ('Q::'a => 'b => E) (l:list 'a) (m:list 'b) =>  *)
(* type Map :: _ = fun ('a::*\) ('b::*\) ('Q::'a => 'b => E) (l:list 'a) (m:list 'b) =>  *)
(*     ((l=[]) && (m=[]) *)


(* with no pre-condition for the function argument *)
val map: 
     'a::* 
  -> 'b::*
  -> (x:'a -> y:'b{'Q x y})
  -> l:list 'a
  -> m:list 'b{forall i. Some_is (Nth l i) ==> 'Q (Some_proj_1 (nth l i)) (Some_proj_1 (nth m i))}

(* val map:  *)
(*   lF: ('a -> 'b) ->  *)
(*   f:(x:'a -> y:'b { y = lF x } ) ->  *)
(*   xs: list 'a -> ys: list 'b { ys = Map lF xs } *)

let rec map f l = match l with 
  | [] -> []
  | hd::tl -> f hd::(map f tl)
