
module TestRRF

type eq 'a = x:'a{| Eq (L x) (R x) |}

(*
 L x + L y = R x + R y ==> 
 plus (L x) (L y) = plus (R x) (R y)
 
*)
val plus: x:int -> y:int{| Eq ((L x) + (L y)) ((R x) + (R y)) |} -> eq int
let plus x y = x - (-y)

val minus: x:int -> y:int{| Eq ((L x) - (L y)) ((R x) - (R y)) |} -> eq int
let minus x y = x + (-y)

type low = eq int

(* let leak (x:int) (y:low) : low = x + y *)

let f1 (x:low) : low  = x + 1

val f2: x:low -> y:int -> (low * int)
let f2 x y =
  let u = x in
    (u,x+y)

val f3: x:int -> y:int{| Eq ((L x) + (L y)) ((R x) + (R y)) |} -> eq int
let f3 x y = x - (-y)

val f4: low -> low -> low
let f4 x y = 3 * x + y

type Corrupt :: string => E
type secret 't (a:string) = (x:'t{| Corrupt (L a) ==> ((L x) = (R x)) |})

val f5: eve:eq string{| Corrupt (L eve) |} -> x:secret int eve -> (y:low { y = x })
let f5 eve x = x

(*$ todo: turn monadic
val r: ref low
let r = ref 0
let write r (x:low) = r:= x
let add (x:low) = write r (read r + x)
 *)

(** mixed-level data structures *)

(* type tag = eq string *)
(* type index = int *)
(* type value = string *)
(* type preentry = tag * index * value *)
(* type entry = preentry *)
(* type mlist = list preentry *)

(* type tag = eq string  *)
(* type index = int  *)
(* type value = string *)

(* (\* // low list of low ints? *\) *)
(* (\* // high list of low ints? *\) *)
(* (\* // high list of high ints? *\) *)
(* (\* // intent: the list have the same structure. *\) *)

(* (\* // entries consist of a security label ("public" or not), an index, and a value *\) *)

(* type preentry = tag * index * value *)

(* (\* //definition !tag,index,data.  (\\* language variables *\\) *\) *)
(* (\* //  Entry(tag,index,data) <=>   *\) *)
(* (\* //  ( L(tag) = R(tag) /\ (L(tag) = L("public") => (L(index) = R(index) /\ L(value) = R(value)))) *\) *)

(* (\* predicate val I: preentry list * preentry list -> bool  *\) *)
(* type I :: list preentry => list preentry => E *)

(* (\* I also tried a more permissive definition, enabling different secret cons *\) *)
(* (\* // definition !x0,x1. I(x0,x1) <=>  *\) *)
(* (\* //   ( (       x0 = [] /\ x1 = []) \/ *\) *)
(* (\* ////    ( ?e,y. x0 = e::y /\ I(y,x1) ) \/  *\) *)
(* (\* ////    ( ?e,y. x1 = e::y /\ I(x0,y) ) \/  *\) *)
(* (\* // //    ( ?i,s,y0,y1. x0 = ("public",i,s)::y0 /\ x1 = ("public",i,s)::y1 /\ I(y0,y1) ) *\) *)
(* (\* //  ( ?t0,t1,i0,i1,s0,s1,y0,y1.  *\) *)
(* (\* //      x0 = (t0,i0,s0)::y0 /\  *\) *)
(* (\* //      x1 = (t1,i1,s1)::y1 /\  *\) *)
(* (\* //      ( (t0 = "public" \/ t1 = "public") => (t0=t1 /\ i0=i1 /\ s0=s1 ) ) /\ *\) *)
(* (\* //      I(y0,y1) )) *\) *)

(* (\* assume L([]) = [] /\ R([]) = [] *\) *)

(* assume I_nil: (I [] []) *)
(* assume I_cons: forall t i0 i1 s0 s1 y0 y1. *)
(*      (I ((t,i0,s0)::y0) ((t,i1,s1)::y1) ) *)
(*   <==>  *)
(*      ((I y0 y1) && (t = "public" ==> (i0=i1 && s0=s1))) *)

(* (\* type entry = (t:tag * i:index * s:value{ (L t) = "public" ==> ((L i)=(R i) && (L s)=(R s)) }) *\) *)
(* (\* type mlist = es: list entry{ I (L es) (R es) } *\) *)

(* (\* let i0 (e:preentry) = e *\) *)

(* (\* let empty = ([] : mlist) *\) *)
(* (\* let insert (es:mlist) (e:entry) : mlist =  *\) *)
(* (\*   let x = e in *\) *)
(* (\*     empty   *\) *)
(* (\*   (\\* // e :: es  *\\) *\) *)


(* (\* let rec high_assoc (es:mlist) idx =  *\) *)
(* (\*   match es with  *\) *)
(* (\*     | (t,i,data)::es -> if i = idx then Some(data) else high_assoc es idx *\) *)
(* (\*     | []             -> None *\) *)

(* (\* let rec low_assoc (es: mlist)  idx =  *\) *)
(* (\*   match es with *\) *)
(* (\*     | ("public",i,data)::es -> if i = idx then Some(data) else low_assoc es idx *\) *)
(* (\*     | _::es                 -> low_assoc es idx *\) *)
(* (\*     | []                    -> None *\) *)
