#monadic(RDST, iRetTx, bindTx)
module UpToBad

(** This example excludes collisions between guesses and values kept in a log.
    We should add some sampling and keep the log abstract so that "bad" is negligible.

 **)

val log : ref (list int)

(* mref 'a 'P    (defined in prims-rrf.fst)
     is a monotonic reference to an 'a with update condition 'P

   MonoBoolT is an update condition for monotonic boolean flags.
*)
val bad : mref bool MonoBoolT

(* EnsuresUpTo bad t P   (defined in prims-rrf.fst)
     which when run in a pre-state h0 h1, produces results u0 u1 and h0' h1', 
     where P h0 h1 u0 u1 h0' h1' is valid
     unless bad is set (i.e., h0'[bad] = h1'[bad] = true)
*)
val guess : x:eq int -> EnsuresUpTo bad unit (fun h0 h1 u0 u1 h0' h1' => 
    ((h0=h0')
     && (h1=h1')
     && not (In (L x) (SelHeap h0 (L log)))
     && not (In (R x) (SelHeap h1 (R log)))))
let guess x = 
  let l = !log in 
    assume (| L l = R l |); (* to discharge the cross cases *)
    if mem x l 
    then mwrite bad true 
    else ()

end

(*

type nonce = fbytes 16 

val fresh: old: list nonce -> n:nonce { n not in old || bad } 

let fresh old = sample 16 

 *)
