#monadic(DST.DST, DST.returnTX, DST.bindNoExnTX)
module Evens
open DST
open RefSet

type Even :: _ = fun (x:int) => (exists (n:int). Eq x (2*n))

type evens_t ('Inv::heap => E) (fp:refset) = 
    Writer int (Requires (fun h => (On fp 'Inv h)))
               (Ensures _ (fun h u h' => (Even u && On fp 'Inv h')))
               (Modifies fp)
    
logic data type t = 
  | Evens : 'Inv::heap => E
          -> fp:refset (* ghost *)
          -> (unit -> evens_t 'Inv fp)
          -> t

type Inv1 :: ref int => ref int => heap => E
assume Inv1_def: forall r1 r2 h. (Inv1 r1 r2 h 
                                  <==> 
                                  (Perm r1 h && Perm r2 h && (SelHeap h r1 = SelHeap h r2)))


val create1: u:unit -> Writer t TrivialPre 
                              (Ensures _ (fun h v h' => 
                                   (On  (Evens_proj_1 v) (Evens_proj_0 v) h'
                                    && Fresh h (Evens_proj_1 v))))
                              (Modifies EmptySet)
let create1 (u:unit) = 
  let x = ref (0:int) in 
  let y = ref (0:int) in 
  let fp = Union (Singleton x) (Singleton y) in 
  let evens (u:unit) : evens_t (Inv1 x y) fp =
    let rx = !x in
    let ry = !y in
    let _ = x := (rx + 1) in
    let _ = y := (ry + 1) in
      rx + ry in
    Evens<Inv1 x y> fp evens
    

type Inv2 :: ref int => heap => E
assume Inv2_def: forall r h. (Inv2 r h <==> Perm r h)
val create2: u:unit -> Writer t TrivialPre 
                              (Ensures _ (fun h v h' => 
                                   (On  (Evens_proj_1 v) (Evens_proj_0 v) h'
                                    && Fresh h (Evens_proj_1 v))))
                              (Modifies EmptySet)
let create2 (u:unit) = 
  let x = ref 0 in
  let fp = Singleton x in
  let evens (u:unit) : evens_t (Inv2 x) fp =
    let rx = !x in
    let _ = x := (rx + 1) in
      2 * rx in
    Evens<Inv2 x> fp evens
    
