module Prims
type unit
type any 
type bool
type number
type string
type mutable : S => S
type NTuple =
  | Tuple_UU : 'a -> 'b -> ('a * 'b)

type option 'a =
  | None : option 'a
  | Some : 'a -> option 'a

type either 'a 'b =
  | Inl : 'a -> either 'a 'b
  | Inr : 'b -> either 'a 'b

type list 'a =
  | Nil : list 'a
  | Cons : 'a -> list 'a -> list 'a

type array: S => S
val newArray: 'a -> unit -> array 'a
val readArray: array 'a -> number -> 'a
val writeArray: array 'a -> number -> 'a -> unit

val setTag: 'a:S -> any -> 'a
val canTag: 'a:S -> any -> bool
val isTag: 'a:S -> any -> bool
val wrap: 'a:S -> any -> 'a
val canWrap: 'a:S -> any -> bool
val typeOf: any -> string

val emptyRecord: unit -> any

val read: any -> string -> any
val write: any -> string -> any -> unit

val foreach: any -> (string -> any) -> any

val String_concat: string -> string -> string
val String_split: string -> string -> any
val String_startsWith: string -> string -> bool
val String_noQueryHash: string -> bool

val window_postMessage: any -> any -> any
val console_log: string -> any

val op_Equality : 'a -> 'a -> bool
val _dummy_op_ColonEquals        : any -> any -> unit
(* Primitive numeric functions *)
val _dummy_op_AmpAmp             : x:bool -> y:bool -> bool 
val _dummy_op_BarBar             : x:bool -> y:bool -> bool
val _dummy_op_Negation           : x:bool -> bool
val _dummy_op_Multiply           : x:number -> y:number -> number
val _dummy_op_Division           : x:number -> y:number -> number
val _dummy_op_Subtraction        : x:number -> y:number -> number
val _dummy_op_Addition           : x:number -> y:number -> number
val _dummy_op_Minus              : x:number -> number
val _dummy_op_Modulus            : x:number -> y:number -> number
val _dummy_op_GreaterThanOrEqual : x:number -> y:number -> bool
val _dummy_op_LessThanOrEqual    : x:number -> y:number -> bool
val _dummy_op_GreaterThan        : x:number -> y:number -> bool
val _dummy_op_LessThan           : x:number -> y:number -> bool
