﻿// See LICENSE-js2ml.txt for terms and conditions
// (c) Joel Weinberger 2012. All rights reserved.

module Common

type id = string

(* we track the start and end position of each syntactic form. *)
type pos = Microsoft.FStar.Range.range
val posToString : pos -> string

val dummy_pos : pos

val iota : int -> int list

val fst : 'a * 'b -> 'a
val snd : 'a * 'b -> 'b
val fst3 : 'a * 'b * 'c -> 'a
val snd3 : 'a * 'b * 'c -> 'b
val third3 : 'a * 'b * 'c -> 'c

val TEMPVAR_ID : id
val TEMPOBJ_ID : id

val dom_functions : Set<id>
val isDomFunction : id -> bool
