// (c) Microsoft Corporation. All rights reserved

module Microsoft.FStar.Tc

open Absyn
open Tcenv

val well_formed_kind: Range.range -> env -> kind -> kind
(* Returns the typ annotated withinfo and the kind synthesized for it *)
val kinding: env -> typ -> (typ * kind)

(* This implements the core source typing from FStar_Typing.v, 
   interleaved with a simple HM type inference algorithm *)
val typing_record : Range.range -> env -> (fieldname * typ * exp option) list 
                -> (lident * typ list * exp list * typ * (fieldname * typ * exp option) list)    
val typing: env -> exp -> (exp * typ * list<bvvar>)

val check_sigelt : env -> (sigelt -> sigelt)
val check_signature: env -> signature -> (env * signature)
  
(* This is the real external interface. 
   Takes a desugared modul and produces a typed, derefined 
   modul ready to be translated to DMSIL *)
val typing_modul: env -> modul -> option<modul>

