// Implementation file for parser generated by fsyacc
module Microsoft.FStar.ParseFStar
#nowarn "64";; // turn off warnings that type variables used in production annotations are instantiated to concrete type
open Microsoft.FSharp.Text.Lexing
open Microsoft.FSharp.Text.Parsing.ParseHelpers
# 1 "parser/parsefstar.fsy"

#light "off"
(*
 Known (intentional) ambiguitites:
   2 s/r conflicts on BAR
      match  with | P -> match with | Q -> _ | R -> _
      function ...

   1 s/r conflict on STAR (unclear exactly why)

   1 r/r conflict on STAR
     (x:t{P} * t')  can also be reduced as ((x:t{P}) * t')

   1 s/r conflict on SEMICOLON
       e1 . ; e2
  
   (* 4 s/r conflicts on SEMICOLON *)
   (*     -- if e then e';e'' *)
   (*     -- let x = e in e';e'' *)
   (*     -- fun x -> e;e *)
   (*     -- match x with | P -> e;e' *)
*)
// (c) Microsoft Corporation. All rights reserved
open Microsoft.FSharp.Compatibility
open Microsoft.FSharp.Compatibility.OCaml.Pervasives
open Microsoft.FSharp.Text.Parsing
open System
open Microsoft.FStar
open Microsoft.FStar.Util
open Microsoft.FStar.Range
open Microsoft.FStar.Sugar
open Microsoft.FStar.Const
open Microsoft.FStar.ParseAST

let consPat r hd tl = PatApp(pattern (PatName Const.cons_lid) r, [hd;tl])

let consTerm r hd tl = term (Construct(Const.cons_lid, [hd;tl])) r Expr

let mkConsList r elts = 
  let nil = term (Construct(Const.nil_lid, [])) r Expr in
    List.fold_right (fun e tl -> consTerm r e tl) elts nil
  
let mkApp t args r = match args with 
  | [] -> t 
  | _ -> match t.term with 
      | Name s -> term (Construct(s, args)) r Un
      | _ -> List.fold_left (fun t a -> term (App(t, a)) r Un) t args
          
let mkTuple t1 t2 r = term (Op("Tuple", [t1;t2])) r Expr

let mkRefinedBinder id t refopt m = 
  let b = binder (Annotated(id, t)) m Type in
  match refopt with 
    | None -> b 
    | Some t -> binder (Annotated(id, term (Refine(b, t)) m Type)) m Type


# 64 "parser\parsefstar.fs"
// This type is the type of tokens accepted by the parser
type token = 
  | COMMENT of (Sugar.lexcont)
  | WHITESPACE of (Sugar.lexcont)
  | HASH_LINE of (Sugar.lexcont)
  | HASH_LIGHT of (Sugar.lexcont)
  | HASH_IF of (Sugar.lexcont)
  | HASH_ELSE of (Sugar.lexcont)
  | HASH_ENDIF of (Sugar.lexcont)
  | INACTIVECODE of (Sugar.lexcont)
  | LINE_COMMENT of (Sugar.lexcont)
  | STRING_TEXT of (Sugar.lexcont)
  | EOF of (Sugar.lexcont)
  | LEX_FAILURE of (string)
  | EXTERN
  | REFERENCE
  | VOID
  | PUBLIC
  | PRIVATE
  | INTERNAL
  | LBRACE_COLON_PATTERN
  | STATIC
  | MEMBER
  | CLASS
  | VIRTUAL
  | ABSTRACT
  | OVERRIDE
  | DEFAULT
  | CONSTRUCTOR
  | INHERIT
  | GREATER_RBRACK
  | STRUCT
  | SIG
  | BAR
  | RBRACK
  | RBRACE
  | MINUS
  | DOLLAR
  | LBRACE_LESS
  | BAR_RBRACK
  | GREATER_RBRACE
  | UNDERSCORE
  | BANG
  | SEMICOLON_SEMICOLON
  | LARROW
  | EQUALS
  | LBRACK
  | LBRACK_BAR
  | LBRACK_LESS
  | LBRACE
  | BACKSLASH
  | QMARK
  | QMARK_QMARK
  | DOT
  | COLON
  | COLON_COLON
  | ATSIGN
  | COLON_GREATER
  | COLON_QMARK_GREATER
  | COLON_QMARK
  | COLON_EQUALS
  | SEMICOLON
  | GREATER_DOT
  | GREATER_BAR_RBRACK
  | LPAREN_STAR_RPAREN
  | IFF
  | IMPLIES
  | CONJUNCTION
  | DISJUNCTION
  | WHEN
  | WHILE
  | WITH
  | HASH
  | AMP
  | AMP_AMP
  | QUOTE
  | LPAREN
  | RPAREN
  | LPAREN_RPAREN
  | STAR
  | COMMA
  | RARROW
  | RARROW2
  | RRARROW
  | OPEN
  | OR
  | PROP
  | REC
  | THEN
  | TO
  | TRUE
  | TRY
  | TYPE
  | VAL
  | INLINE
  | INTERFACE
  | INSTANCE
  | LAZY
  | MATCH
  | METHOD
  | MUTABLE
  | NEW
  | OF
  | EXCEPTION
  | FALSE
  | FOR
  | FUN
  | FUNCTION
  | IF
  | IN
  | FINALLY
  | DO_BANG
  | AND
  | AS
  | ASSERT
  | ASR
  | BEGIN
  | DO
  | DONE
  | DOWNTO
  | ELSE
  | ELIF
  | END
  | DOT_DOT
  | BAR_BAR
  | LEQ
  | GEQ
  | LESS
  | GREATER
  | LESSGREATER
  | GREATERGREATER
  | UPCAST
  | DOWNCAST
  | NULL
  | RESERVED
  | MODULE
  | DELEGATE
  | CONSTRAINT
  | BASE
  | SUBTYPE
  | SUBKIND
  | FORALL
  | EXISTS
  | ASSUME
  | QUERY
  | DEFINE
  | LOGIC
  | PRAGMAMONADIC
  | PRAGMADYNAMIC
  | LQUOTE of (string * bool)
  | RQUOTE of (string * bool)
  | SPLICE_SYMBOL of (string)
  | PERCENT_OP of (string)
  | BINDER of (string)
  | LET of (bool)
  | YIELD of (bool)
  | YIELD_BANG of (bool)
  | BIGINT of (byte[])
  | BIGNUM of (byte[])
  | DECIMAL of (System.Decimal)
  | CHAR of (char)
  | IEEE64 of (double)
  | IEEE32 of (single)
  | NATIVEINT of (int64)
  | UNATIVEINT of (uint64)
  | UINT64 of (uint64)
  | UINT32 of (uint32)
  | UINT16 of (uint16)
  | UINT8 of (byte)
  | INT64 of (int64 * bool)
  | INT32 of (int32 * bool)
  | INT32_DOT_DOT of (int32 * bool)
  | INT16 of (int16 * bool)
  | INT8 of (sbyte * bool)
  | FUNKY_OPERATOR_NAME of (string)
  | ADJACENT_PREFIX_PLUS_MINUS_OP of (string)
  | PLUS_MINUS_OP of (string)
  | INFIX_AMP_OP of (string)
  | INFIX_STAR_DIV_MOD_OP of (string)
  | DIV_MOD_OP of (string)
  | PREFIX_OP of (string)
  | INFIX_BAR_OP of (string)
  | INFIX_AT_HAT_OP of (string)
  | INFIX_COMPARE_OP of (string)
  | INFIX_STAR_STAR_OP of (string)
  | LANG of (string)
  | BASEKIND of (string)
  | TVAR of (string)
  | NAME of (string)
  | IDENT of (string)
  | STRING of (byte[])
  | BYTEARRAY of (byte[])
// This type is used to give symbolic names to token indexes, useful for error messages
type tokenId = 
    | TOKEN_COMMENT
    | TOKEN_WHITESPACE
    | TOKEN_HASH_LINE
    | TOKEN_HASH_LIGHT
    | TOKEN_HASH_IF
    | TOKEN_HASH_ELSE
    | TOKEN_HASH_ENDIF
    | TOKEN_INACTIVECODE
    | TOKEN_LINE_COMMENT
    | TOKEN_STRING_TEXT
    | TOKEN_EOF
    | TOKEN_LEX_FAILURE
    | TOKEN_EXTERN
    | TOKEN_REFERENCE
    | TOKEN_VOID
    | TOKEN_PUBLIC
    | TOKEN_PRIVATE
    | TOKEN_INTERNAL
    | TOKEN_LBRACE_COLON_PATTERN
    | TOKEN_STATIC
    | TOKEN_MEMBER
    | TOKEN_CLASS
    | TOKEN_VIRTUAL
    | TOKEN_ABSTRACT
    | TOKEN_OVERRIDE
    | TOKEN_DEFAULT
    | TOKEN_CONSTRUCTOR
    | TOKEN_INHERIT
    | TOKEN_GREATER_RBRACK
    | TOKEN_STRUCT
    | TOKEN_SIG
    | TOKEN_BAR
    | TOKEN_RBRACK
    | TOKEN_RBRACE
    | TOKEN_MINUS
    | TOKEN_DOLLAR
    | TOKEN_LBRACE_LESS
    | TOKEN_BAR_RBRACK
    | TOKEN_GREATER_RBRACE
    | TOKEN_UNDERSCORE
    | TOKEN_BANG
    | TOKEN_SEMICOLON_SEMICOLON
    | TOKEN_LARROW
    | TOKEN_EQUALS
    | TOKEN_LBRACK
    | TOKEN_LBRACK_BAR
    | TOKEN_LBRACK_LESS
    | TOKEN_LBRACE
    | TOKEN_BACKSLASH
    | TOKEN_QMARK
    | TOKEN_QMARK_QMARK
    | TOKEN_DOT
    | TOKEN_COLON
    | TOKEN_COLON_COLON
    | TOKEN_ATSIGN
    | TOKEN_COLON_GREATER
    | TOKEN_COLON_QMARK_GREATER
    | TOKEN_COLON_QMARK
    | TOKEN_COLON_EQUALS
    | TOKEN_SEMICOLON
    | TOKEN_GREATER_DOT
    | TOKEN_GREATER_BAR_RBRACK
    | TOKEN_LPAREN_STAR_RPAREN
    | TOKEN_IFF
    | TOKEN_IMPLIES
    | TOKEN_CONJUNCTION
    | TOKEN_DISJUNCTION
    | TOKEN_WHEN
    | TOKEN_WHILE
    | TOKEN_WITH
    | TOKEN_HASH
    | TOKEN_AMP
    | TOKEN_AMP_AMP
    | TOKEN_QUOTE
    | TOKEN_LPAREN
    | TOKEN_RPAREN
    | TOKEN_LPAREN_RPAREN
    | TOKEN_STAR
    | TOKEN_COMMA
    | TOKEN_RARROW
    | TOKEN_RARROW2
    | TOKEN_RRARROW
    | TOKEN_OPEN
    | TOKEN_OR
    | TOKEN_PROP
    | TOKEN_REC
    | TOKEN_THEN
    | TOKEN_TO
    | TOKEN_TRUE
    | TOKEN_TRY
    | TOKEN_TYPE
    | TOKEN_VAL
    | TOKEN_INLINE
    | TOKEN_INTERFACE
    | TOKEN_INSTANCE
    | TOKEN_LAZY
    | TOKEN_MATCH
    | TOKEN_METHOD
    | TOKEN_MUTABLE
    | TOKEN_NEW
    | TOKEN_OF
    | TOKEN_EXCEPTION
    | TOKEN_FALSE
    | TOKEN_FOR
    | TOKEN_FUN
    | TOKEN_FUNCTION
    | TOKEN_IF
    | TOKEN_IN
    | TOKEN_FINALLY
    | TOKEN_DO_BANG
    | TOKEN_AND
    | TOKEN_AS
    | TOKEN_ASSERT
    | TOKEN_ASR
    | TOKEN_BEGIN
    | TOKEN_DO
    | TOKEN_DONE
    | TOKEN_DOWNTO
    | TOKEN_ELSE
    | TOKEN_ELIF
    | TOKEN_END
    | TOKEN_DOT_DOT
    | TOKEN_BAR_BAR
    | TOKEN_LEQ
    | TOKEN_GEQ
    | TOKEN_LESS
    | TOKEN_GREATER
    | TOKEN_LESSGREATER
    | TOKEN_GREATERGREATER
    | TOKEN_UPCAST
    | TOKEN_DOWNCAST
    | TOKEN_NULL
    | TOKEN_RESERVED
    | TOKEN_MODULE
    | TOKEN_DELEGATE
    | TOKEN_CONSTRAINT
    | TOKEN_BASE
    | TOKEN_SUBTYPE
    | TOKEN_SUBKIND
    | TOKEN_FORALL
    | TOKEN_EXISTS
    | TOKEN_ASSUME
    | TOKEN_QUERY
    | TOKEN_DEFINE
    | TOKEN_LOGIC
    | TOKEN_PRAGMAMONADIC
    | TOKEN_PRAGMADYNAMIC
    | TOKEN_LQUOTE
    | TOKEN_RQUOTE
    | TOKEN_SPLICE_SYMBOL
    | TOKEN_PERCENT_OP
    | TOKEN_BINDER
    | TOKEN_LET
    | TOKEN_YIELD
    | TOKEN_YIELD_BANG
    | TOKEN_BIGINT
    | TOKEN_BIGNUM
    | TOKEN_DECIMAL
    | TOKEN_CHAR
    | TOKEN_IEEE64
    | TOKEN_IEEE32
    | TOKEN_NATIVEINT
    | TOKEN_UNATIVEINT
    | TOKEN_UINT64
    | TOKEN_UINT32
    | TOKEN_UINT16
    | TOKEN_UINT8
    | TOKEN_INT64
    | TOKEN_INT32
    | TOKEN_INT32_DOT_DOT
    | TOKEN_INT16
    | TOKEN_INT8
    | TOKEN_FUNKY_OPERATOR_NAME
    | TOKEN_ADJACENT_PREFIX_PLUS_MINUS_OP
    | TOKEN_PLUS_MINUS_OP
    | TOKEN_INFIX_AMP_OP
    | TOKEN_INFIX_STAR_DIV_MOD_OP
    | TOKEN_DIV_MOD_OP
    | TOKEN_PREFIX_OP
    | TOKEN_INFIX_BAR_OP
    | TOKEN_INFIX_AT_HAT_OP
    | TOKEN_INFIX_COMPARE_OP
    | TOKEN_INFIX_STAR_STAR_OP
    | TOKEN_LANG
    | TOKEN_BASEKIND
    | TOKEN_TVAR
    | TOKEN_NAME
    | TOKEN_IDENT
    | TOKEN_STRING
    | TOKEN_BYTEARRAY
    | TOKEN_end_of_input
    | TOKEN_error
// This type is used to give symbolic names to token indexes, useful for error messages
type nonTerminalId = 
    | NONTERM__startfile
    | NONTERM_file
    | NONTERM_moduleList
    | NONTERM_modul
    | NONTERM_endopt
    | NONTERM_pragmas
    | NONTERM_pragma
    | NONTERM_decls
    | NONTERM_decl
    | NONTERM_decl'
    | NONTERM_valQuals
    | NONTERM_erefDefn
    | NONTERM_erefFields
    | NONTERM_logicTag
    | NONTERM_assumeTag
    | NONTERM_tycon
    | NONTERM_tyconDefinition
    | NONTERM_tyconDefinitions
    | NONTERM_tyconQuals
    | NONTERM_logicArrayArgs
    | NONTERM_recopt
    | NONTERM_letbindings
    | NONTERM_letbinding
    | NONTERM_pattern
    | NONTERM_appPattern
    | NONTERM_listPattern
    | NONTERM_consPattern
    | NONTERM_tuplePattern
    | NONTERM_compositePattern
    | NONTERM_atomicPatterns
    | NONTERM_atomicPattern
    | NONTERM_atomicPattern'
    | NONTERM_nonTvarPattern
    | NONTERM_nonTvarPattern'
    | NONTERM_ascriptionOrPattern
    | NONTERM_maybeAscribeKind
    | NONTERM_patternListSemiColon
    | NONTERM_patternListComma
    | NONTERM_recordPattern
    | NONTERM_binder
    | NONTERM_binders
    | NONTERM_tyconDefn
    | NONTERM_recordFields
    | NONTERM_constructors
    | NONTERM_recordFieldDecl
    | NONTERM_constructorDecl
    | NONTERM_eitherQname
    | NONTERM_eitherQname'
    | NONTERM_lid
    | NONTERM_qname
    | NONTERM_eitherName
    | NONTERM_ident
    | NONTERM_name
    | NONTERM_tvar
    | NONTERM_namepath
    | NONTERM_idpath
    | NONTERM_ascribeTypOpt
    | NONTERM_ascribeKindOpt
    | NONTERM_kind
    | NONTERM_atomicKind
    | NONTERM_typ
    | NONTERM_term
    | NONTERM_noSeqTerm
    | NONTERM_qpat
    | NONTERM_morePats
    | NONTERM_simpleTerm
    | NONTERM_patternBranches
    | NONTERM_patternBranch
    | NONTERM_funArrow
    | NONTERM_tmIff
    | NONTERM_tmImplies
    | NONTERM_tmDisjunction
    | NONTERM_tmConjunction
    | NONTERM_tmTuple
    | NONTERM_tmEq
    | NONTERM_tmCons
    | NONTERM_tmOr
    | NONTERM_tmAnd
    | NONTERM_cmpTerm
    | NONTERM_comparisonOp
    | NONTERM_arithTerm
    | NONTERM_starDivModTerm
    | NONTERM_sumType
    | NONTERM_product'
    | NONTERM_prodArrow
    | NONTERM_sumTypeTail
    | NONTERM_product
    | NONTERM_productOrSumDomain
    | NONTERM_refineOpt
    | NONTERM_refinementTerm
    | NONTERM_unaryOpTerm
    | NONTERM_appTerm
    | NONTERM_formula
    | NONTERM_atomicTerm
    | NONTERM_maybeFieldProjections
    | NONTERM_projectionLHS
    | NONTERM_projection
    | NONTERM_semiColonTermList
    | NONTERM_moreSemiColonTerms
    | NONTERM_recordExp
    | NONTERM_recordExpRest
    | NONTERM_recordFieldAssignment
    | NONTERM_recordFieldAssignments
    | NONTERM_maybeWithSort
    | NONTERM_hasSort
    | NONTERM_atomicTerms
    | NONTERM_consTerm
    | NONTERM_tupleTerm
    | NONTERM_constant

// This function maps tokens to integers indexes
let tagOfToken (t:token) = 
  match t with
  | COMMENT _ -> 0 
  | WHITESPACE _ -> 1 
  | HASH_LINE _ -> 2 
  | HASH_LIGHT _ -> 3 
  | HASH_IF _ -> 4 
  | HASH_ELSE _ -> 5 
  | HASH_ENDIF _ -> 6 
  | INACTIVECODE _ -> 7 
  | LINE_COMMENT _ -> 8 
  | STRING_TEXT _ -> 9 
  | EOF _ -> 10 
  | LEX_FAILURE _ -> 11 
  | EXTERN  -> 12 
  | REFERENCE  -> 13 
  | VOID  -> 14 
  | PUBLIC  -> 15 
  | PRIVATE  -> 16 
  | INTERNAL  -> 17 
  | LBRACE_COLON_PATTERN  -> 18 
  | STATIC  -> 19 
  | MEMBER  -> 20 
  | CLASS  -> 21 
  | VIRTUAL  -> 22 
  | ABSTRACT  -> 23 
  | OVERRIDE  -> 24 
  | DEFAULT  -> 25 
  | CONSTRUCTOR  -> 26 
  | INHERIT  -> 27 
  | GREATER_RBRACK  -> 28 
  | STRUCT  -> 29 
  | SIG  -> 30 
  | BAR  -> 31 
  | RBRACK  -> 32 
  | RBRACE  -> 33 
  | MINUS  -> 34 
  | DOLLAR  -> 35 
  | LBRACE_LESS  -> 36 
  | BAR_RBRACK  -> 37 
  | GREATER_RBRACE  -> 38 
  | UNDERSCORE  -> 39 
  | BANG  -> 40 
  | SEMICOLON_SEMICOLON  -> 41 
  | LARROW  -> 42 
  | EQUALS  -> 43 
  | LBRACK  -> 44 
  | LBRACK_BAR  -> 45 
  | LBRACK_LESS  -> 46 
  | LBRACE  -> 47 
  | BACKSLASH  -> 48 
  | QMARK  -> 49 
  | QMARK_QMARK  -> 50 
  | DOT  -> 51 
  | COLON  -> 52 
  | COLON_COLON  -> 53 
  | ATSIGN  -> 54 
  | COLON_GREATER  -> 55 
  | COLON_QMARK_GREATER  -> 56 
  | COLON_QMARK  -> 57 
  | COLON_EQUALS  -> 58 
  | SEMICOLON  -> 59 
  | GREATER_DOT  -> 60 
  | GREATER_BAR_RBRACK  -> 61 
  | LPAREN_STAR_RPAREN  -> 62 
  | IFF  -> 63 
  | IMPLIES  -> 64 
  | CONJUNCTION  -> 65 
  | DISJUNCTION  -> 66 
  | WHEN  -> 67 
  | WHILE  -> 68 
  | WITH  -> 69 
  | HASH  -> 70 
  | AMP  -> 71 
  | AMP_AMP  -> 72 
  | QUOTE  -> 73 
  | LPAREN  -> 74 
  | RPAREN  -> 75 
  | LPAREN_RPAREN  -> 76 
  | STAR  -> 77 
  | COMMA  -> 78 
  | RARROW  -> 79 
  | RARROW2  -> 80 
  | RRARROW  -> 81 
  | OPEN  -> 82 
  | OR  -> 83 
  | PROP  -> 84 
  | REC  -> 85 
  | THEN  -> 86 
  | TO  -> 87 
  | TRUE  -> 88 
  | TRY  -> 89 
  | TYPE  -> 90 
  | VAL  -> 91 
  | INLINE  -> 92 
  | INTERFACE  -> 93 
  | INSTANCE  -> 94 
  | LAZY  -> 95 
  | MATCH  -> 96 
  | METHOD  -> 97 
  | MUTABLE  -> 98 
  | NEW  -> 99 
  | OF  -> 100 
  | EXCEPTION  -> 101 
  | FALSE  -> 102 
  | FOR  -> 103 
  | FUN  -> 104 
  | FUNCTION  -> 105 
  | IF  -> 106 
  | IN  -> 107 
  | FINALLY  -> 108 
  | DO_BANG  -> 109 
  | AND  -> 110 
  | AS  -> 111 
  | ASSERT  -> 112 
  | ASR  -> 113 
  | BEGIN  -> 114 
  | DO  -> 115 
  | DONE  -> 116 
  | DOWNTO  -> 117 
  | ELSE  -> 118 
  | ELIF  -> 119 
  | END  -> 120 
  | DOT_DOT  -> 121 
  | BAR_BAR  -> 122 
  | LEQ  -> 123 
  | GEQ  -> 124 
  | LESS  -> 125 
  | GREATER  -> 126 
  | LESSGREATER  -> 127 
  | GREATERGREATER  -> 128 
  | UPCAST  -> 129 
  | DOWNCAST  -> 130 
  | NULL  -> 131 
  | RESERVED  -> 132 
  | MODULE  -> 133 
  | DELEGATE  -> 134 
  | CONSTRAINT  -> 135 
  | BASE  -> 136 
  | SUBTYPE  -> 137 
  | SUBKIND  -> 138 
  | FORALL  -> 139 
  | EXISTS  -> 140 
  | ASSUME  -> 141 
  | QUERY  -> 142 
  | DEFINE  -> 143 
  | LOGIC  -> 144 
  | PRAGMAMONADIC  -> 145 
  | PRAGMADYNAMIC  -> 146 
  | LQUOTE _ -> 147 
  | RQUOTE _ -> 148 
  | SPLICE_SYMBOL _ -> 149 
  | PERCENT_OP _ -> 150 
  | BINDER _ -> 151 
  | LET _ -> 152 
  | YIELD _ -> 153 
  | YIELD_BANG _ -> 154 
  | BIGINT _ -> 155 
  | BIGNUM _ -> 156 
  | DECIMAL _ -> 157 
  | CHAR _ -> 158 
  | IEEE64 _ -> 159 
  | IEEE32 _ -> 160 
  | NATIVEINT _ -> 161 
  | UNATIVEINT _ -> 162 
  | UINT64 _ -> 163 
  | UINT32 _ -> 164 
  | UINT16 _ -> 165 
  | UINT8 _ -> 166 
  | INT64 _ -> 167 
  | INT32 _ -> 168 
  | INT32_DOT_DOT _ -> 169 
  | INT16 _ -> 170 
  | INT8 _ -> 171 
  | FUNKY_OPERATOR_NAME _ -> 172 
  | ADJACENT_PREFIX_PLUS_MINUS_OP _ -> 173 
  | PLUS_MINUS_OP _ -> 174 
  | INFIX_AMP_OP _ -> 175 
  | INFIX_STAR_DIV_MOD_OP _ -> 176 
  | DIV_MOD_OP _ -> 177 
  | PREFIX_OP _ -> 178 
  | INFIX_BAR_OP _ -> 179 
  | INFIX_AT_HAT_OP _ -> 180 
  | INFIX_COMPARE_OP _ -> 181 
  | INFIX_STAR_STAR_OP _ -> 182 
  | LANG _ -> 183 
  | BASEKIND _ -> 184 
  | TVAR _ -> 185 
  | NAME _ -> 186 
  | IDENT _ -> 187 
  | STRING _ -> 188 
  | BYTEARRAY _ -> 189 

// This function maps integers indexes to symbolic token ids
let tokenTagToTokenId (tokenIdx:int) = 
  match tokenIdx with
  | 0 -> TOKEN_COMMENT 
  | 1 -> TOKEN_WHITESPACE 
  | 2 -> TOKEN_HASH_LINE 
  | 3 -> TOKEN_HASH_LIGHT 
  | 4 -> TOKEN_HASH_IF 
  | 5 -> TOKEN_HASH_ELSE 
  | 6 -> TOKEN_HASH_ENDIF 
  | 7 -> TOKEN_INACTIVECODE 
  | 8 -> TOKEN_LINE_COMMENT 
  | 9 -> TOKEN_STRING_TEXT 
  | 10 -> TOKEN_EOF 
  | 11 -> TOKEN_LEX_FAILURE 
  | 12 -> TOKEN_EXTERN 
  | 13 -> TOKEN_REFERENCE 
  | 14 -> TOKEN_VOID 
  | 15 -> TOKEN_PUBLIC 
  | 16 -> TOKEN_PRIVATE 
  | 17 -> TOKEN_INTERNAL 
  | 18 -> TOKEN_LBRACE_COLON_PATTERN 
  | 19 -> TOKEN_STATIC 
  | 20 -> TOKEN_MEMBER 
  | 21 -> TOKEN_CLASS 
  | 22 -> TOKEN_VIRTUAL 
  | 23 -> TOKEN_ABSTRACT 
  | 24 -> TOKEN_OVERRIDE 
  | 25 -> TOKEN_DEFAULT 
  | 26 -> TOKEN_CONSTRUCTOR 
  | 27 -> TOKEN_INHERIT 
  | 28 -> TOKEN_GREATER_RBRACK 
  | 29 -> TOKEN_STRUCT 
  | 30 -> TOKEN_SIG 
  | 31 -> TOKEN_BAR 
  | 32 -> TOKEN_RBRACK 
  | 33 -> TOKEN_RBRACE 
  | 34 -> TOKEN_MINUS 
  | 35 -> TOKEN_DOLLAR 
  | 36 -> TOKEN_LBRACE_LESS 
  | 37 -> TOKEN_BAR_RBRACK 
  | 38 -> TOKEN_GREATER_RBRACE 
  | 39 -> TOKEN_UNDERSCORE 
  | 40 -> TOKEN_BANG 
  | 41 -> TOKEN_SEMICOLON_SEMICOLON 
  | 42 -> TOKEN_LARROW 
  | 43 -> TOKEN_EQUALS 
  | 44 -> TOKEN_LBRACK 
  | 45 -> TOKEN_LBRACK_BAR 
  | 46 -> TOKEN_LBRACK_LESS 
  | 47 -> TOKEN_LBRACE 
  | 48 -> TOKEN_BACKSLASH 
  | 49 -> TOKEN_QMARK 
  | 50 -> TOKEN_QMARK_QMARK 
  | 51 -> TOKEN_DOT 
  | 52 -> TOKEN_COLON 
  | 53 -> TOKEN_COLON_COLON 
  | 54 -> TOKEN_ATSIGN 
  | 55 -> TOKEN_COLON_GREATER 
  | 56 -> TOKEN_COLON_QMARK_GREATER 
  | 57 -> TOKEN_COLON_QMARK 
  | 58 -> TOKEN_COLON_EQUALS 
  | 59 -> TOKEN_SEMICOLON 
  | 60 -> TOKEN_GREATER_DOT 
  | 61 -> TOKEN_GREATER_BAR_RBRACK 
  | 62 -> TOKEN_LPAREN_STAR_RPAREN 
  | 63 -> TOKEN_IFF 
  | 64 -> TOKEN_IMPLIES 
  | 65 -> TOKEN_CONJUNCTION 
  | 66 -> TOKEN_DISJUNCTION 
  | 67 -> TOKEN_WHEN 
  | 68 -> TOKEN_WHILE 
  | 69 -> TOKEN_WITH 
  | 70 -> TOKEN_HASH 
  | 71 -> TOKEN_AMP 
  | 72 -> TOKEN_AMP_AMP 
  | 73 -> TOKEN_QUOTE 
  | 74 -> TOKEN_LPAREN 
  | 75 -> TOKEN_RPAREN 
  | 76 -> TOKEN_LPAREN_RPAREN 
  | 77 -> TOKEN_STAR 
  | 78 -> TOKEN_COMMA 
  | 79 -> TOKEN_RARROW 
  | 80 -> TOKEN_RARROW2 
  | 81 -> TOKEN_RRARROW 
  | 82 -> TOKEN_OPEN 
  | 83 -> TOKEN_OR 
  | 84 -> TOKEN_PROP 
  | 85 -> TOKEN_REC 
  | 86 -> TOKEN_THEN 
  | 87 -> TOKEN_TO 
  | 88 -> TOKEN_TRUE 
  | 89 -> TOKEN_TRY 
  | 90 -> TOKEN_TYPE 
  | 91 -> TOKEN_VAL 
  | 92 -> TOKEN_INLINE 
  | 93 -> TOKEN_INTERFACE 
  | 94 -> TOKEN_INSTANCE 
  | 95 -> TOKEN_LAZY 
  | 96 -> TOKEN_MATCH 
  | 97 -> TOKEN_METHOD 
  | 98 -> TOKEN_MUTABLE 
  | 99 -> TOKEN_NEW 
  | 100 -> TOKEN_OF 
  | 101 -> TOKEN_EXCEPTION 
  | 102 -> TOKEN_FALSE 
  | 103 -> TOKEN_FOR 
  | 104 -> TOKEN_FUN 
  | 105 -> TOKEN_FUNCTION 
  | 106 -> TOKEN_IF 
  | 107 -> TOKEN_IN 
  | 108 -> TOKEN_FINALLY 
  | 109 -> TOKEN_DO_BANG 
  | 110 -> TOKEN_AND 
  | 111 -> TOKEN_AS 
  | 112 -> TOKEN_ASSERT 
  | 113 -> TOKEN_ASR 
  | 114 -> TOKEN_BEGIN 
  | 115 -> TOKEN_DO 
  | 116 -> TOKEN_DONE 
  | 117 -> TOKEN_DOWNTO 
  | 118 -> TOKEN_ELSE 
  | 119 -> TOKEN_ELIF 
  | 120 -> TOKEN_END 
  | 121 -> TOKEN_DOT_DOT 
  | 122 -> TOKEN_BAR_BAR 
  | 123 -> TOKEN_LEQ 
  | 124 -> TOKEN_GEQ 
  | 125 -> TOKEN_LESS 
  | 126 -> TOKEN_GREATER 
  | 127 -> TOKEN_LESSGREATER 
  | 128 -> TOKEN_GREATERGREATER 
  | 129 -> TOKEN_UPCAST 
  | 130 -> TOKEN_DOWNCAST 
  | 131 -> TOKEN_NULL 
  | 132 -> TOKEN_RESERVED 
  | 133 -> TOKEN_MODULE 
  | 134 -> TOKEN_DELEGATE 
  | 135 -> TOKEN_CONSTRAINT 
  | 136 -> TOKEN_BASE 
  | 137 -> TOKEN_SUBTYPE 
  | 138 -> TOKEN_SUBKIND 
  | 139 -> TOKEN_FORALL 
  | 140 -> TOKEN_EXISTS 
  | 141 -> TOKEN_ASSUME 
  | 142 -> TOKEN_QUERY 
  | 143 -> TOKEN_DEFINE 
  | 144 -> TOKEN_LOGIC 
  | 145 -> TOKEN_PRAGMAMONADIC 
  | 146 -> TOKEN_PRAGMADYNAMIC 
  | 147 -> TOKEN_LQUOTE 
  | 148 -> TOKEN_RQUOTE 
  | 149 -> TOKEN_SPLICE_SYMBOL 
  | 150 -> TOKEN_PERCENT_OP 
  | 151 -> TOKEN_BINDER 
  | 152 -> TOKEN_LET 
  | 153 -> TOKEN_YIELD 
  | 154 -> TOKEN_YIELD_BANG 
  | 155 -> TOKEN_BIGINT 
  | 156 -> TOKEN_BIGNUM 
  | 157 -> TOKEN_DECIMAL 
  | 158 -> TOKEN_CHAR 
  | 159 -> TOKEN_IEEE64 
  | 160 -> TOKEN_IEEE32 
  | 161 -> TOKEN_NATIVEINT 
  | 162 -> TOKEN_UNATIVEINT 
  | 163 -> TOKEN_UINT64 
  | 164 -> TOKEN_UINT32 
  | 165 -> TOKEN_UINT16 
  | 166 -> TOKEN_UINT8 
  | 167 -> TOKEN_INT64 
  | 168 -> TOKEN_INT32 
  | 169 -> TOKEN_INT32_DOT_DOT 
  | 170 -> TOKEN_INT16 
  | 171 -> TOKEN_INT8 
  | 172 -> TOKEN_FUNKY_OPERATOR_NAME 
  | 173 -> TOKEN_ADJACENT_PREFIX_PLUS_MINUS_OP 
  | 174 -> TOKEN_PLUS_MINUS_OP 
  | 175 -> TOKEN_INFIX_AMP_OP 
  | 176 -> TOKEN_INFIX_STAR_DIV_MOD_OP 
  | 177 -> TOKEN_DIV_MOD_OP 
  | 178 -> TOKEN_PREFIX_OP 
  | 179 -> TOKEN_INFIX_BAR_OP 
  | 180 -> TOKEN_INFIX_AT_HAT_OP 
  | 181 -> TOKEN_INFIX_COMPARE_OP 
  | 182 -> TOKEN_INFIX_STAR_STAR_OP 
  | 183 -> TOKEN_LANG 
  | 184 -> TOKEN_BASEKIND 
  | 185 -> TOKEN_TVAR 
  | 186 -> TOKEN_NAME 
  | 187 -> TOKEN_IDENT 
  | 188 -> TOKEN_STRING 
  | 189 -> TOKEN_BYTEARRAY 
  | 192 -> TOKEN_end_of_input
  | 190 -> TOKEN_error
  | _ -> failwith "tokenTagToTokenId: bad token"

/// This function maps production indexes returned in syntax errors to strings representing the non terminal that would be produced by that production
let prodIdxToNonTerminal (prodIdx:int) = 
  match prodIdx with
    | 0 -> NONTERM__startfile 
    | 1 -> NONTERM_file 
    | 2 -> NONTERM_moduleList 
    | 3 -> NONTERM_moduleList 
    | 4 -> NONTERM_modul 
    | 5 -> NONTERM_endopt 
    | 6 -> NONTERM_endopt 
    | 7 -> NONTERM_pragmas 
    | 8 -> NONTERM_pragmas 
    | 9 -> NONTERM_pragma 
    | 10 -> NONTERM_pragma 
    | 11 -> NONTERM_decls 
    | 12 -> NONTERM_decls 
    | 13 -> NONTERM_decls 
    | 14 -> NONTERM_decl 
    | 15 -> NONTERM_decl' 
    | 16 -> NONTERM_decl' 
    | 17 -> NONTERM_decl' 
    | 18 -> NONTERM_decl' 
    | 19 -> NONTERM_decl' 
    | 20 -> NONTERM_decl' 
    | 21 -> NONTERM_valQuals 
    | 22 -> NONTERM_valQuals 
    | 23 -> NONTERM_valQuals 
    | 24 -> NONTERM_erefDefn 
    | 25 -> NONTERM_erefFields 
    | 26 -> NONTERM_erefFields 
    | 27 -> NONTERM_logicTag 
    | 28 -> NONTERM_logicTag 
    | 29 -> NONTERM_assumeTag 
    | 30 -> NONTERM_assumeTag 
    | 31 -> NONTERM_assumeTag 
    | 32 -> NONTERM_tycon 
    | 33 -> NONTERM_tyconDefinition 
    | 34 -> NONTERM_tyconDefinitions 
    | 35 -> NONTERM_tyconDefinitions 
    | 36 -> NONTERM_tyconQuals 
    | 37 -> NONTERM_tyconQuals 
    | 38 -> NONTERM_tyconQuals 
    | 39 -> NONTERM_logicArrayArgs 
    | 40 -> NONTERM_logicArrayArgs 
    | 41 -> NONTERM_recopt 
    | 42 -> NONTERM_recopt 
    | 43 -> NONTERM_letbindings 
    | 44 -> NONTERM_letbindings 
    | 45 -> NONTERM_letbinding 
    | 46 -> NONTERM_pattern 
    | 47 -> NONTERM_pattern 
    | 48 -> NONTERM_pattern 
    | 49 -> NONTERM_appPattern 
    | 50 -> NONTERM_listPattern 
    | 51 -> NONTERM_consPattern 
    | 52 -> NONTERM_consPattern 
    | 53 -> NONTERM_tuplePattern 
    | 54 -> NONTERM_compositePattern 
    | 55 -> NONTERM_compositePattern 
    | 56 -> NONTERM_compositePattern 
    | 57 -> NONTERM_atomicPatterns 
    | 58 -> NONTERM_atomicPatterns 
    | 59 -> NONTERM_atomicPattern 
    | 60 -> NONTERM_atomicPattern' 
    | 61 -> NONTERM_atomicPattern' 
    | 62 -> NONTERM_nonTvarPattern 
    | 63 -> NONTERM_nonTvarPattern' 
    | 64 -> NONTERM_nonTvarPattern' 
    | 65 -> NONTERM_nonTvarPattern' 
    | 66 -> NONTERM_nonTvarPattern' 
    | 67 -> NONTERM_nonTvarPattern' 
    | 68 -> NONTERM_nonTvarPattern' 
    | 69 -> NONTERM_nonTvarPattern' 
    | 70 -> NONTERM_ascriptionOrPattern 
    | 71 -> NONTERM_ascriptionOrPattern 
    | 72 -> NONTERM_ascriptionOrPattern 
    | 73 -> NONTERM_maybeAscribeKind 
    | 74 -> NONTERM_maybeAscribeKind 
    | 75 -> NONTERM_patternListSemiColon 
    | 76 -> NONTERM_patternListSemiColon 
    | 77 -> NONTERM_patternListComma 
    | 78 -> NONTERM_patternListComma 
    | 79 -> NONTERM_recordPattern 
    | 80 -> NONTERM_recordPattern 
    | 81 -> NONTERM_binder 
    | 82 -> NONTERM_binder 
    | 83 -> NONTERM_binder 
    | 84 -> NONTERM_binder 
    | 85 -> NONTERM_binders 
    | 86 -> NONTERM_binders 
    | 87 -> NONTERM_tyconDefn 
    | 88 -> NONTERM_tyconDefn 
    | 89 -> NONTERM_tyconDefn 
    | 90 -> NONTERM_tyconDefn 
    | 91 -> NONTERM_recordFields 
    | 92 -> NONTERM_recordFields 
    | 93 -> NONTERM_constructors 
    | 94 -> NONTERM_constructors 
    | 95 -> NONTERM_recordFieldDecl 
    | 96 -> NONTERM_constructorDecl 
    | 97 -> NONTERM_eitherQname 
    | 98 -> NONTERM_eitherQname' 
    | 99 -> NONTERM_eitherQname' 
    | 100 -> NONTERM_lid 
    | 101 -> NONTERM_qname 
    | 102 -> NONTERM_eitherName 
    | 103 -> NONTERM_eitherName 
    | 104 -> NONTERM_ident 
    | 105 -> NONTERM_name 
    | 106 -> NONTERM_tvar 
    | 107 -> NONTERM_namepath 
    | 108 -> NONTERM_namepath 
    | 109 -> NONTERM_idpath 
    | 110 -> NONTERM_idpath 
    | 111 -> NONTERM_ascribeTypOpt 
    | 112 -> NONTERM_ascribeTypOpt 
    | 113 -> NONTERM_ascribeKindOpt 
    | 114 -> NONTERM_ascribeKindOpt 
    | 115 -> NONTERM_kind 
    | 116 -> NONTERM_atomicKind 
    | 117 -> NONTERM_typ 
    | 118 -> NONTERM_term 
    | 119 -> NONTERM_term 
    | 120 -> NONTERM_noSeqTerm 
    | 121 -> NONTERM_noSeqTerm 
    | 122 -> NONTERM_noSeqTerm 
    | 123 -> NONTERM_noSeqTerm 
    | 124 -> NONTERM_noSeqTerm 
    | 125 -> NONTERM_noSeqTerm 
    | 126 -> NONTERM_noSeqTerm 
    | 127 -> NONTERM_noSeqTerm 
    | 128 -> NONTERM_qpat 
    | 129 -> NONTERM_qpat 
    | 130 -> NONTERM_morePats 
    | 131 -> NONTERM_morePats 
    | 132 -> NONTERM_simpleTerm 
    | 133 -> NONTERM_simpleTerm 
    | 134 -> NONTERM_patternBranches 
    | 135 -> NONTERM_patternBranches 
    | 136 -> NONTERM_patternBranch 
    | 137 -> NONTERM_funArrow 
    | 138 -> NONTERM_funArrow 
    | 139 -> NONTERM_funArrow 
    | 140 -> NONTERM_tmIff 
    | 141 -> NONTERM_tmIff 
    | 142 -> NONTERM_tmImplies 
    | 143 -> NONTERM_tmImplies 
    | 144 -> NONTERM_tmDisjunction 
    | 145 -> NONTERM_tmDisjunction 
    | 146 -> NONTERM_tmConjunction 
    | 147 -> NONTERM_tmConjunction 
    | 148 -> NONTERM_tmTuple 
    | 149 -> NONTERM_tmTuple 
    | 150 -> NONTERM_tmEq 
    | 151 -> NONTERM_tmEq 
    | 152 -> NONTERM_tmEq 
    | 153 -> NONTERM_tmEq 
    | 154 -> NONTERM_tmCons 
    | 155 -> NONTERM_tmCons 
    | 156 -> NONTERM_tmOr 
    | 157 -> NONTERM_tmOr 
    | 158 -> NONTERM_tmAnd 
    | 159 -> NONTERM_tmAnd 
    | 160 -> NONTERM_cmpTerm 
    | 161 -> NONTERM_cmpTerm 
    | 162 -> NONTERM_comparisonOp 
    | 163 -> NONTERM_comparisonOp 
    | 164 -> NONTERM_comparisonOp 
    | 165 -> NONTERM_comparisonOp 
    | 166 -> NONTERM_arithTerm 
    | 167 -> NONTERM_arithTerm 
    | 168 -> NONTERM_starDivModTerm 
    | 169 -> NONTERM_starDivModTerm 
    | 170 -> NONTERM_starDivModTerm 
    | 171 -> NONTERM_sumType 
    | 172 -> NONTERM_sumType 
    | 173 -> NONTERM_product' 
    | 174 -> NONTERM_product' 
    | 175 -> NONTERM_product' 
    | 176 -> NONTERM_prodArrow 
    | 177 -> NONTERM_prodArrow 
    | 178 -> NONTERM_prodArrow 
    | 179 -> NONTERM_sumTypeTail 
    | 180 -> NONTERM_sumTypeTail 
    | 181 -> NONTERM_product 
    | 182 -> NONTERM_product 
    | 183 -> NONTERM_product 
    | 184 -> NONTERM_productOrSumDomain 
    | 185 -> NONTERM_productOrSumDomain 
    | 186 -> NONTERM_refineOpt 
    | 187 -> NONTERM_refineOpt 
    | 188 -> NONTERM_refinementTerm 
    | 189 -> NONTERM_refinementTerm 
    | 190 -> NONTERM_refinementTerm 
    | 191 -> NONTERM_unaryOpTerm 
    | 192 -> NONTERM_unaryOpTerm 
    | 193 -> NONTERM_appTerm 
    | 194 -> NONTERM_formula 
    | 195 -> NONTERM_atomicTerm 
    | 196 -> NONTERM_atomicTerm 
    | 197 -> NONTERM_atomicTerm 
    | 198 -> NONTERM_atomicTerm 
    | 199 -> NONTERM_atomicTerm 
    | 200 -> NONTERM_atomicTerm 
    | 201 -> NONTERM_maybeFieldProjections 
    | 202 -> NONTERM_maybeFieldProjections 
    | 203 -> NONTERM_projectionLHS 
    | 204 -> NONTERM_projectionLHS 
    | 205 -> NONTERM_projectionLHS 
    | 206 -> NONTERM_projection 
    | 207 -> NONTERM_projection 
    | 208 -> NONTERM_semiColonTermList 
    | 209 -> NONTERM_semiColonTermList 
    | 210 -> NONTERM_moreSemiColonTerms 
    | 211 -> NONTERM_moreSemiColonTerms 
    | 212 -> NONTERM_recordExp 
    | 213 -> NONTERM_recordExpRest 
    | 214 -> NONTERM_recordExpRest 
    | 215 -> NONTERM_recordFieldAssignment 
    | 216 -> NONTERM_recordFieldAssignments 
    | 217 -> NONTERM_recordFieldAssignments 
    | 218 -> NONTERM_maybeWithSort 
    | 219 -> NONTERM_maybeWithSort 
    | 220 -> NONTERM_hasSort 
    | 221 -> NONTERM_hasSort 
    | 222 -> NONTERM_atomicTerms 
    | 223 -> NONTERM_atomicTerms 
    | 224 -> NONTERM_consTerm 
    | 225 -> NONTERM_consTerm 
    | 226 -> NONTERM_tupleTerm 
    | 227 -> NONTERM_tupleTerm 
    | 228 -> NONTERM_constant 
    | 229 -> NONTERM_constant 
    | 230 -> NONTERM_constant 
    | 231 -> NONTERM_constant 
    | 232 -> NONTERM_constant 
    | 233 -> NONTERM_constant 
    | 234 -> NONTERM_constant 
    | 235 -> NONTERM_constant 
    | 236 -> NONTERM_constant 
    | 237 -> NONTERM_constant 
    | 238 -> NONTERM_constant 
    | 239 -> NONTERM_constant 
    | 240 -> NONTERM_constant 
    | 241 -> NONTERM_constant 
    | 242 -> NONTERM_constant 
    | 243 -> NONTERM_constant 
    | 244 -> NONTERM_constant 
    | 245 -> NONTERM_constant 
    | 246 -> NONTERM_constant 
    | 247 -> NONTERM_constant 
    | 248 -> NONTERM_constant 
    | _ -> failwith "prodIdxToNonTerminal: bad production index"

let _fsyacc_endOfInputTag = 192 
let _fsyacc_tagOfErrorTerminal = 190

// This function gets the name of a token as a string
let token_to_string (t:token) = 
  match t with 
  | COMMENT _ -> "COMMENT" 
  | WHITESPACE _ -> "WHITESPACE" 
  | HASH_LINE _ -> "HASH_LINE" 
  | HASH_LIGHT _ -> "HASH_LIGHT" 
  | HASH_IF _ -> "HASH_IF" 
  | HASH_ELSE _ -> "HASH_ELSE" 
  | HASH_ENDIF _ -> "HASH_ENDIF" 
  | INACTIVECODE _ -> "INACTIVECODE" 
  | LINE_COMMENT _ -> "LINE_COMMENT" 
  | STRING_TEXT _ -> "STRING_TEXT" 
  | EOF _ -> "EOF" 
  | LEX_FAILURE _ -> "LEX_FAILURE" 
  | EXTERN  -> "EXTERN" 
  | REFERENCE  -> "REFERENCE" 
  | VOID  -> "VOID" 
  | PUBLIC  -> "PUBLIC" 
  | PRIVATE  -> "PRIVATE" 
  | INTERNAL  -> "INTERNAL" 
  | LBRACE_COLON_PATTERN  -> "LBRACE_COLON_PATTERN" 
  | STATIC  -> "STATIC" 
  | MEMBER  -> "MEMBER" 
  | CLASS  -> "CLASS" 
  | VIRTUAL  -> "VIRTUAL" 
  | ABSTRACT  -> "ABSTRACT" 
  | OVERRIDE  -> "OVERRIDE" 
  | DEFAULT  -> "DEFAULT" 
  | CONSTRUCTOR  -> "CONSTRUCTOR" 
  | INHERIT  -> "INHERIT" 
  | GREATER_RBRACK  -> "GREATER_RBRACK" 
  | STRUCT  -> "STRUCT" 
  | SIG  -> "SIG" 
  | BAR  -> "BAR" 
  | RBRACK  -> "RBRACK" 
  | RBRACE  -> "RBRACE" 
  | MINUS  -> "MINUS" 
  | DOLLAR  -> "DOLLAR" 
  | LBRACE_LESS  -> "LBRACE_LESS" 
  | BAR_RBRACK  -> "BAR_RBRACK" 
  | GREATER_RBRACE  -> "GREATER_RBRACE" 
  | UNDERSCORE  -> "UNDERSCORE" 
  | BANG  -> "BANG" 
  | SEMICOLON_SEMICOLON  -> "SEMICOLON_SEMICOLON" 
  | LARROW  -> "LARROW" 
  | EQUALS  -> "EQUALS" 
  | LBRACK  -> "LBRACK" 
  | LBRACK_BAR  -> "LBRACK_BAR" 
  | LBRACK_LESS  -> "LBRACK_LESS" 
  | LBRACE  -> "LBRACE" 
  | BACKSLASH  -> "BACKSLASH" 
  | QMARK  -> "QMARK" 
  | QMARK_QMARK  -> "QMARK_QMARK" 
  | DOT  -> "DOT" 
  | COLON  -> "COLON" 
  | COLON_COLON  -> "COLON_COLON" 
  | ATSIGN  -> "ATSIGN" 
  | COLON_GREATER  -> "COLON_GREATER" 
  | COLON_QMARK_GREATER  -> "COLON_QMARK_GREATER" 
  | COLON_QMARK  -> "COLON_QMARK" 
  | COLON_EQUALS  -> "COLON_EQUALS" 
  | SEMICOLON  -> "SEMICOLON" 
  | GREATER_DOT  -> "GREATER_DOT" 
  | GREATER_BAR_RBRACK  -> "GREATER_BAR_RBRACK" 
  | LPAREN_STAR_RPAREN  -> "LPAREN_STAR_RPAREN" 
  | IFF  -> "IFF" 
  | IMPLIES  -> "IMPLIES" 
  | CONJUNCTION  -> "CONJUNCTION" 
  | DISJUNCTION  -> "DISJUNCTION" 
  | WHEN  -> "WHEN" 
  | WHILE  -> "WHILE" 
  | WITH  -> "WITH" 
  | HASH  -> "HASH" 
  | AMP  -> "AMP" 
  | AMP_AMP  -> "AMP_AMP" 
  | QUOTE  -> "QUOTE" 
  | LPAREN  -> "LPAREN" 
  | RPAREN  -> "RPAREN" 
  | LPAREN_RPAREN  -> "LPAREN_RPAREN" 
  | STAR  -> "STAR" 
  | COMMA  -> "COMMA" 
  | RARROW  -> "RARROW" 
  | RARROW2  -> "RARROW2" 
  | RRARROW  -> "RRARROW" 
  | OPEN  -> "OPEN" 
  | OR  -> "OR" 
  | PROP  -> "PROP" 
  | REC  -> "REC" 
  | THEN  -> "THEN" 
  | TO  -> "TO" 
  | TRUE  -> "TRUE" 
  | TRY  -> "TRY" 
  | TYPE  -> "TYPE" 
  | VAL  -> "VAL" 
  | INLINE  -> "INLINE" 
  | INTERFACE  -> "INTERFACE" 
  | INSTANCE  -> "INSTANCE" 
  | LAZY  -> "LAZY" 
  | MATCH  -> "MATCH" 
  | METHOD  -> "METHOD" 
  | MUTABLE  -> "MUTABLE" 
  | NEW  -> "NEW" 
  | OF  -> "OF" 
  | EXCEPTION  -> "EXCEPTION" 
  | FALSE  -> "FALSE" 
  | FOR  -> "FOR" 
  | FUN  -> "FUN" 
  | FUNCTION  -> "FUNCTION" 
  | IF  -> "IF" 
  | IN  -> "IN" 
  | FINALLY  -> "FINALLY" 
  | DO_BANG  -> "DO_BANG" 
  | AND  -> "AND" 
  | AS  -> "AS" 
  | ASSERT  -> "ASSERT" 
  | ASR  -> "ASR" 
  | BEGIN  -> "BEGIN" 
  | DO  -> "DO" 
  | DONE  -> "DONE" 
  | DOWNTO  -> "DOWNTO" 
  | ELSE  -> "ELSE" 
  | ELIF  -> "ELIF" 
  | END  -> "END" 
  | DOT_DOT  -> "DOT_DOT" 
  | BAR_BAR  -> "BAR_BAR" 
  | LEQ  -> "LEQ" 
  | GEQ  -> "GEQ" 
  | LESS  -> "LESS" 
  | GREATER  -> "GREATER" 
  | LESSGREATER  -> "LESSGREATER" 
  | GREATERGREATER  -> "GREATERGREATER" 
  | UPCAST  -> "UPCAST" 
  | DOWNCAST  -> "DOWNCAST" 
  | NULL  -> "NULL" 
  | RESERVED  -> "RESERVED" 
  | MODULE  -> "MODULE" 
  | DELEGATE  -> "DELEGATE" 
  | CONSTRAINT  -> "CONSTRAINT" 
  | BASE  -> "BASE" 
  | SUBTYPE  -> "SUBTYPE" 
  | SUBKIND  -> "SUBKIND" 
  | FORALL  -> "FORALL" 
  | EXISTS  -> "EXISTS" 
  | ASSUME  -> "ASSUME" 
  | QUERY  -> "QUERY" 
  | DEFINE  -> "DEFINE" 
  | LOGIC  -> "LOGIC" 
  | PRAGMAMONADIC  -> "PRAGMAMONADIC" 
  | PRAGMADYNAMIC  -> "PRAGMADYNAMIC" 
  | LQUOTE _ -> "LQUOTE" 
  | RQUOTE _ -> "RQUOTE" 
  | SPLICE_SYMBOL _ -> "SPLICE_SYMBOL" 
  | PERCENT_OP _ -> "PERCENT_OP" 
  | BINDER _ -> "BINDER" 
  | LET _ -> "LET" 
  | YIELD _ -> "YIELD" 
  | YIELD_BANG _ -> "YIELD_BANG" 
  | BIGINT _ -> "BIGINT" 
  | BIGNUM _ -> "BIGNUM" 
  | DECIMAL _ -> "DECIMAL" 
  | CHAR _ -> "CHAR" 
  | IEEE64 _ -> "IEEE64" 
  | IEEE32 _ -> "IEEE32" 
  | NATIVEINT _ -> "NATIVEINT" 
  | UNATIVEINT _ -> "UNATIVEINT" 
  | UINT64 _ -> "UINT64" 
  | UINT32 _ -> "UINT32" 
  | UINT16 _ -> "UINT16" 
  | UINT8 _ -> "UINT8" 
  | INT64 _ -> "INT64" 
  | INT32 _ -> "INT32" 
  | INT32_DOT_DOT _ -> "INT32_DOT_DOT" 
  | INT16 _ -> "INT16" 
  | INT8 _ -> "INT8" 
  | FUNKY_OPERATOR_NAME _ -> "FUNKY_OPERATOR_NAME" 
  | ADJACENT_PREFIX_PLUS_MINUS_OP _ -> "ADJACENT_PREFIX_PLUS_MINUS_OP" 
  | PLUS_MINUS_OP _ -> "PLUS_MINUS_OP" 
  | INFIX_AMP_OP _ -> "INFIX_AMP_OP" 
  | INFIX_STAR_DIV_MOD_OP _ -> "INFIX_STAR_DIV_MOD_OP" 
  | DIV_MOD_OP _ -> "DIV_MOD_OP" 
  | PREFIX_OP _ -> "PREFIX_OP" 
  | INFIX_BAR_OP _ -> "INFIX_BAR_OP" 
  | INFIX_AT_HAT_OP _ -> "INFIX_AT_HAT_OP" 
  | INFIX_COMPARE_OP _ -> "INFIX_COMPARE_OP" 
  | INFIX_STAR_STAR_OP _ -> "INFIX_STAR_STAR_OP" 
  | LANG _ -> "LANG" 
  | BASEKIND _ -> "BASEKIND" 
  | TVAR _ -> "TVAR" 
  | NAME _ -> "NAME" 
  | IDENT _ -> "IDENT" 
  | STRING _ -> "STRING" 
  | BYTEARRAY _ -> "BYTEARRAY" 

// This function gets the data carried by a token as an object
let _fsyacc_dataOfToken (t:token) = 
  match t with 
  | COMMENT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | WHITESPACE _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | HASH_LINE _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | HASH_LIGHT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | HASH_IF _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | HASH_ELSE _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | HASH_ENDIF _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INACTIVECODE _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | LINE_COMMENT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | STRING_TEXT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | EOF _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | LEX_FAILURE _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | EXTERN  -> (null : System.Object) 
  | REFERENCE  -> (null : System.Object) 
  | VOID  -> (null : System.Object) 
  | PUBLIC  -> (null : System.Object) 
  | PRIVATE  -> (null : System.Object) 
  | INTERNAL  -> (null : System.Object) 
  | LBRACE_COLON_PATTERN  -> (null : System.Object) 
  | STATIC  -> (null : System.Object) 
  | MEMBER  -> (null : System.Object) 
  | CLASS  -> (null : System.Object) 
  | VIRTUAL  -> (null : System.Object) 
  | ABSTRACT  -> (null : System.Object) 
  | OVERRIDE  -> (null : System.Object) 
  | DEFAULT  -> (null : System.Object) 
  | CONSTRUCTOR  -> (null : System.Object) 
  | INHERIT  -> (null : System.Object) 
  | GREATER_RBRACK  -> (null : System.Object) 
  | STRUCT  -> (null : System.Object) 
  | SIG  -> (null : System.Object) 
  | BAR  -> (null : System.Object) 
  | RBRACK  -> (null : System.Object) 
  | RBRACE  -> (null : System.Object) 
  | MINUS  -> (null : System.Object) 
  | DOLLAR  -> (null : System.Object) 
  | LBRACE_LESS  -> (null : System.Object) 
  | BAR_RBRACK  -> (null : System.Object) 
  | GREATER_RBRACE  -> (null : System.Object) 
  | UNDERSCORE  -> (null : System.Object) 
  | BANG  -> (null : System.Object) 
  | SEMICOLON_SEMICOLON  -> (null : System.Object) 
  | LARROW  -> (null : System.Object) 
  | EQUALS  -> (null : System.Object) 
  | LBRACK  -> (null : System.Object) 
  | LBRACK_BAR  -> (null : System.Object) 
  | LBRACK_LESS  -> (null : System.Object) 
  | LBRACE  -> (null : System.Object) 
  | BACKSLASH  -> (null : System.Object) 
  | QMARK  -> (null : System.Object) 
  | QMARK_QMARK  -> (null : System.Object) 
  | DOT  -> (null : System.Object) 
  | COLON  -> (null : System.Object) 
  | COLON_COLON  -> (null : System.Object) 
  | ATSIGN  -> (null : System.Object) 
  | COLON_GREATER  -> (null : System.Object) 
  | COLON_QMARK_GREATER  -> (null : System.Object) 
  | COLON_QMARK  -> (null : System.Object) 
  | COLON_EQUALS  -> (null : System.Object) 
  | SEMICOLON  -> (null : System.Object) 
  | GREATER_DOT  -> (null : System.Object) 
  | GREATER_BAR_RBRACK  -> (null : System.Object) 
  | LPAREN_STAR_RPAREN  -> (null : System.Object) 
  | IFF  -> (null : System.Object) 
  | IMPLIES  -> (null : System.Object) 
  | CONJUNCTION  -> (null : System.Object) 
  | DISJUNCTION  -> (null : System.Object) 
  | WHEN  -> (null : System.Object) 
  | WHILE  -> (null : System.Object) 
  | WITH  -> (null : System.Object) 
  | HASH  -> (null : System.Object) 
  | AMP  -> (null : System.Object) 
  | AMP_AMP  -> (null : System.Object) 
  | QUOTE  -> (null : System.Object) 
  | LPAREN  -> (null : System.Object) 
  | RPAREN  -> (null : System.Object) 
  | LPAREN_RPAREN  -> (null : System.Object) 
  | STAR  -> (null : System.Object) 
  | COMMA  -> (null : System.Object) 
  | RARROW  -> (null : System.Object) 
  | RARROW2  -> (null : System.Object) 
  | RRARROW  -> (null : System.Object) 
  | OPEN  -> (null : System.Object) 
  | OR  -> (null : System.Object) 
  | PROP  -> (null : System.Object) 
  | REC  -> (null : System.Object) 
  | THEN  -> (null : System.Object) 
  | TO  -> (null : System.Object) 
  | TRUE  -> (null : System.Object) 
  | TRY  -> (null : System.Object) 
  | TYPE  -> (null : System.Object) 
  | VAL  -> (null : System.Object) 
  | INLINE  -> (null : System.Object) 
  | INTERFACE  -> (null : System.Object) 
  | INSTANCE  -> (null : System.Object) 
  | LAZY  -> (null : System.Object) 
  | MATCH  -> (null : System.Object) 
  | METHOD  -> (null : System.Object) 
  | MUTABLE  -> (null : System.Object) 
  | NEW  -> (null : System.Object) 
  | OF  -> (null : System.Object) 
  | EXCEPTION  -> (null : System.Object) 
  | FALSE  -> (null : System.Object) 
  | FOR  -> (null : System.Object) 
  | FUN  -> (null : System.Object) 
  | FUNCTION  -> (null : System.Object) 
  | IF  -> (null : System.Object) 
  | IN  -> (null : System.Object) 
  | FINALLY  -> (null : System.Object) 
  | DO_BANG  -> (null : System.Object) 
  | AND  -> (null : System.Object) 
  | AS  -> (null : System.Object) 
  | ASSERT  -> (null : System.Object) 
  | ASR  -> (null : System.Object) 
  | BEGIN  -> (null : System.Object) 
  | DO  -> (null : System.Object) 
  | DONE  -> (null : System.Object) 
  | DOWNTO  -> (null : System.Object) 
  | ELSE  -> (null : System.Object) 
  | ELIF  -> (null : System.Object) 
  | END  -> (null : System.Object) 
  | DOT_DOT  -> (null : System.Object) 
  | BAR_BAR  -> (null : System.Object) 
  | LEQ  -> (null : System.Object) 
  | GEQ  -> (null : System.Object) 
  | LESS  -> (null : System.Object) 
  | GREATER  -> (null : System.Object) 
  | LESSGREATER  -> (null : System.Object) 
  | GREATERGREATER  -> (null : System.Object) 
  | UPCAST  -> (null : System.Object) 
  | DOWNCAST  -> (null : System.Object) 
  | NULL  -> (null : System.Object) 
  | RESERVED  -> (null : System.Object) 
  | MODULE  -> (null : System.Object) 
  | DELEGATE  -> (null : System.Object) 
  | CONSTRAINT  -> (null : System.Object) 
  | BASE  -> (null : System.Object) 
  | SUBTYPE  -> (null : System.Object) 
  | SUBKIND  -> (null : System.Object) 
  | FORALL  -> (null : System.Object) 
  | EXISTS  -> (null : System.Object) 
  | ASSUME  -> (null : System.Object) 
  | QUERY  -> (null : System.Object) 
  | DEFINE  -> (null : System.Object) 
  | LOGIC  -> (null : System.Object) 
  | PRAGMAMONADIC  -> (null : System.Object) 
  | PRAGMADYNAMIC  -> (null : System.Object) 
  | LQUOTE _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | RQUOTE _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | SPLICE_SYMBOL _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | PERCENT_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | BINDER _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | LET _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | YIELD _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | YIELD_BANG _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | BIGINT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | BIGNUM _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | DECIMAL _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | CHAR _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | IEEE64 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | IEEE32 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | NATIVEINT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | UNATIVEINT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | UINT64 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | UINT32 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | UINT16 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | UINT8 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INT64 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INT32 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INT32_DOT_DOT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INT16 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INT8 _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | FUNKY_OPERATOR_NAME _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | ADJACENT_PREFIX_PLUS_MINUS_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | PLUS_MINUS_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INFIX_AMP_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INFIX_STAR_DIV_MOD_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | DIV_MOD_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | PREFIX_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INFIX_BAR_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INFIX_AT_HAT_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INFIX_COMPARE_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INFIX_STAR_STAR_OP _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | LANG _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | BASEKIND _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | TVAR _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | NAME _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | IDENT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | STRING _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | BYTEARRAY _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
let _fsyacc_gotos = [| 0us; 65535us; 1us; 65535us; 0us; 1us; 2us; 65535us; 2us; 3us; 4us; 5us; 2us; 65535us; 2us; 4us; 4us; 4us; 1us; 65535us; 9us; 10us; 1us; 65535us; 0us; 2us; 1us; 65535us; 2us; 12us; 2us; 65535us; 8us; 9us; 24us; 25us; 2us; 65535us; 8us; 24us; 24us; 24us; 2us; 65535us; 8us; 26us; 24us; 26us; 2us; 65535us; 8us; 34us; 24us; 34us; 1us; 65535us; 45us; 46us; 2us; 65535us; 52us; 53us; 58us; 59us; 0us; 65535us; 2us; 65535us; 8us; 39us; 24us; 39us; 2us; 65535us; 8us; 29us; 24us; 29us; 2us; 65535us; 64us; 65us; 71us; 72us; 2us; 65535us; 65us; 66us; 72us; 73us; 2us; 65535us; 8us; 63us; 24us; 63us; 1us; 65535us; 74us; 75us; 2us; 65535us; 30us; 31us; 228us; 229us; 3us; 65535us; 32us; 33us; 87us; 88us; 230us; 231us; 3us; 65535us; 31us; 32us; 86us; 87us; 229us; 230us; 4us; 65535us; 31us; 89us; 86us; 89us; 229us; 89us; 263us; 264us; 7us; 65535us; 31us; 93us; 86us; 93us; 107us; 108us; 128us; 106us; 143us; 144us; 229us; 93us; 263us; 93us; 5us; 65535us; 31us; 94us; 86us; 94us; 128us; 112us; 229us; 94us; 263us; 94us; 2us; 65535us; 101us; 102us; 104us; 105us; 5us; 65535us; 31us; 95us; 86us; 95us; 128us; 113us; 229us; 95us; 263us; 95us; 1us; 65535us; 128us; 139us; 6us; 65535us; 96us; 99us; 97us; 99us; 98us; 99us; 110us; 111us; 114us; 115us; 258us; 259us; 19us; 65535us; 31us; 97us; 86us; 97us; 96us; 114us; 97us; 114us; 98us; 110us; 100us; 101us; 103us; 104us; 107us; 96us; 110us; 114us; 114us; 114us; 125us; 140us; 128us; 98us; 141us; 140us; 143us; 96us; 147us; 148us; 229us; 97us; 257us; 258us; 258us; 114us; 263us; 97us; 19us; 65535us; 31us; 116us; 86us; 116us; 96us; 116us; 97us; 116us; 98us; 116us; 100us; 116us; 103us; 116us; 107us; 116us; 110us; 116us; 114us; 116us; 125us; 116us; 128us; 116us; 141us; 116us; 143us; 116us; 147us; 116us; 229us; 116us; 257us; 116us; 258us; 116us; 263us; 116us; 1us; 65535us; 128us; 134us; 19us; 65535us; 31us; 117us; 86us; 117us; 96us; 117us; 97us; 117us; 98us; 117us; 100us; 117us; 103us; 117us; 107us; 117us; 110us; 117us; 114us; 117us; 125us; 117us; 128us; 118us; 141us; 117us; 143us; 117us; 147us; 117us; 229us; 117us; 257us; 117us; 258us; 117us; 263us; 117us; 1us; 65535us; 128us; 129us; 0us; 65535us; 2us; 65535us; 125us; 126us; 141us; 142us; 2us; 65535us; 108us; 109us; 144us; 145us; 2us; 65535us; 131us; 132us; 149us; 150us; 4us; 65535us; 67us; 163us; 163us; 163us; 234us; 163us; 239us; 163us; 4us; 65535us; 67us; 68us; 163us; 164us; 234us; 235us; 239us; 240us; 1us; 65535us; 69us; 70us; 2us; 65535us; 168us; 169us; 173us; 174us; 1us; 65535us; 165us; 171us; 2us; 65535us; 167us; 168us; 172us; 173us; 1us; 65535us; 171us; 175us; 3us; 65535us; 14us; 15us; 16us; 17us; 18us; 19us; 4us; 65535us; 14us; 184us; 16us; 184us; 18us; 184us; 187us; 188us; 65us; 65535us; 22us; 366us; 37us; 366us; 41us; 366us; 91us; 366us; 131us; 146us; 135us; 366us; 137us; 366us; 149us; 146us; 155us; 366us; 160us; 366us; 165us; 366us; 167us; 366us; 178us; 366us; 182us; 366us; 206us; 366us; 208us; 366us; 214us; 366us; 217us; 366us; 219us; 366us; 221us; 366us; 223us; 366us; 232us; 366us; 237us; 366us; 242us; 366us; 247us; 366us; 249us; 366us; 253us; 366us; 260us; 366us; 265us; 366us; 271us; 366us; 274us; 366us; 276us; 366us; 279us; 366us; 284us; 366us; 287us; 366us; 289us; 366us; 291us; 366us; 295us; 366us; 297us; 366us; 300us; 366us; 303us; 366us; 310us; 366us; 313us; 366us; 315us; 366us; 319us; 366us; 325us; 366us; 326us; 366us; 330us; 366us; 333us; 366us; 336us; 366us; 340us; 366us; 342us; 366us; 343us; 366us; 348us; 366us; 352us; 366us; 354us; 366us; 367us; 366us; 371us; 366us; 376us; 366us; 381us; 386us; 384us; 366us; 387us; 366us; 388us; 386us; 391us; 366us; 395us; 366us; 86us; 65535us; 7us; 8us; 22us; 360us; 27us; 28us; 31us; 124us; 37us; 360us; 41us; 360us; 76us; 77us; 78us; 79us; 80us; 81us; 82us; 83us; 86us; 124us; 91us; 360us; 96us; 124us; 97us; 124us; 98us; 124us; 100us; 124us; 103us; 124us; 107us; 124us; 110us; 124us; 114us; 124us; 125us; 124us; 128us; 124us; 135us; 360us; 137us; 360us; 141us; 124us; 143us; 124us; 147us; 124us; 155us; 360us; 160us; 360us; 165us; 360us; 167us; 360us; 178us; 360us; 182us; 360us; 206us; 360us; 208us; 360us; 214us; 360us; 217us; 360us; 219us; 360us; 221us; 360us; 223us; 360us; 229us; 124us; 232us; 360us; 237us; 360us; 242us; 360us; 247us; 360us; 249us; 360us; 253us; 360us; 257us; 124us; 258us; 124us; 260us; 360us; 263us; 124us; 265us; 360us; 271us; 360us; 274us; 360us; 276us; 360us; 279us; 360us; 284us; 360us; 287us; 360us; 289us; 360us; 291us; 360us; 295us; 360us; 297us; 360us; 300us; 360us; 303us; 360us; 310us; 360us; 313us; 360us; 315us; 360us; 319us; 360us; 325us; 360us; 326us; 360us; 330us; 360us; 333us; 360us; 336us; 360us; 340us; 360us; 342us; 360us; 343us; 360us; 348us; 360us; 352us; 360us; 354us; 360us; 367us; 360us; 371us; 360us; 376us; 360us; 384us; 360us; 387us; 360us; 391us; 360us; 395us; 360us; 7us; 65535us; 14us; 185us; 16us; 185us; 18us; 185us; 35us; 36us; 64us; 67us; 71us; 67us; 187us; 185us; 103us; 65535us; 14us; 191us; 16us; 191us; 18us; 191us; 22us; 202us; 31us; 123us; 35us; 191us; 37us; 202us; 41us; 202us; 47us; 74us; 49us; 50us; 55us; 56us; 64us; 191us; 67us; 151us; 71us; 191us; 86us; 123us; 91us; 202us; 96us; 123us; 97us; 123us; 98us; 123us; 100us; 123us; 103us; 123us; 107us; 123us; 110us; 123us; 114us; 123us; 125us; 123us; 128us; 123us; 131us; 201us; 135us; 202us; 137us; 202us; 141us; 123us; 143us; 123us; 147us; 123us; 149us; 201us; 153us; 154us; 155us; 201us; 160us; 202us; 163us; 151us; 165us; 202us; 167us; 177us; 172us; 176us; 178us; 202us; 182us; 202us; 187us; 191us; 199us; 201us; 204us; 201us; 206us; 202us; 208us; 202us; 214us; 202us; 217us; 202us; 219us; 202us; 221us; 202us; 223us; 202us; 229us; 123us; 232us; 202us; 234us; 151us; 237us; 202us; 239us; 151us; 242us; 202us; 247us; 201us; 249us; 201us; 253us; 201us; 257us; 123us; 258us; 123us; 260us; 202us; 263us; 123us; 265us; 202us; 271us; 202us; 274us; 202us; 276us; 202us; 279us; 202us; 284us; 202us; 287us; 202us; 289us; 202us; 291us; 202us; 295us; 202us; 297us; 202us; 300us; 202us; 303us; 202us; 310us; 202us; 313us; 202us; 315us; 202us; 319us; 202us; 325us; 201us; 326us; 202us; 330us; 202us; 333us; 202us; 336us; 201us; 340us; 201us; 342us; 202us; 343us; 202us; 348us; 201us; 352us; 201us; 354us; 201us; 364us; 365us; 367us; 202us; 371us; 202us; 376us; 202us; 381us; 201us; 384us; 202us; 387us; 202us; 388us; 201us; 391us; 202us; 395us; 201us; 104us; 65535us; 7us; 196us; 14us; 186us; 16us; 186us; 18us; 186us; 22us; 197us; 27us; 196us; 31us; 196us; 35us; 192us; 37us; 197us; 39us; 40us; 41us; 197us; 43us; 48us; 44us; 45us; 64us; 192us; 71us; 192us; 76us; 196us; 78us; 196us; 80us; 196us; 82us; 196us; 86us; 196us; 91us; 197us; 96us; 196us; 97us; 196us; 98us; 196us; 100us; 196us; 103us; 196us; 107us; 196us; 110us; 196us; 114us; 196us; 125us; 196us; 128us; 196us; 131us; 203us; 135us; 197us; 137us; 197us; 141us; 196us; 143us; 196us; 147us; 196us; 149us; 203us; 155us; 197us; 160us; 197us; 165us; 197us; 167us; 197us; 178us; 197us; 180us; 181us; 182us; 197us; 187us; 186us; 198us; 196us; 199us; 197us; 204us; 203us; 206us; 197us; 208us; 197us; 214us; 197us; 217us; 197us; 219us; 197us; 221us; 197us; 223us; 197us; 229us; 196us; 232us; 197us; 237us; 197us; 242us; 197us; 247us; 197us; 249us; 197us; 253us; 197us; 257us; 196us; 258us; 196us; 260us; 197us; 263us; 196us; 265us; 197us; 271us; 197us; 274us; 197us; 276us; 197us; 279us; 197us; 284us; 197us; 287us; 197us; 289us; 197us; 291us; 197us; 295us; 197us; 297us; 197us; 300us; 197us; 303us; 197us; 310us; 197us; 313us; 197us; 315us; 197us; 319us; 197us; 325us; 197us; 326us; 197us; 330us; 197us; 333us; 197us; 336us; 197us; 340us; 197us; 342us; 197us; 343us; 197us; 348us; 197us; 352us; 197us; 354us; 197us; 367us; 197us; 371us; 197us; 376us; 197us; 381us; 203us; 384us; 197us; 387us; 197us; 388us; 203us; 391us; 197us; 395us; 197us; 85us; 65535us; 22us; 339us; 31us; 119us; 37us; 339us; 41us; 339us; 67us; 152us; 86us; 119us; 91us; 339us; 96us; 119us; 97us; 119us; 98us; 119us; 100us; 119us; 103us; 119us; 107us; 119us; 110us; 119us; 114us; 119us; 125us; 119us; 128us; 120us; 135us; 339us; 137us; 339us; 141us; 119us; 143us; 119us; 147us; 119us; 153us; 159us; 155us; 359us; 160us; 339us; 163us; 152us; 165us; 339us; 167us; 359us; 178us; 339us; 182us; 339us; 206us; 339us; 208us; 339us; 214us; 339us; 217us; 339us; 219us; 339us; 221us; 339us; 223us; 339us; 229us; 119us; 232us; 339us; 234us; 152us; 237us; 339us; 239us; 152us; 242us; 339us; 247us; 359us; 249us; 359us; 253us; 359us; 257us; 119us; 258us; 119us; 260us; 339us; 263us; 119us; 265us; 339us; 271us; 339us; 274us; 339us; 276us; 339us; 279us; 339us; 284us; 339us; 287us; 339us; 289us; 339us; 291us; 339us; 295us; 339us; 297us; 339us; 300us; 339us; 303us; 339us; 310us; 339us; 313us; 339us; 315us; 339us; 319us; 339us; 325us; 359us; 326us; 339us; 330us; 339us; 333us; 339us; 336us; 359us; 340us; 359us; 342us; 339us; 343us; 339us; 348us; 359us; 352us; 359us; 354us; 359us; 367us; 339us; 371us; 339us; 376us; 339us; 384us; 339us; 387us; 339us; 391us; 339us; 395us; 359us; 88us; 65535us; 7us; 190us; 22us; 190us; 27us; 190us; 31us; 190us; 37us; 190us; 41us; 190us; 76us; 190us; 78us; 190us; 80us; 190us; 82us; 190us; 86us; 190us; 91us; 190us; 96us; 190us; 97us; 190us; 98us; 190us; 100us; 190us; 103us; 190us; 107us; 190us; 110us; 190us; 114us; 190us; 125us; 190us; 128us; 190us; 135us; 190us; 137us; 190us; 141us; 190us; 143us; 190us; 147us; 190us; 155us; 190us; 160us; 190us; 165us; 190us; 167us; 190us; 178us; 190us; 182us; 190us; 198us; 200us; 199us; 200us; 206us; 190us; 208us; 190us; 214us; 190us; 217us; 190us; 219us; 190us; 221us; 190us; 223us; 190us; 229us; 190us; 232us; 190us; 237us; 190us; 242us; 190us; 247us; 190us; 249us; 190us; 253us; 190us; 257us; 190us; 258us; 190us; 260us; 190us; 263us; 190us; 265us; 190us; 271us; 190us; 274us; 190us; 276us; 190us; 279us; 190us; 284us; 190us; 287us; 190us; 289us; 190us; 291us; 190us; 295us; 190us; 297us; 190us; 300us; 190us; 303us; 190us; 310us; 190us; 313us; 190us; 315us; 190us; 319us; 190us; 325us; 190us; 326us; 190us; 330us; 190us; 333us; 190us; 336us; 190us; 340us; 190us; 342us; 190us; 343us; 190us; 348us; 190us; 352us; 190us; 354us; 190us; 367us; 190us; 371us; 190us; 376us; 190us; 384us; 190us; 387us; 190us; 391us; 190us; 395us; 190us; 67us; 65535us; 22us; 189us; 37us; 189us; 41us; 189us; 91us; 189us; 131us; 189us; 135us; 189us; 137us; 189us; 149us; 189us; 155us; 189us; 160us; 189us; 165us; 189us; 167us; 189us; 178us; 189us; 182us; 189us; 199us; 205us; 204us; 205us; 206us; 189us; 208us; 189us; 214us; 189us; 217us; 189us; 219us; 189us; 221us; 189us; 223us; 189us; 232us; 189us; 237us; 189us; 242us; 189us; 247us; 189us; 249us; 189us; 253us; 189us; 260us; 189us; 265us; 189us; 271us; 189us; 274us; 189us; 276us; 189us; 279us; 189us; 284us; 189us; 287us; 189us; 289us; 189us; 291us; 189us; 295us; 189us; 297us; 189us; 300us; 189us; 303us; 189us; 310us; 189us; 313us; 189us; 315us; 189us; 319us; 189us; 325us; 189us; 326us; 189us; 330us; 189us; 333us; 189us; 336us; 189us; 340us; 189us; 342us; 189us; 343us; 189us; 348us; 189us; 352us; 189us; 354us; 189us; 367us; 189us; 371us; 189us; 376us; 189us; 381us; 189us; 384us; 189us; 387us; 189us; 388us; 189us; 391us; 189us; 395us; 189us; 1us; 65535us; 89us; 90us; 1us; 65535us; 68us; 69us; 3us; 65535us; 137us; 138us; 160us; 161us; 208us; 209us; 1us; 65535us; 340us; 341us; 4us; 65535us; 37us; 38us; 135us; 136us; 165us; 166us; 182us; 183us; 11us; 65535us; 22us; 23us; 91us; 92us; 214us; 215us; 217us; 218us; 219us; 220us; 221us; 222us; 223us; 224us; 232us; 233us; 260us; 261us; 265us; 266us; 367us; 368us; 18us; 65535us; 22us; 213us; 41us; 356us; 91us; 213us; 214us; 213us; 217us; 213us; 219us; 213us; 221us; 213us; 223us; 213us; 232us; 213us; 237us; 238us; 242us; 243us; 260us; 213us; 265us; 213us; 342us; 356us; 343us; 356us; 367us; 213us; 371us; 374us; 376us; 377us; 2us; 65535us; 236us; 237us; 241us; 242us; 2us; 65535us; 250us; 251us; 254us; 255us; 23us; 65535us; 22us; 216us; 37us; 212us; 41us; 216us; 91us; 216us; 135us; 212us; 165us; 212us; 182us; 212us; 214us; 216us; 217us; 216us; 219us; 216us; 221us; 216us; 223us; 216us; 232us; 216us; 237us; 216us; 242us; 216us; 260us; 216us; 265us; 216us; 342us; 216us; 343us; 216us; 367us; 216us; 371us; 216us; 376us; 216us; 391us; 392us; 2us; 65535us; 226us; 227us; 245us; 246us; 4us; 65535us; 225us; 226us; 227us; 262us; 244us; 245us; 246us; 262us; 1us; 65535us; 259us; 260us; 24us; 65535us; 22us; 256us; 37us; 256us; 41us; 256us; 91us; 256us; 135us; 256us; 165us; 256us; 182us; 256us; 214us; 256us; 217us; 256us; 219us; 256us; 221us; 256us; 223us; 256us; 232us; 256us; 237us; 256us; 242us; 256us; 260us; 256us; 265us; 256us; 271us; 272us; 342us; 256us; 343us; 256us; 367us; 256us; 371us; 256us; 376us; 256us; 391us; 256us; 25us; 65535us; 22us; 270us; 37us; 270us; 41us; 270us; 91us; 270us; 135us; 270us; 165us; 270us; 182us; 270us; 214us; 270us; 217us; 270us; 219us; 270us; 221us; 270us; 223us; 270us; 232us; 270us; 237us; 270us; 242us; 270us; 260us; 270us; 265us; 270us; 271us; 270us; 274us; 275us; 342us; 270us; 343us; 270us; 367us; 270us; 371us; 270us; 376us; 270us; 391us; 270us; 25us; 65535us; 22us; 273us; 37us; 273us; 41us; 273us; 91us; 273us; 135us; 273us; 165us; 273us; 182us; 273us; 214us; 273us; 217us; 273us; 219us; 273us; 221us; 273us; 223us; 273us; 232us; 273us; 237us; 273us; 242us; 273us; 260us; 273us; 265us; 273us; 271us; 273us; 274us; 273us; 342us; 273us; 343us; 273us; 367us; 273us; 371us; 273us; 376us; 273us; 391us; 273us; 26us; 65535us; 22us; 278us; 37us; 278us; 41us; 278us; 91us; 278us; 135us; 278us; 165us; 278us; 182us; 278us; 214us; 278us; 217us; 278us; 219us; 278us; 221us; 278us; 223us; 278us; 232us; 278us; 237us; 278us; 242us; 278us; 260us; 278us; 265us; 278us; 271us; 278us; 274us; 278us; 276us; 277us; 342us; 278us; 343us; 278us; 367us; 278us; 371us; 278us; 376us; 278us; 391us; 278us; 30us; 65535us; 22us; 281us; 37us; 281us; 41us; 281us; 91us; 281us; 135us; 281us; 165us; 281us; 178us; 179us; 182us; 281us; 214us; 281us; 217us; 281us; 219us; 281us; 221us; 281us; 223us; 281us; 232us; 281us; 237us; 281us; 242us; 281us; 260us; 281us; 265us; 281us; 271us; 281us; 274us; 281us; 276us; 281us; 279us; 280us; 342us; 281us; 343us; 281us; 367us; 281us; 371us; 281us; 376us; 281us; 384us; 282us; 387us; 283us; 391us; 281us; 31us; 65535us; 22us; 286us; 37us; 286us; 41us; 286us; 91us; 286us; 135us; 286us; 165us; 286us; 178us; 286us; 182us; 286us; 214us; 286us; 217us; 286us; 219us; 286us; 221us; 286us; 223us; 286us; 232us; 286us; 237us; 286us; 242us; 286us; 260us; 286us; 265us; 286us; 271us; 286us; 274us; 286us; 276us; 286us; 279us; 286us; 284us; 285us; 342us; 286us; 343us; 286us; 367us; 286us; 371us; 286us; 376us; 286us; 384us; 286us; 387us; 286us; 391us; 286us; 36us; 65535us; 22us; 293us; 37us; 293us; 41us; 293us; 91us; 293us; 135us; 293us; 165us; 293us; 178us; 293us; 182us; 293us; 206us; 207us; 214us; 293us; 217us; 293us; 219us; 293us; 221us; 293us; 223us; 293us; 232us; 293us; 237us; 293us; 242us; 293us; 260us; 293us; 265us; 293us; 271us; 293us; 274us; 293us; 276us; 293us; 279us; 293us; 284us; 293us; 287us; 288us; 289us; 290us; 291us; 292us; 295us; 296us; 342us; 293us; 343us; 293us; 367us; 293us; 371us; 293us; 376us; 293us; 384us; 293us; 387us; 293us; 391us; 293us; 36us; 65535us; 22us; 294us; 37us; 294us; 41us; 294us; 91us; 294us; 135us; 294us; 165us; 294us; 178us; 294us; 182us; 294us; 206us; 294us; 214us; 294us; 217us; 294us; 219us; 294us; 221us; 294us; 223us; 294us; 232us; 294us; 237us; 294us; 242us; 294us; 260us; 294us; 265us; 294us; 271us; 294us; 274us; 294us; 276us; 294us; 279us; 294us; 284us; 294us; 287us; 294us; 289us; 294us; 291us; 294us; 295us; 294us; 342us; 294us; 343us; 294us; 367us; 294us; 371us; 294us; 376us; 294us; 384us; 294us; 387us; 294us; 391us; 294us; 37us; 65535us; 22us; 299us; 37us; 299us; 41us; 299us; 91us; 299us; 135us; 299us; 165us; 299us; 178us; 299us; 182us; 299us; 206us; 299us; 214us; 299us; 217us; 299us; 219us; 299us; 221us; 299us; 223us; 299us; 232us; 299us; 237us; 299us; 242us; 299us; 260us; 299us; 265us; 299us; 271us; 299us; 274us; 299us; 276us; 299us; 279us; 299us; 284us; 299us; 287us; 299us; 289us; 299us; 291us; 299us; 295us; 299us; 297us; 298us; 342us; 299us; 343us; 299us; 367us; 299us; 371us; 299us; 376us; 299us; 384us; 299us; 387us; 299us; 391us; 299us; 37us; 65535us; 22us; 302us; 37us; 302us; 41us; 302us; 91us; 302us; 135us; 302us; 165us; 302us; 178us; 302us; 182us; 302us; 206us; 302us; 214us; 302us; 217us; 302us; 219us; 302us; 221us; 302us; 223us; 302us; 232us; 302us; 237us; 302us; 242us; 302us; 260us; 302us; 265us; 302us; 271us; 302us; 274us; 302us; 276us; 302us; 279us; 302us; 284us; 302us; 287us; 302us; 289us; 302us; 291us; 302us; 295us; 302us; 297us; 302us; 342us; 302us; 343us; 302us; 367us; 302us; 371us; 302us; 376us; 302us; 384us; 302us; 387us; 302us; 391us; 302us; 1us; 65535us; 302us; 303us; 39us; 65535us; 22us; 305us; 37us; 305us; 41us; 305us; 91us; 305us; 135us; 305us; 165us; 305us; 178us; 305us; 182us; 305us; 206us; 305us; 214us; 305us; 217us; 305us; 219us; 305us; 221us; 305us; 223us; 305us; 232us; 305us; 237us; 305us; 242us; 305us; 260us; 305us; 265us; 305us; 271us; 305us; 274us; 305us; 276us; 305us; 279us; 305us; 284us; 305us; 287us; 305us; 289us; 305us; 291us; 305us; 295us; 305us; 297us; 305us; 300us; 301us; 303us; 304us; 342us; 305us; 343us; 305us; 367us; 305us; 371us; 305us; 376us; 305us; 384us; 305us; 387us; 305us; 391us; 305us; 40us; 65535us; 22us; 312us; 37us; 312us; 41us; 312us; 91us; 312us; 135us; 312us; 165us; 312us; 178us; 312us; 182us; 312us; 206us; 312us; 214us; 312us; 217us; 312us; 219us; 312us; 221us; 312us; 223us; 312us; 232us; 312us; 237us; 312us; 242us; 312us; 260us; 312us; 265us; 312us; 271us; 312us; 274us; 312us; 276us; 312us; 279us; 312us; 284us; 312us; 287us; 312us; 289us; 312us; 291us; 312us; 295us; 312us; 297us; 312us; 300us; 312us; 303us; 312us; 310us; 311us; 342us; 312us; 343us; 312us; 367us; 312us; 371us; 312us; 376us; 312us; 384us; 312us; 387us; 312us; 391us; 312us; 44us; 65535us; 22us; 317us; 37us; 317us; 41us; 317us; 91us; 317us; 135us; 317us; 165us; 317us; 178us; 317us; 182us; 317us; 206us; 317us; 214us; 317us; 217us; 317us; 219us; 317us; 221us; 317us; 223us; 317us; 232us; 317us; 237us; 317us; 242us; 317us; 260us; 317us; 265us; 317us; 271us; 317us; 274us; 317us; 276us; 317us; 279us; 317us; 284us; 317us; 287us; 317us; 289us; 317us; 291us; 317us; 295us; 317us; 297us; 317us; 300us; 317us; 303us; 317us; 310us; 317us; 313us; 314us; 315us; 316us; 319us; 328us; 326us; 327us; 342us; 317us; 343us; 317us; 367us; 317us; 371us; 317us; 376us; 317us; 384us; 317us; 387us; 317us; 391us; 317us; 0us; 65535us; 3us; 65535us; 318us; 330us; 329us; 330us; 332us; 333us; 1us; 65535us; 319us; 320us; 49us; 65535us; 22us; 321us; 37us; 321us; 41us; 321us; 91us; 321us; 135us; 321us; 137us; 210us; 160us; 210us; 165us; 321us; 178us; 321us; 182us; 321us; 206us; 321us; 208us; 210us; 214us; 321us; 217us; 321us; 219us; 321us; 221us; 321us; 223us; 321us; 232us; 321us; 237us; 321us; 242us; 321us; 260us; 321us; 265us; 321us; 271us; 321us; 274us; 321us; 276us; 321us; 279us; 321us; 284us; 321us; 287us; 321us; 289us; 321us; 291us; 321us; 295us; 321us; 297us; 321us; 300us; 321us; 303us; 321us; 310us; 321us; 313us; 321us; 315us; 321us; 319us; 321us; 326us; 321us; 330us; 331us; 333us; 334us; 342us; 321us; 343us; 321us; 367us; 321us; 371us; 321us; 376us; 321us; 384us; 321us; 387us; 321us; 391us; 321us; 49us; 65535us; 22us; 318us; 37us; 318us; 41us; 318us; 91us; 318us; 135us; 318us; 137us; 329us; 160us; 329us; 165us; 318us; 178us; 318us; 182us; 318us; 206us; 318us; 208us; 329us; 214us; 318us; 217us; 318us; 219us; 318us; 221us; 318us; 223us; 318us; 232us; 318us; 237us; 318us; 242us; 318us; 260us; 318us; 265us; 318us; 271us; 318us; 274us; 318us; 276us; 318us; 279us; 318us; 284us; 318us; 287us; 318us; 289us; 318us; 291us; 318us; 295us; 318us; 297us; 318us; 300us; 318us; 303us; 318us; 310us; 318us; 313us; 318us; 315us; 318us; 319us; 318us; 326us; 318us; 330us; 329us; 333us; 329us; 342us; 318us; 343us; 318us; 367us; 318us; 371us; 318us; 376us; 318us; 384us; 318us; 387us; 318us; 391us; 318us; 2us; 65535us; 156us; 157us; 337us; 338us; 49us; 65535us; 22us; 335us; 37us; 335us; 41us; 335us; 91us; 335us; 135us; 335us; 137us; 335us; 160us; 335us; 165us; 335us; 178us; 335us; 182us; 335us; 206us; 335us; 208us; 335us; 214us; 335us; 217us; 335us; 219us; 335us; 221us; 335us; 223us; 335us; 232us; 335us; 237us; 335us; 242us; 335us; 260us; 335us; 265us; 335us; 271us; 335us; 274us; 335us; 276us; 335us; 279us; 335us; 284us; 335us; 287us; 335us; 289us; 335us; 291us; 335us; 295us; 335us; 297us; 335us; 300us; 335us; 303us; 335us; 310us; 335us; 313us; 335us; 315us; 335us; 319us; 335us; 326us; 335us; 330us; 335us; 333us; 335us; 342us; 335us; 343us; 335us; 367us; 335us; 371us; 335us; 376us; 335us; 384us; 335us; 387us; 335us; 391us; 335us; 49us; 65535us; 22us; 351us; 37us; 351us; 41us; 351us; 91us; 351us; 135us; 351us; 137us; 351us; 160us; 351us; 165us; 351us; 178us; 351us; 182us; 351us; 206us; 351us; 208us; 351us; 214us; 351us; 217us; 351us; 219us; 351us; 221us; 351us; 223us; 351us; 232us; 351us; 237us; 351us; 242us; 351us; 260us; 351us; 265us; 351us; 271us; 351us; 274us; 351us; 276us; 351us; 279us; 351us; 284us; 351us; 287us; 351us; 289us; 351us; 291us; 351us; 295us; 351us; 297us; 351us; 300us; 351us; 303us; 351us; 310us; 351us; 313us; 351us; 315us; 351us; 319us; 351us; 326us; 351us; 330us; 351us; 333us; 351us; 342us; 351us; 343us; 351us; 367us; 351us; 371us; 351us; 376us; 351us; 384us; 351us; 387us; 351us; 391us; 351us; 54us; 65535us; 22us; 332us; 37us; 332us; 41us; 332us; 91us; 332us; 135us; 332us; 137us; 332us; 155us; 156us; 160us; 332us; 165us; 332us; 178us; 332us; 182us; 332us; 206us; 332us; 208us; 332us; 214us; 332us; 217us; 332us; 219us; 332us; 221us; 332us; 223us; 332us; 232us; 332us; 237us; 332us; 242us; 332us; 249us; 250us; 253us; 254us; 260us; 332us; 265us; 332us; 271us; 332us; 274us; 332us; 276us; 332us; 279us; 332us; 284us; 332us; 287us; 332us; 289us; 332us; 291us; 332us; 295us; 332us; 297us; 332us; 300us; 332us; 303us; 332us; 310us; 332us; 313us; 332us; 315us; 332us; 319us; 332us; 326us; 332us; 330us; 332us; 333us; 332us; 336us; 337us; 342us; 332us; 343us; 332us; 352us; 353us; 367us; 332us; 371us; 332us; 376us; 332us; 384us; 332us; 387us; 332us; 391us; 332us; 3us; 65535us; 41us; 42us; 342us; 344us; 343us; 345us; 61us; 65535us; 22us; 354us; 37us; 354us; 41us; 354us; 91us; 354us; 135us; 354us; 137us; 354us; 155us; 354us; 160us; 354us; 165us; 354us; 167us; 379us; 178us; 354us; 182us; 354us; 206us; 354us; 208us; 354us; 214us; 354us; 217us; 354us; 219us; 354us; 221us; 354us; 223us; 354us; 232us; 354us; 237us; 354us; 242us; 354us; 247us; 248us; 249us; 354us; 253us; 354us; 260us; 354us; 265us; 354us; 271us; 354us; 274us; 354us; 276us; 354us; 279us; 354us; 284us; 354us; 287us; 354us; 289us; 354us; 291us; 354us; 295us; 354us; 297us; 354us; 300us; 354us; 303us; 354us; 310us; 354us; 313us; 354us; 315us; 354us; 319us; 325us; 325us; 395us; 326us; 354us; 330us; 354us; 333us; 354us; 336us; 354us; 340us; 211us; 342us; 354us; 343us; 354us; 348us; 379us; 352us; 354us; 354us; 395us; 367us; 354us; 371us; 354us; 376us; 354us; 384us; 354us; 387us; 354us; 391us; 354us; 395us; 395us; 1us; 65535us; 362us; 363us; 61us; 65535us; 22us; 362us; 37us; 362us; 41us; 362us; 91us; 362us; 135us; 362us; 137us; 362us; 155us; 362us; 160us; 362us; 165us; 362us; 167us; 362us; 178us; 362us; 182us; 362us; 206us; 362us; 208us; 362us; 214us; 362us; 217us; 362us; 219us; 362us; 221us; 362us; 223us; 362us; 232us; 362us; 237us; 362us; 242us; 362us; 247us; 362us; 249us; 362us; 253us; 362us; 260us; 362us; 265us; 362us; 271us; 362us; 274us; 362us; 276us; 362us; 279us; 362us; 284us; 362us; 287us; 362us; 289us; 362us; 291us; 362us; 295us; 362us; 297us; 362us; 300us; 362us; 303us; 362us; 310us; 362us; 313us; 362us; 315us; 362us; 319us; 362us; 325us; 362us; 326us; 362us; 330us; 362us; 333us; 362us; 336us; 362us; 340us; 362us; 342us; 362us; 343us; 362us; 348us; 362us; 352us; 362us; 354us; 362us; 367us; 362us; 371us; 362us; 376us; 362us; 384us; 362us; 387us; 362us; 391us; 362us; 395us; 362us; 0us; 65535us; 1us; 65535us; 371us; 372us; 2us; 65535us; 374us; 375us; 377us; 378us; 2us; 65535us; 167us; 349us; 348us; 349us; 1us; 65535us; 379us; 380us; 2us; 65535us; 381us; 382us; 388us; 389us; 3us; 65535us; 282us; 385us; 382us; 383us; 389us; 390us; 1us; 65535us; 368us; 369us; 1us; 65535us; 368us; 391us; 3us; 65535us; 325us; 355us; 354us; 355us; 395us; 396us; 0us; 65535us; 0us; 65535us; 80us; 65535us; 22us; 361us; 31us; 122us; 37us; 361us; 41us; 361us; 86us; 122us; 91us; 361us; 96us; 122us; 97us; 122us; 98us; 122us; 100us; 122us; 103us; 122us; 107us; 122us; 110us; 122us; 114us; 122us; 125us; 122us; 128us; 122us; 135us; 361us; 137us; 361us; 141us; 122us; 143us; 122us; 147us; 122us; 155us; 361us; 160us; 361us; 165us; 361us; 167us; 361us; 178us; 361us; 182us; 361us; 206us; 361us; 208us; 361us; 214us; 361us; 217us; 361us; 219us; 361us; 221us; 361us; 223us; 361us; 229us; 122us; 232us; 361us; 237us; 361us; 242us; 361us; 247us; 361us; 249us; 361us; 253us; 361us; 257us; 122us; 258us; 122us; 260us; 361us; 263us; 122us; 265us; 361us; 271us; 361us; 274us; 361us; 276us; 361us; 279us; 361us; 284us; 361us; 287us; 361us; 289us; 361us; 291us; 361us; 295us; 361us; 297us; 361us; 300us; 361us; 303us; 361us; 310us; 361us; 313us; 361us; 315us; 361us; 319us; 361us; 325us; 361us; 326us; 361us; 330us; 361us; 333us; 361us; 336us; 361us; 340us; 361us; 342us; 361us; 343us; 361us; 348us; 361us; 352us; 361us; 354us; 361us; 367us; 361us; 371us; 361us; 376us; 361us; 384us; 361us; 387us; 361us; 391us; 361us; 395us; 361us; |]
let _fsyacc_sparseGotoTableRowOffsets = [|0us; 1us; 3us; 6us; 9us; 11us; 13us; 15us; 18us; 21us; 24us; 27us; 29us; 32us; 33us; 36us; 39us; 42us; 45us; 48us; 50us; 53us; 57us; 61us; 66us; 74us; 80us; 83us; 89us; 91us; 98us; 118us; 138us; 140us; 160us; 162us; 163us; 166us; 169us; 172us; 177us; 182us; 184us; 187us; 189us; 192us; 194us; 198us; 203us; 269us; 356us; 364us; 468us; 573us; 659us; 748us; 816us; 818us; 820us; 824us; 826us; 831us; 843us; 862us; 865us; 868us; 892us; 895us; 900us; 902us; 927us; 953us; 979us; 1006us; 1037us; 1069us; 1106us; 1143us; 1181us; 1219us; 1221us; 1261us; 1302us; 1347us; 1348us; 1352us; 1354us; 1404us; 1454us; 1457us; 1507us; 1557us; 1612us; 1616us; 1678us; 1680us; 1742us; 1743us; 1745us; 1748us; 1751us; 1753us; 1756us; 1760us; 1762us; 1764us; 1768us; 1769us; 1770us; |]
let _fsyacc_stateToProdIdxsTableElements = [| 1us; 0us; 1us; 0us; 2us; 1us; 7us; 1us; 1us; 1us; 2us; 1us; 2us; 1us; 3us; 1us; 4us; 1us; 4us; 1us; 4us; 1us; 4us; 1us; 5us; 1us; 7us; 1us; 9us; 1us; 9us; 1us; 9us; 1us; 9us; 1us; 9us; 1us; 9us; 1us; 9us; 1us; 9us; 1us; 10us; 1us; 12us; 1us; 12us; 1us; 13us; 1us; 13us; 1us; 14us; 1us; 15us; 1us; 15us; 1us; 16us; 1us; 17us; 1us; 17us; 1us; 17us; 1us; 17us; 1us; 18us; 1us; 18us; 1us; 18us; 1us; 18us; 1us; 18us; 1us; 19us; 1us; 19us; 1us; 19us; 1us; 19us; 3us; 20us; 23us; 38us; 1us; 20us; 1us; 20us; 1us; 20us; 2us; 22us; 37us; 2us; 23us; 38us; 1us; 24us; 1us; 24us; 1us; 24us; 1us; 24us; 1us; 24us; 1us; 24us; 1us; 26us; 1us; 26us; 1us; 26us; 1us; 26us; 1us; 26us; 1us; 29us; 1us; 30us; 1us; 31us; 1us; 32us; 1us; 32us; 1us; 32us; 1us; 32us; 1us; 33us; 1us; 33us; 1us; 33us; 1us; 33us; 1us; 35us; 1us; 35us; 1us; 35us; 1us; 37us; 1us; 37us; 1us; 40us; 1us; 40us; 1us; 40us; 1us; 40us; 1us; 40us; 1us; 40us; 1us; 40us; 1us; 40us; 1us; 40us; 1us; 41us; 1us; 43us; 1us; 43us; 1us; 43us; 1us; 45us; 1us; 45us; 1us; 45us; 1us; 45us; 2us; 46us; 53us; 1us; 47us; 1us; 48us; 1us; 49us; 2us; 49us; 50us; 3us; 49us; 50us; 54us; 1us; 49us; 1us; 50us; 1us; 50us; 1us; 50us; 1us; 52us; 1us; 52us; 1us; 52us; 1us; 53us; 1us; 53us; 1us; 53us; 1us; 53us; 2us; 54us; 58us; 2us; 54us; 58us; 1us; 55us; 1us; 56us; 1us; 58us; 1us; 58us; 1us; 59us; 1us; 60us; 2us; 60us; 62us; 1us; 61us; 2us; 61us; 71us; 1us; 63us; 1us; 64us; 1us; 65us; 1us; 66us; 1us; 67us; 1us; 67us; 1us; 67us; 1us; 68us; 1us; 68us; 1us; 68us; 1us; 69us; 1us; 69us; 1us; 69us; 1us; 70us; 1us; 70us; 1us; 70us; 1us; 71us; 1us; 71us; 1us; 72us; 1us; 76us; 1us; 76us; 1us; 76us; 1us; 78us; 1us; 78us; 1us; 78us; 1us; 80us; 1us; 80us; 1us; 80us; 1us; 80us; 1us; 80us; 1us; 81us; 1us; 82us; 2us; 83us; 84us; 1us; 83us; 1us; 83us; 1us; 83us; 1us; 83us; 1us; 83us; 1us; 84us; 1us; 84us; 1us; 84us; 1us; 84us; 1us; 85us; 1us; 85us; 3us; 88us; 89us; 90us; 1us; 88us; 2us; 89us; 189us; 1us; 89us; 1us; 89us; 1us; 89us; 2us; 90us; 94us; 1us; 91us; 1us; 91us; 1us; 91us; 1us; 94us; 1us; 95us; 2us; 95us; 109us; 1us; 95us; 2us; 95us; 148us; 1us; 96us; 1us; 96us; 1us; 96us; 1us; 96us; 1us; 97us; 1us; 98us; 2us; 99us; 103us; 1us; 99us; 1us; 99us; 1us; 100us; 1us; 101us; 1us; 102us; 1us; 103us; 1us; 104us; 1us; 105us; 1us; 106us; 2us; 107us; 108us; 3us; 107us; 108us; 110us; 1us; 108us; 2us; 108us; 110us; 1us; 108us; 1us; 109us; 3us; 109us; 184us; 188us; 1us; 110us; 1us; 110us; 1us; 110us; 1us; 112us; 1us; 112us; 1us; 114us; 1us; 114us; 1us; 115us; 1us; 116us; 1us; 117us; 2us; 118us; 119us; 1us; 119us; 1us; 119us; 1us; 120us; 1us; 121us; 1us; 121us; 1us; 121us; 1us; 121us; 1us; 121us; 1us; 121us; 1us; 122us; 1us; 122us; 1us; 122us; 1us; 122us; 2us; 122us; 135us; 1us; 123us; 1us; 123us; 1us; 123us; 1us; 123us; 1us; 123us; 1us; 123us; 1us; 124us; 1us; 124us; 1us; 124us; 1us; 124us; 1us; 124us; 1us; 125us; 1us; 125us; 1us; 125us; 1us; 125us; 1us; 125us; 1us; 126us; 1us; 126us; 2us; 126us; 135us; 1us; 127us; 1us; 127us; 1us; 129us; 1us; 129us; 1us; 129us; 1us; 129us; 1us; 131us; 1us; 131us; 1us; 131us; 1us; 132us; 1us; 133us; 1us; 133us; 1us; 133us; 1us; 133us; 1us; 133us; 1us; 135us; 1us; 136us; 1us; 136us; 1us; 136us; 1us; 136us; 1us; 137us; 1us; 138us; 1us; 139us; 2us; 140us; 141us; 1us; 140us; 1us; 140us; 3us; 142us; 143us; 144us; 1us; 142us; 1us; 142us; 1us; 144us; 2us; 144us; 146us; 2us; 145us; 146us; 1us; 146us; 2us; 146us; 148us; 2us; 147us; 148us; 2us; 148us; 214us; 2us; 148us; 215us; 1us; 148us; 4us; 148us; 150us; 151us; 152us; 4us; 149us; 150us; 151us; 152us; 1us; 150us; 1us; 150us; 1us; 151us; 1us; 151us; 1us; 152us; 1us; 152us; 1us; 153us; 3us; 154us; 155us; 156us; 1us; 154us; 1us; 154us; 1us; 156us; 2us; 156us; 158us; 2us; 157us; 158us; 1us; 158us; 2us; 158us; 166us; 2us; 159us; 160us; 1us; 160us; 2us; 160us; 166us; 2us; 161us; 166us; 1us; 162us; 1us; 163us; 1us; 164us; 1us; 165us; 1us; 166us; 3us; 166us; 168us; 169us; 3us; 167us; 168us; 169us; 1us; 168us; 1us; 168us; 1us; 169us; 1us; 169us; 1us; 170us; 2us; 171us; 181us; 1us; 171us; 1us; 171us; 1us; 172us; 1us; 176us; 1us; 177us; 1us; 178us; 2us; 179us; 193us; 1us; 179us; 1us; 179us; 1us; 180us; 1us; 181us; 1us; 181us; 1us; 181us; 2us; 182us; 192us; 1us; 182us; 1us; 182us; 1us; 183us; 2us; 184us; 188us; 2us; 184us; 188us; 1us; 184us; 2us; 185us; 197us; 1us; 185us; 1us; 185us; 1us; 187us; 2us; 187us; 188us; 1us; 187us; 2us; 187us; 188us; 1us; 187us; 2us; 187us; 188us; 1us; 189us; 1us; 189us; 1us; 189us; 1us; 190us; 1us; 191us; 1us; 191us; 1us; 193us; 1us; 193us; 1us; 194us; 1us; 195us; 1us; 196us; 1us; 197us; 1us; 198us; 1us; 199us; 1us; 200us; 2us; 200us; 202us; 1us; 202us; 1us; 202us; 1us; 203us; 1us; 204us; 1us; 204us; 1us; 204us; 1us; 204us; 1us; 205us; 1us; 205us; 1us; 205us; 1us; 209us; 1us; 209us; 1us; 211us; 1us; 211us; 1us; 211us; 1us; 212us; 1us; 212us; 1us; 213us; 1us; 213us; 1us; 213us; 1us; 214us; 1us; 214us; 1us; 215us; 1us; 215us; 1us; 217us; 1us; 217us; 1us; 217us; 1us; 219us; 1us; 219us; 1us; 220us; 1us; 221us; 1us; 223us; 1us; 223us; 1us; 228us; 1us; 229us; 1us; 230us; 1us; 231us; 1us; 232us; 1us; 233us; 1us; 234us; 1us; 235us; 1us; 236us; 1us; 237us; 1us; 238us; 1us; 239us; 1us; 240us; 1us; 241us; 1us; 242us; 1us; 243us; 1us; 244us; 1us; 245us; 1us; 246us; 1us; 247us; 1us; 248us; |]
let _fsyacc_stateToProdIdxsTableRowOffsets = [|0us; 2us; 4us; 7us; 9us; 11us; 13us; 15us; 17us; 19us; 21us; 23us; 25us; 27us; 29us; 31us; 33us; 35us; 37us; 39us; 41us; 43us; 45us; 47us; 49us; 51us; 53us; 55us; 57us; 59us; 61us; 63us; 65us; 67us; 69us; 71us; 73us; 75us; 77us; 79us; 81us; 83us; 85us; 87us; 91us; 93us; 95us; 97us; 100us; 103us; 105us; 107us; 109us; 111us; 113us; 115us; 117us; 119us; 121us; 123us; 125us; 127us; 129us; 131us; 133us; 135us; 137us; 139us; 141us; 143us; 145us; 147us; 149us; 151us; 153us; 155us; 157us; 159us; 161us; 163us; 165us; 167us; 169us; 171us; 173us; 175us; 177us; 179us; 181us; 183us; 185us; 187us; 189us; 191us; 194us; 196us; 198us; 200us; 203us; 207us; 209us; 211us; 213us; 215us; 217us; 219us; 221us; 223us; 225us; 227us; 229us; 232us; 235us; 237us; 239us; 241us; 243us; 245us; 247us; 250us; 252us; 255us; 257us; 259us; 261us; 263us; 265us; 267us; 269us; 271us; 273us; 275us; 277us; 279us; 281us; 283us; 285us; 287us; 289us; 291us; 293us; 295us; 297us; 299us; 301us; 303us; 305us; 307us; 309us; 311us; 313us; 315us; 317us; 319us; 322us; 324us; 326us; 328us; 330us; 332us; 334us; 336us; 338us; 340us; 342us; 344us; 348us; 350us; 353us; 355us; 357us; 359us; 362us; 364us; 366us; 368us; 370us; 372us; 375us; 377us; 380us; 382us; 384us; 386us; 388us; 390us; 392us; 395us; 397us; 399us; 401us; 403us; 405us; 407us; 409us; 411us; 413us; 416us; 420us; 422us; 425us; 427us; 429us; 433us; 435us; 437us; 439us; 441us; 443us; 445us; 447us; 449us; 451us; 453us; 456us; 458us; 460us; 462us; 464us; 466us; 468us; 470us; 472us; 474us; 476us; 478us; 480us; 482us; 485us; 487us; 489us; 491us; 493us; 495us; 497us; 499us; 501us; 503us; 505us; 507us; 509us; 511us; 513us; 515us; 517us; 519us; 521us; 524us; 526us; 528us; 530us; 532us; 534us; 536us; 538us; 540us; 542us; 544us; 546us; 548us; 550us; 552us; 554us; 556us; 558us; 560us; 562us; 564us; 566us; 568us; 570us; 573us; 575us; 577us; 581us; 583us; 585us; 587us; 590us; 593us; 595us; 598us; 601us; 604us; 607us; 609us; 614us; 619us; 621us; 623us; 625us; 627us; 629us; 631us; 633us; 637us; 639us; 641us; 643us; 646us; 649us; 651us; 654us; 657us; 659us; 662us; 665us; 667us; 669us; 671us; 673us; 675us; 679us; 683us; 685us; 687us; 689us; 691us; 693us; 696us; 698us; 700us; 702us; 704us; 706us; 708us; 711us; 713us; 715us; 717us; 719us; 721us; 723us; 726us; 728us; 730us; 732us; 735us; 738us; 740us; 743us; 745us; 747us; 749us; 752us; 754us; 757us; 759us; 762us; 764us; 766us; 768us; 770us; 772us; 774us; 776us; 778us; 780us; 782us; 784us; 786us; 788us; 790us; 792us; 795us; 797us; 799us; 801us; 803us; 805us; 807us; 809us; 811us; 813us; 815us; 817us; 819us; 821us; 823us; 825us; 827us; 829us; 831us; 833us; 835us; 837us; 839us; 841us; 843us; 845us; 847us; 849us; 851us; 853us; 855us; 857us; 859us; 861us; 863us; 865us; 867us; 869us; 871us; 873us; 875us; 877us; 879us; 881us; 883us; 885us; 887us; 889us; 891us; 893us; 895us; 897us; 899us; 901us; |]
let _fsyacc_action_rows = 418
let _fsyacc_actionTableElements = [|0us; 16392us; 0us; 49152us; 4us; 32768us; 10us; 6us; 133us; 7us; 145us; 13us; 146us; 21us; 0us; 16385us; 2us; 32768us; 10us; 6us; 133us; 7us; 0us; 16386us; 0us; 16387us; 1us; 32768us; 186us; 194us; 10us; 16395us; 12us; 43us; 41us; 22us; 82us; 27us; 90us; 16420us; 91us; 16405us; 141us; 60us; 142us; 61us; 143us; 62us; 144us; 47us; 152us; 30us; 1us; 16390us; 120us; 11us; 0us; 16388us; 0us; 16389us; 0us; 16391us; 1us; 32768us; 74us; 14us; 2us; 32768us; 186us; 194us; 187us; 193us; 1us; 32768us; 78us; 16us; 2us; 32768us; 186us; 194us; 187us; 193us; 1us; 32768us; 78us; 18us; 2us; 32768us; 186us; 194us; 187us; 193us; 1us; 32768us; 75us; 20us; 0us; 16393us; 0us; 16394us; 38us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 96us; 223us; 102us; 417us; 104us; 257us; 105us; 244us; 106us; 217us; 112us; 358us; 139us; 234us; 140us; 239us; 141us; 247us; 152us; 228us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16396us; 10us; 16395us; 12us; 43us; 41us; 22us; 82us; 27us; 90us; 16420us; 91us; 16405us; 141us; 60us; 142us; 61us; 143us; 62us; 144us; 47us; 152us; 30us; 0us; 16397us; 0us; 16398us; 1us; 32768us; 186us; 194us; 0us; 16399us; 0us; 16400us; 1us; 16426us; 85us; 85us; 28us; 32768us; 39us; 121us; 44us; 125us; 47us; 131us; 74us; 128us; 76us; 397us; 88us; 416us; 102us; 417us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 16428us; 110us; 86us; 0us; 16401us; 1us; 32768us; 91us; 35us; 2us; 32768us; 186us; 194us; 187us; 193us; 1us; 32768us; 52us; 37us; 31us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 104us; 257us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16402us; 1us; 32768us; 186us; 194us; 1us; 32768us; 52us; 41us; 38us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 96us; 223us; 102us; 417us; 104us; 257us; 105us; 244us; 106us; 217us; 112us; 358us; 139us; 234us; 140us; 239us; 141us; 247us; 152us; 228us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16403us; 2us; 32768us; 13us; 44us; 186us; 194us; 1us; 32768us; 186us; 194us; 1us; 32768us; 47us; 49us; 0us; 16404us; 1us; 16406us; 187us; 193us; 1us; 16407us; 90us; 16422us; 1us; 32768us; 187us; 193us; 1us; 32768us; 43us; 51us; 1us; 32768us; 188us; 52us; 1us; 16409us; 59us; 55us; 1us; 32768us; 33us; 54us; 0us; 16408us; 1us; 32768us; 187us; 193us; 1us; 32768us; 43us; 57us; 1us; 32768us; 188us; 58us; 1us; 16409us; 59us; 55us; 0us; 16410us; 0us; 16413us; 0us; 16414us; 0us; 16415us; 1us; 32768us; 90us; 64us; 2us; 32768us; 186us; 194us; 187us; 193us; 1us; 16418us; 110us; 71us; 0us; 16416us; 3us; 16470us; 74us; 153us; 185us; 195us; 187us; 193us; 1us; 16497us; 52us; 208us; 1us; 16471us; 43us; 165us; 0us; 16417us; 2us; 32768us; 186us; 194us; 187us; 193us; 1us; 16418us; 110us; 71us; 0us; 16419us; 1us; 16423us; 74us; 76us; 0us; 16421us; 1us; 32768us; 186us; 194us; 1us; 32768us; 78us; 78us; 1us; 32768us; 186us; 194us; 1us; 32768us; 78us; 80us; 1us; 32768us; 186us; 194us; 1us; 32768us; 78us; 82us; 1us; 32768us; 186us; 194us; 1us; 32768us; 75us; 84us; 0us; 16424us; 0us; 16425us; 28us; 32768us; 39us; 121us; 44us; 125us; 47us; 131us; 74us; 128us; 76us; 397us; 88us; 416us; 102us; 417us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 16428us; 110us; 86us; 0us; 16427us; 1us; 16495us; 52us; 206us; 1us; 32768us; 43us; 91us; 38us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 96us; 223us; 102us; 417us; 104us; 257us; 105us; 244us; 106us; 217us; 112us; 358us; 139us; 234us; 140us; 239us; 141us; 247us; 152us; 228us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16429us; 1us; 16430us; 78us; 107us; 0us; 16431us; 0us; 16432us; 28us; 16441us; 39us; 121us; 44us; 125us; 47us; 131us; 74us; 128us; 76us; 397us; 88us; 416us; 102us; 417us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 29us; 16441us; 39us; 121us; 44us; 125us; 47us; 131us; 53us; 100us; 74us; 128us; 76us; 397us; 88us; 416us; 102us; 417us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 29us; 16441us; 39us; 121us; 44us; 125us; 47us; 131us; 53us; 100us; 74us; 128us; 76us; 397us; 88us; 416us; 102us; 417us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16433us; 28us; 32768us; 39us; 121us; 44us; 125us; 47us; 131us; 74us; 128us; 76us; 397us; 88us; 416us; 102us; 417us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 16435us; 53us; 103us; 0us; 16434us; 28us; 32768us; 39us; 121us; 44us; 125us; 47us; 131us; 74us; 128us; 76us; 397us; 88us; 416us; 102us; 417us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 16435us; 53us; 103us; 0us; 16436us; 1us; 32768us; 78us; 107us; 28us; 32768us; 39us; 121us; 44us; 125us; 47us; 131us; 74us; 128us; 76us; 397us; 88us; 416us; 102us; 417us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 16461us; 78us; 143us; 0us; 16437us; 28us; 16441us; 39us; 121us; 44us; 125us; 47us; 131us; 74us; 128us; 76us; 397us; 88us; 416us; 102us; 417us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 16438us; 78us; 16442us; 0us; 16439us; 0us; 16440us; 28us; 16441us; 39us; 121us; 44us; 125us; 47us; 131us; 74us; 128us; 76us; 397us; 88us; 416us; 102us; 417us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16442us; 0us; 16443us; 0us; 16444us; 1us; 16444us; 52us; 16446us; 0us; 16445us; 1us; 16445us; 52us; 137us; 0us; 16447us; 0us; 16448us; 0us; 16449us; 0us; 16450us; 28us; 16459us; 39us; 121us; 44us; 125us; 47us; 131us; 74us; 128us; 76us; 397us; 88us; 416us; 102us; 417us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 32768us; 32us; 127us; 0us; 16451us; 28us; 32768us; 39us; 121us; 44us; 125us; 47us; 131us; 74us; 128us; 76us; 397us; 88us; 416us; 102us; 417us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 32768us; 75us; 130us; 0us; 16452us; 2us; 16463us; 186us; 194us; 187us; 193us; 1us; 32768us; 33us; 133us; 0us; 16453us; 1us; 32768us; 52us; 135us; 31us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 104us; 257us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16454us; 30us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16455us; 0us; 16456us; 1us; 32768us; 59us; 141us; 28us; 16459us; 39us; 121us; 44us; 125us; 47us; 131us; 74us; 128us; 76us; 397us; 88us; 416us; 102us; 417us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16460us; 28us; 32768us; 39us; 121us; 44us; 125us; 47us; 131us; 74us; 128us; 76us; 397us; 88us; 416us; 102us; 417us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 16461us; 78us; 143us; 0us; 16462us; 1us; 32768us; 43us; 147us; 28us; 32768us; 39us; 121us; 44us; 125us; 47us; 131us; 74us; 128us; 76us; 397us; 88us; 416us; 102us; 417us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 32768us; 59us; 149us; 2us; 16463us; 186us; 194us; 187us; 193us; 0us; 16464us; 0us; 16465us; 0us; 16466us; 2us; 32768us; 185us; 195us; 187us; 193us; 1us; 32768us; 52us; 155us; 28us; 32768us; 39us; 357us; 44us; 371us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 16570us; 47us; 342us; 1us; 32768us; 75us; 158us; 0us; 16467us; 1us; 32768us; 52us; 160us; 30us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 32768us; 75us; 162us; 0us; 16468us; 3us; 16470us; 74us; 153us; 185us; 195us; 187us; 193us; 0us; 16469us; 31us; 16477us; 39us; 357us; 44us; 371us; 47us; 167us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 104us; 257us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16472us; 28us; 32768us; 39us; 357us; 44us; 371us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 16476us; 59us; 172us; 1us; 32768us; 33us; 170us; 0us; 16473us; 1us; 16474us; 31us; 180us; 1us; 32768us; 187us; 193us; 1us; 16476us; 59us; 172us; 0us; 16475us; 0us; 16478us; 1us; 32768us; 52us; 178us; 1us; 16493us; 52us; 178us; 30us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 16479us; 78us; 284us; 1us; 32768us; 186us; 194us; 1us; 32768us; 52us; 182us; 31us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 104us; 257us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16480us; 0us; 16481us; 0us; 16482us; 1us; 16487us; 51us; 187us; 2us; 32768us; 186us; 194us; 187us; 193us; 0us; 16483us; 0us; 16484us; 0us; 16485us; 0us; 16486us; 0us; 16487us; 0us; 16488us; 0us; 16489us; 0us; 16490us; 1us; 16491us; 51us; 198us; 1us; 16491us; 51us; 199us; 1us; 32768us; 186us; 194us; 2us; 32768us; 186us; 194us; 187us; 193us; 0us; 16492us; 0us; 16493us; 1us; 16493us; 52us; 336us; 1us; 32768us; 51us; 204us; 2us; 32768us; 186us; 194us; 187us; 193us; 0us; 16494us; 30us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16496us; 30us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16498us; 0us; 16499us; 0us; 16500us; 0us; 16501us; 1us; 16502us; 59us; 214us; 38us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 96us; 223us; 102us; 417us; 104us; 257us; 105us; 244us; 106us; 217us; 112us; 358us; 139us; 234us; 140us; 239us; 141us; 247us; 152us; 228us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16503us; 0us; 16504us; 38us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 96us; 223us; 102us; 417us; 104us; 257us; 105us; 244us; 106us; 217us; 112us; 358us; 139us; 234us; 140us; 239us; 141us; 247us; 152us; 228us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 32768us; 86us; 219us; 38us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 96us; 223us; 102us; 417us; 104us; 257us; 105us; 244us; 106us; 217us; 112us; 358us; 139us; 234us; 140us; 239us; 141us; 247us; 152us; 228us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 32768us; 118us; 221us; 38us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 96us; 223us; 102us; 417us; 104us; 257us; 105us; 244us; 106us; 217us; 112us; 358us; 139us; 234us; 140us; 239us; 141us; 247us; 152us; 228us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16505us; 38us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 96us; 223us; 102us; 417us; 104us; 257us; 105us; 244us; 106us; 217us; 112us; 358us; 139us; 234us; 140us; 239us; 141us; 247us; 152us; 228us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 32768us; 69us; 225us; 1us; 32768us; 31us; 263us; 0us; 16518us; 1us; 16506us; 31us; 263us; 1us; 16426us; 85us; 85us; 28us; 32768us; 39us; 121us; 44us; 125us; 47us; 131us; 74us; 128us; 76us; 397us; 88us; 416us; 102us; 417us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 16428us; 110us; 86us; 1us; 32768us; 107us; 232us; 38us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 96us; 223us; 102us; 417us; 104us; 257us; 105us; 244us; 106us; 217us; 112us; 358us; 139us; 234us; 140us; 239us; 141us; 247us; 152us; 228us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16507us; 3us; 16470us; 74us; 153us; 185us; 195us; 187us; 193us; 1us; 32768us; 51us; 236us; 1us; 16512us; 18us; 249us; 38us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 96us; 223us; 102us; 417us; 104us; 257us; 105us; 244us; 106us; 217us; 112us; 358us; 139us; 234us; 140us; 239us; 141us; 247us; 152us; 228us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16508us; 3us; 16470us; 74us; 153us; 185us; 195us; 187us; 193us; 1us; 32768us; 51us; 241us; 1us; 16512us; 18us; 249us; 38us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 96us; 223us; 102us; 417us; 104us; 257us; 105us; 244us; 106us; 217us; 112us; 358us; 139us; 234us; 140us; 239us; 141us; 247us; 152us; 228us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16509us; 1us; 32768us; 31us; 263us; 0us; 16518us; 1us; 16510us; 31us; 263us; 28us; 32768us; 39us; 357us; 44us; 371us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16511us; 28us; 32768us; 39us; 357us; 44us; 371us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 16514us; 59us; 253us; 1us; 32768us; 33us; 252us; 0us; 16513us; 28us; 32768us; 39us; 357us; 44us; 371us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 16514us; 59us; 253us; 0us; 16515us; 0us; 16516us; 28us; 32768us; 39us; 121us; 44us; 125us; 47us; 131us; 74us; 128us; 76us; 397us; 88us; 416us; 102us; 417us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 28us; 16441us; 39us; 121us; 44us; 125us; 47us; 131us; 74us; 128us; 76us; 397us; 88us; 416us; 102us; 417us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 3us; 32768us; 79us; 267us; 81us; 268us; 128us; 269us; 38us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 96us; 223us; 102us; 417us; 104us; 257us; 105us; 244us; 106us; 217us; 112us; 358us; 139us; 234us; 140us; 239us; 141us; 247us; 152us; 228us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16517us; 0us; 16519us; 28us; 32768us; 39us; 121us; 44us; 125us; 47us; 131us; 74us; 128us; 76us; 397us; 88us; 416us; 102us; 417us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 32768us; 79us; 265us; 38us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 96us; 223us; 102us; 417us; 104us; 257us; 105us; 244us; 106us; 217us; 112us; 358us; 139us; 234us; 140us; 239us; 141us; 247us; 152us; 228us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16520us; 0us; 16521us; 0us; 16522us; 0us; 16523us; 1us; 16525us; 63us; 271us; 30us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16524us; 2us; 16527us; 64us; 274us; 66us; 276us; 30us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16526us; 30us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 16528us; 65us; 279us; 1us; 16529us; 65us; 279us; 30us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 16530us; 78us; 284us; 1us; 16531us; 78us; 284us; 2us; 16600us; 59us; 388us; 78us; 284us; 1us; 16599us; 78us; 284us; 30us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 3us; 16532us; 43us; 287us; 58us; 291us; 127us; 289us; 3us; 16533us; 43us; 287us; 58us; 291us; 127us; 289us; 30us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16534us; 30us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16535us; 30us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16536us; 0us; 16537us; 2us; 16539us; 53us; 295us; 122us; 297us; 30us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16538us; 30us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 16540us; 72us; 300us; 1us; 16541us; 72us; 300us; 30us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 16542us; 174us; 310us; 4us; 16543us; 123us; 308us; 124us; 309us; 125us; 306us; 126us; 307us; 30us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 16544us; 174us; 310us; 1us; 16545us; 174us; 310us; 0us; 16546us; 0us; 16547us; 0us; 16548us; 0us; 16549us; 30us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 2us; 16550us; 77us; 313us; 177us; 315us; 2us; 16551us; 77us; 313us; 177us; 315us; 30us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16552us; 30us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16553us; 0us; 16554us; 4us; 32768us; 77us; 319us; 79us; 322us; 81us; 323us; 128us; 324us; 30us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16555us; 0us; 16556us; 0us; 16560us; 0us; 16561us; 0us; 16562us; 29us; 16606us; 39us; 357us; 44us; 371us; 74us; 367us; 76us; 397us; 77us; 326us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 30us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16563us; 0us; 16564us; 3us; 32768us; 79us; 322us; 81us; 323us; 128us; 324us; 30us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16565us; 3us; 16576us; 79us; 322us; 81us; 323us; 128us; 324us; 30us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16566us; 0us; 16567us; 28us; 32768us; 39us; 357us; 44us; 371us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 16570us; 47us; 343us; 0us; 16568us; 1us; 16581us; 52us; 340us; 28us; 32768us; 39us; 357us; 44us; 371us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16569us; 38us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 96us; 223us; 102us; 417us; 104us; 257us; 105us; 244us; 106us; 217us; 112us; 358us; 139us; 234us; 140us; 239us; 141us; 247us; 152us; 228us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 38us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 96us; 223us; 102us; 417us; 104us; 257us; 105us; 244us; 106us; 217us; 112us; 358us; 139us; 234us; 140us; 239us; 141us; 247us; 152us; 228us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 32768us; 33us; 346us; 1us; 32768us; 33us; 347us; 0us; 16571us; 42us; 16571us; 10us; 16572us; 12us; 16572us; 31us; 16572us; 32us; 16572us; 33us; 16572us; 41us; 16572us; 43us; 16572us; 53us; 16572us; 58us; 16572us; 59us; 16572us; 63us; 16572us; 64us; 16572us; 65us; 16572us; 66us; 16572us; 69us; 16572us; 72us; 16572us; 75us; 16572us; 78us; 16572us; 82us; 16572us; 86us; 16572us; 90us; 16572us; 91us; 16572us; 107us; 16572us; 110us; 16572us; 118us; 16572us; 120us; 16572us; 122us; 16572us; 123us; 16572us; 124us; 16572us; 125us; 16572us; 126us; 16572us; 127us; 16572us; 133us; 16572us; 137us; 16572us; 138us; 16572us; 141us; 16572us; 142us; 16572us; 143us; 16572us; 144us; 16572us; 152us; 16572us; 174us; 16572us; 177us; 16572us; 28us; 32768us; 39us; 357us; 44us; 371us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 32768us; 33us; 350us; 0us; 16573us; 0us; 16574us; 28us; 32768us; 39us; 357us; 44us; 371us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16575us; 28us; 16606us; 39us; 357us; 44us; 371us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16577us; 0us; 16578us; 0us; 16579us; 0us; 16580us; 0us; 16581us; 0us; 16582us; 0us; 16583us; 0us; 16585us; 1us; 16584us; 51us; 364us; 1us; 32768us; 187us; 193us; 0us; 16586us; 0us; 16587us; 38us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 96us; 223us; 102us; 417us; 104us; 257us; 105us; 244us; 106us; 217us; 112us; 358us; 139us; 234us; 140us; 239us; 141us; 247us; 152us; 228us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 2us; 16602us; 137us; 393us; 138us; 394us; 1us; 32768us; 75us; 370us; 0us; 16588us; 38us; 16592us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 96us; 223us; 102us; 417us; 104us; 257us; 105us; 244us; 106us; 217us; 112us; 358us; 139us; 234us; 140us; 239us; 141us; 247us; 152us; 228us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 32768us; 32us; 373us; 0us; 16589us; 1us; 16594us; 59us; 376us; 0us; 16593us; 38us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 96us; 223us; 102us; 417us; 104us; 257us; 105us; 244us; 106us; 217us; 112us; 358us; 139us; 234us; 140us; 239us; 141us; 247us; 152us; 228us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 1us; 16594us; 59us; 376us; 0us; 16595us; 2us; 32768us; 43us; 384us; 69us; 381us; 0us; 16596us; 2us; 32768us; 186us; 194us; 187us; 193us; 1us; 16600us; 59us; 388us; 0us; 16597us; 30us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16598us; 1us; 32768us; 43us; 387us; 30us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 2us; 32768us; 186us; 194us; 187us; 193us; 1us; 16600us; 59us; 388us; 0us; 16601us; 31us; 32768us; 39us; 357us; 44us; 371us; 47us; 348us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 104us; 257us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 174us; 352us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16603us; 0us; 16604us; 0us; 16605us; 28us; 16606us; 39us; 357us; 44us; 371us; 74us; 367us; 76us; 397us; 88us; 416us; 102us; 417us; 112us; 358us; 155us; 411us; 156us; 413us; 157us; 412us; 158us; 410us; 159us; 409us; 160us; 408us; 161us; 406us; 162us; 407us; 163us; 405us; 164us; 403us; 165us; 401us; 166us; 399us; 167us; 404us; 168us; 402us; 170us; 400us; 171us; 398us; 185us; 195us; 186us; 194us; 187us; 193us; 188us; 414us; 189us; 415us; 0us; 16607us; 0us; 16612us; 0us; 16613us; 0us; 16614us; 0us; 16615us; 0us; 16616us; 0us; 16617us; 0us; 16618us; 0us; 16619us; 0us; 16620us; 0us; 16621us; 0us; 16622us; 0us; 16623us; 0us; 16624us; 0us; 16625us; 0us; 16626us; 0us; 16627us; 0us; 16628us; 0us; 16629us; 0us; 16630us; 0us; 16631us; 0us; 16632us; |]
let _fsyacc_actionTableRowOffsets = [|0us; 1us; 2us; 7us; 8us; 11us; 12us; 13us; 15us; 26us; 28us; 29us; 30us; 31us; 33us; 36us; 38us; 41us; 43us; 46us; 48us; 49us; 50us; 89us; 90us; 101us; 102us; 103us; 105us; 106us; 107us; 109us; 138us; 140us; 141us; 143us; 146us; 148us; 180us; 181us; 183us; 185us; 224us; 225us; 228us; 230us; 232us; 233us; 235us; 237us; 239us; 241us; 243us; 245us; 247us; 248us; 250us; 252us; 254us; 256us; 257us; 258us; 259us; 260us; 262us; 265us; 267us; 268us; 272us; 274us; 276us; 277us; 280us; 282us; 283us; 285us; 286us; 288us; 290us; 292us; 294us; 296us; 298us; 300us; 302us; 303us; 304us; 333us; 335us; 336us; 338us; 340us; 379us; 380us; 382us; 383us; 384us; 413us; 443us; 473us; 474us; 503us; 505us; 506us; 535us; 537us; 538us; 540us; 569us; 571us; 572us; 601us; 603us; 604us; 605us; 634us; 635us; 636us; 637us; 639us; 640us; 642us; 643us; 644us; 645us; 646us; 675us; 677us; 678us; 707us; 709us; 710us; 713us; 715us; 716us; 718us; 750us; 751us; 782us; 783us; 784us; 786us; 815us; 816us; 845us; 847us; 848us; 850us; 879us; 881us; 884us; 885us; 886us; 887us; 890us; 892us; 921us; 923us; 925us; 926us; 928us; 959us; 961us; 962us; 966us; 967us; 999us; 1000us; 1029us; 1031us; 1033us; 1034us; 1036us; 1038us; 1040us; 1041us; 1042us; 1044us; 1046us; 1077us; 1079us; 1081us; 1083us; 1115us; 1116us; 1117us; 1118us; 1120us; 1123us; 1124us; 1125us; 1126us; 1127us; 1128us; 1129us; 1130us; 1131us; 1133us; 1135us; 1137us; 1140us; 1141us; 1142us; 1144us; 1146us; 1149us; 1150us; 1181us; 1182us; 1213us; 1214us; 1215us; 1216us; 1217us; 1219us; 1258us; 1259us; 1260us; 1299us; 1301us; 1340us; 1342us; 1381us; 1382us; 1421us; 1423us; 1425us; 1426us; 1428us; 1430us; 1459us; 1461us; 1463us; 1502us; 1503us; 1507us; 1509us; 1511us; 1550us; 1551us; 1555us; 1557us; 1559us; 1598us; 1599us; 1601us; 1602us; 1604us; 1633us; 1634us; 1663us; 1665us; 1667us; 1668us; 1697us; 1699us; 1700us; 1701us; 1730us; 1759us; 1763us; 1802us; 1803us; 1804us; 1833us; 1835us; 1874us; 1875us; 1876us; 1877us; 1878us; 1880us; 1911us; 1912us; 1915us; 1946us; 1947us; 1978us; 1980us; 1982us; 2013us; 2015us; 2017us; 2020us; 2022us; 2053us; 2057us; 2061us; 2092us; 2093us; 2124us; 2125us; 2156us; 2157us; 2158us; 2161us; 2192us; 2193us; 2224us; 2226us; 2228us; 2259us; 2261us; 2266us; 2297us; 2299us; 2301us; 2302us; 2303us; 2304us; 2305us; 2336us; 2339us; 2342us; 2373us; 2374us; 2405us; 2406us; 2407us; 2412us; 2443us; 2444us; 2445us; 2446us; 2447us; 2448us; 2478us; 2509us; 2510us; 2511us; 2515us; 2546us; 2547us; 2551us; 2582us; 2583us; 2584us; 2613us; 2615us; 2616us; 2618us; 2647us; 2648us; 2687us; 2726us; 2728us; 2730us; 2731us; 2774us; 2803us; 2805us; 2806us; 2807us; 2836us; 2837us; 2866us; 2867us; 2868us; 2869us; 2870us; 2871us; 2872us; 2873us; 2874us; 2876us; 2878us; 2879us; 2880us; 2919us; 2922us; 2924us; 2925us; 2964us; 2966us; 2967us; 2969us; 2970us; 3009us; 3011us; 3012us; 3015us; 3016us; 3019us; 3021us; 3022us; 3053us; 3054us; 3056us; 3087us; 3090us; 3092us; 3093us; 3125us; 3126us; 3127us; 3128us; 3157us; 3158us; 3159us; 3160us; 3161us; 3162us; 3163us; 3164us; 3165us; 3166us; 3167us; 3168us; 3169us; 3170us; 3171us; 3172us; 3173us; 3174us; 3175us; 3176us; 3177us; 3178us; |]
let _fsyacc_reductionSymbolCounts = [|1us; 2us; 2us; 1us; 4us; 1us; 0us; 2us; 0us; 8us; 1us; 0us; 2us; 2us; 1us; 2us; 1us; 4us; 5us; 4us; 4us; 0us; 1us; 2us; 6us; 0us; 5us; 0us; 1us; 1us; 1us; 1us; 4us; 4us; 0us; 3us; 0us; 3us; 2us; 0us; 9us; 1us; 0us; 3us; 0us; 4us; 1us; 1us; 1us; 2us; 4us; 0us; 3us; 4us; 3us; 1us; 1us; 0us; 2us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 3us; 3us; 3us; 3us; 3us; 1us; 0us; 2us; 0us; 3us; 0us; 3us; 0us; 5us; 1us; 1us; 6us; 5us; 2us; 0us; 0us; 2us; 5us; 2us; 3us; 0us; 0us; 2us; 3us; 4us; 1us; 1us; 3us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 3us; 1us; 3us; 0us; 2us; 0us; 2us; 1us; 1us; 1us; 1us; 3us; 1us; 6us; 5us; 6us; 5us; 5us; 3us; 2us; 0us; 4us; 0us; 3us; 1us; 5us; 0us; 2us; 4us; 1us; 1us; 1us; 3us; 1us; 3us; 1us; 3us; 1us; 3us; 1us; 3us; 1us; 3us; 3us; 3us; 1us; 3us; 1us; 3us; 1us; 3us; 1us; 3us; 1us; 1us; 1us; 1us; 1us; 3us; 1us; 3us; 3us; 1us; 3us; 1us; 3us; 3us; 1us; 1us; 1us; 1us; 3us; 1us; 3us; 3us; 1us; 4us; 3us; 0us; 3us; 6us; 3us; 1us; 2us; 1us; 2us; 1us; 1us; 1us; 1us; 1us; 1us; 2us; 0us; 3us; 1us; 4us; 3us; 3us; 1us; 0us; 2us; 0us; 3us; 2us; 3us; 3us; 3us; 0us; 3us; 0us; 2us; 1us; 1us; 0us; 2us; 0us; 3us; 0us; 3us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; |]
let _fsyacc_productionToNonTerminalTable = [|0us; 1us; 2us; 2us; 3us; 4us; 4us; 5us; 5us; 6us; 6us; 7us; 7us; 7us; 8us; 9us; 9us; 9us; 9us; 9us; 9us; 10us; 10us; 10us; 11us; 12us; 12us; 13us; 13us; 14us; 14us; 14us; 15us; 16us; 17us; 17us; 18us; 18us; 18us; 19us; 19us; 20us; 20us; 21us; 21us; 22us; 23us; 23us; 23us; 24us; 25us; 26us; 26us; 27us; 28us; 28us; 28us; 29us; 29us; 30us; 31us; 31us; 32us; 33us; 33us; 33us; 33us; 33us; 33us; 33us; 34us; 34us; 34us; 35us; 35us; 36us; 36us; 37us; 37us; 38us; 38us; 39us; 39us; 39us; 39us; 40us; 40us; 41us; 41us; 41us; 41us; 42us; 42us; 43us; 43us; 44us; 45us; 46us; 47us; 47us; 48us; 49us; 50us; 50us; 51us; 52us; 53us; 54us; 54us; 55us; 55us; 56us; 56us; 57us; 57us; 58us; 59us; 60us; 61us; 61us; 62us; 62us; 62us; 62us; 62us; 62us; 62us; 62us; 63us; 63us; 64us; 64us; 65us; 65us; 66us; 66us; 67us; 68us; 68us; 68us; 69us; 69us; 70us; 70us; 71us; 71us; 72us; 72us; 73us; 73us; 74us; 74us; 74us; 74us; 75us; 75us; 76us; 76us; 77us; 77us; 78us; 78us; 79us; 79us; 79us; 79us; 80us; 80us; 81us; 81us; 81us; 82us; 82us; 83us; 83us; 83us; 84us; 84us; 84us; 85us; 85us; 86us; 86us; 86us; 87us; 87us; 88us; 88us; 89us; 89us; 89us; 90us; 90us; 91us; 92us; 93us; 93us; 93us; 93us; 93us; 93us; 94us; 94us; 95us; 95us; 95us; 96us; 96us; 97us; 97us; 98us; 98us; 99us; 100us; 100us; 101us; 102us; 102us; 103us; 103us; 104us; 104us; 105us; 105us; 106us; 106us; 107us; 107us; 108us; 108us; 108us; 108us; 108us; 108us; 108us; 108us; 108us; 108us; 108us; 108us; 108us; 108us; 108us; 108us; 108us; 108us; 108us; 108us; 108us; |]
let _fsyacc_immediateActions = [|65535us; 49152us; 65535us; 16385us; 65535us; 16386us; 16387us; 65535us; 65535us; 65535us; 16388us; 16389us; 16391us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16393us; 16394us; 65535us; 16396us; 65535us; 16397us; 16398us; 65535us; 16399us; 16400us; 65535us; 65535us; 65535us; 16401us; 65535us; 65535us; 65535us; 65535us; 16402us; 65535us; 65535us; 65535us; 16403us; 65535us; 65535us; 65535us; 16404us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16408us; 65535us; 65535us; 65535us; 65535us; 16410us; 16413us; 16414us; 16415us; 65535us; 65535us; 65535us; 16416us; 65535us; 65535us; 65535us; 16417us; 65535us; 65535us; 16419us; 65535us; 16421us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16424us; 16425us; 65535us; 65535us; 16427us; 65535us; 65535us; 65535us; 16429us; 65535us; 16431us; 16432us; 65535us; 65535us; 65535us; 16433us; 65535us; 65535us; 16434us; 65535us; 65535us; 16436us; 65535us; 65535us; 65535us; 16437us; 65535us; 65535us; 16439us; 16440us; 65535us; 16442us; 16443us; 16444us; 65535us; 16445us; 65535us; 16447us; 16448us; 16449us; 16450us; 65535us; 65535us; 16451us; 65535us; 65535us; 16452us; 65535us; 65535us; 16453us; 65535us; 65535us; 16454us; 65535us; 16455us; 16456us; 65535us; 65535us; 16460us; 65535us; 65535us; 16462us; 65535us; 65535us; 65535us; 65535us; 16464us; 16465us; 16466us; 65535us; 65535us; 65535us; 65535us; 65535us; 16467us; 65535us; 65535us; 65535us; 16468us; 65535us; 16469us; 65535us; 16472us; 65535us; 65535us; 65535us; 16473us; 65535us; 65535us; 65535us; 16475us; 16478us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16480us; 16481us; 16482us; 65535us; 65535us; 16483us; 16484us; 16485us; 16486us; 16487us; 16488us; 16489us; 16490us; 65535us; 65535us; 65535us; 65535us; 16492us; 16493us; 65535us; 65535us; 65535us; 16494us; 65535us; 16496us; 65535us; 16498us; 16499us; 16500us; 16501us; 65535us; 65535us; 16503us; 16504us; 65535us; 65535us; 65535us; 65535us; 65535us; 16505us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16507us; 65535us; 65535us; 65535us; 65535us; 16508us; 65535us; 65535us; 65535us; 65535us; 16509us; 65535us; 65535us; 65535us; 65535us; 16511us; 65535us; 65535us; 65535us; 16513us; 65535us; 65535us; 16515us; 16516us; 65535us; 65535us; 65535us; 65535us; 16517us; 16519us; 65535us; 65535us; 65535us; 16520us; 16521us; 16522us; 16523us; 65535us; 65535us; 16524us; 65535us; 65535us; 16526us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16534us; 65535us; 16535us; 65535us; 16536us; 16537us; 65535us; 65535us; 16538us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16546us; 16547us; 16548us; 16549us; 65535us; 65535us; 65535us; 65535us; 16552us; 65535us; 16553us; 16554us; 65535us; 65535us; 16555us; 16556us; 16560us; 16561us; 16562us; 65535us; 65535us; 16563us; 16564us; 65535us; 65535us; 16565us; 65535us; 65535us; 16566us; 16567us; 65535us; 65535us; 16568us; 65535us; 65535us; 16569us; 65535us; 65535us; 65535us; 65535us; 16571us; 65535us; 65535us; 65535us; 16573us; 16574us; 65535us; 16575us; 65535us; 16577us; 16578us; 16579us; 16580us; 16581us; 16582us; 16583us; 65535us; 65535us; 65535us; 16586us; 16587us; 65535us; 65535us; 65535us; 16588us; 65535us; 65535us; 16589us; 65535us; 16593us; 65535us; 65535us; 16595us; 65535us; 16596us; 65535us; 65535us; 16597us; 65535us; 16598us; 65535us; 65535us; 65535us; 65535us; 16601us; 65535us; 16603us; 16604us; 16605us; 65535us; 16607us; 16612us; 16613us; 16614us; 16615us; 16616us; 16617us; 16618us; 16619us; 16620us; 16621us; 16622us; 16623us; 16624us; 16625us; 16626us; 16627us; 16628us; 16629us; 16630us; 16631us; 16632us; |]
let _fsyacc_reductions ()  =    [| 
# 1609 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : file)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
                      raise (Microsoft.FSharp.Text.Parsing.Accept(Microsoft.FSharp.Core.Operators.box _1))
                   )
                 : '_startfile));
# 1618 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'pragmas)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 125 "parser/parsefstar.fsy"
                             (_1, _2) 
                   )
# 125 "parser/parsefstar.fsy"
                 : file));
# 1630 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'modul)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moduleList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 129 "parser/parsefstar.fsy"
                             _1::_2 
                   )
# 129 "parser/parsefstar.fsy"
                 : 'moduleList));
# 1642 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Sugar.lexcont)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 131 "parser/parsefstar.fsy"
                             [] 
                   )
# 131 "parser/parsefstar.fsy"
                 : 'moduleList));
# 1653 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'qname)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'decls)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'endopt)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 135 "parser/parsefstar.fsy"
                               Module(_2, _3) 
                   )
# 135 "parser/parsefstar.fsy"
                 : 'modul));
# 1666 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 138 "parser/parsefstar.fsy"
                               
                   )
# 138 "parser/parsefstar.fsy"
                 : 'endopt));
# 1676 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 139 "parser/parsefstar.fsy"
                               
                   )
# 139 "parser/parsefstar.fsy"
                 : 'endopt));
# 1686 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'pragmas)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'pragma)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 143 "parser/parsefstar.fsy"
                             (_1@[_2]) 
                   )
# 143 "parser/parsefstar.fsy"
                 : 'pragmas));
# 1698 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 144 "parser/parsefstar.fsy"
                             [] 
                   )
# 144 "parser/parsefstar.fsy"
                 : 'pragmas));
# 1708 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'eitherQname)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'eitherQname)) in
            let _7 = (let data = parseState.GetInput(7) in (Microsoft.FSharp.Core.Operators.unbox data : 'eitherQname)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 148 "parser/parsefstar.fsy"
                             Monadic(_3, _5, _7) 
                   )
# 148 "parser/parsefstar.fsy"
                 : 'pragma));
# 1721 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 150 "parser/parsefstar.fsy"
                             Dynamic 
                   )
# 150 "parser/parsefstar.fsy"
                 : 'pragma));
# 1731 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 153 "parser/parsefstar.fsy"
                             [] 
                   )
# 153 "parser/parsefstar.fsy"
                 : 'decls));
# 1741 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'term)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 155 "parser/parsefstar.fsy"
                             [decl (Main _2) (rhs2 parseState 1 2)] 
                   )
# 155 "parser/parsefstar.fsy"
                 : 'decls));
# 1752 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'decl)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'decls)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 157 "parser/parsefstar.fsy"
                             (_1::_2) 
                   )
# 157 "parser/parsefstar.fsy"
                 : 'decls));
# 1764 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'decl')) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 160 "parser/parsefstar.fsy"
                                 decl _1 (rhs parseState 1) 
                   )
# 160 "parser/parsefstar.fsy"
                 : 'decl));
# 1775 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'qname)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 164 "parser/parsefstar.fsy"
                             Open _2 
                   )
# 164 "parser/parsefstar.fsy"
                 : 'decl'));
# 1786 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tycon)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 166 "parser/parsefstar.fsy"
                             _1 
                   )
# 166 "parser/parsefstar.fsy"
                 : 'decl'));
# 1797 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recopt)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'letbinding)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'letbindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 168 "parser/parsefstar.fsy"
                             ToplevelLet(_2, _3::_4) 
                   )
# 168 "parser/parsefstar.fsy"
                 : 'decl'));
# 1811 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'valQuals)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'eitherName)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'typ)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 170 "parser/parsefstar.fsy"
                             Val(_1, _3, _5) 
                   )
# 170 "parser/parsefstar.fsy"
                 : 'decl'));
# 1824 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'assumeTag)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'name)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'formula)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 172 "parser/parsefstar.fsy"
                             Assume(_1, _2, _4) 
                   )
# 172 "parser/parsefstar.fsy"
                 : 'decl'));
# 1837 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'name)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'erefDefn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 174 "parser/parsefstar.fsy"
                             ExternRef(_3, _4) 
                   )
# 174 "parser/parsefstar.fsy"
                 : 'decl'));
# 1849 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 177 "parser/parsefstar.fsy"
                                 None 
                   )
# 177 "parser/parsefstar.fsy"
                 : 'valQuals));
# 1859 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 178 "parser/parsefstar.fsy"
                                 Some (LogicTag None) 
                   )
# 178 "parser/parsefstar.fsy"
                 : 'valQuals));
# 1869 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'name)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 179 "parser/parsefstar.fsy"
                                       Some (Extern _2) 
                   )
# 179 "parser/parsefstar.fsy"
                 : 'valQuals));
# 1880 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'ident)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : byte[])) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'erefFields)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 183 "parser/parsefstar.fsy"
                             let id:ident = _2 in (id.idText,Util.unicodeEncoding.GetString(_4))::_5 
                   )
# 183 "parser/parsefstar.fsy"
                 : 'erefDefn));
# 1893 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 186 "parser/parsefstar.fsy"
                            [] 
                   )
# 186 "parser/parsefstar.fsy"
                 : 'erefFields));
# 1903 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'ident)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : byte[])) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'erefFields)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 188 "parser/parsefstar.fsy"
                            let id:ident = _2 in (id.idText,Util.unicodeEncoding.GetString(_4))::_5
                   )
# 188 "parser/parsefstar.fsy"
                 : 'erefFields));
# 1916 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 191 "parser/parsefstar.fsy"
                                 false 
                   )
# 191 "parser/parsefstar.fsy"
                 : 'logicTag));
# 1926 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 192 "parser/parsefstar.fsy"
                                 true 
                   )
# 192 "parser/parsefstar.fsy"
                 : 'logicTag));
# 1936 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 195 "parser/parsefstar.fsy"
                                  AssumeTag 
                   )
# 195 "parser/parsefstar.fsy"
                 : 'assumeTag));
# 1946 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 196 "parser/parsefstar.fsy"
                                  QueryTag 
                   )
# 196 "parser/parsefstar.fsy"
                 : 'assumeTag));
# 1956 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 197 "parser/parsefstar.fsy"
                                  DefinitionTag 
                   )
# 197 "parser/parsefstar.fsy"
                 : 'assumeTag));
# 1966 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconQuals)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconDefinition)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconDefinitions)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 201 "parser/parsefstar.fsy"
                             Tycon (_1, _3::_4) 
                   )
# 201 "parser/parsefstar.fsy"
                 : 'tycon));
# 1979 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'eitherName)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'binders)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'ascribeKindOpt)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconDefn)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 205 "parser/parsefstar.fsy"
                             _4 _1 _2 _3 
                   )
# 205 "parser/parsefstar.fsy"
                 : 'tyconDefinition));
# 1993 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 208 "parser/parsefstar.fsy"
                             [] 
                   )
# 208 "parser/parsefstar.fsy"
                 : 'tyconDefinitions));
# 2003 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconDefinition)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tyconDefinitions)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 210 "parser/parsefstar.fsy"
                             _2::_3 
                   )
# 210 "parser/parsefstar.fsy"
                 : 'tyconDefinitions));
# 2015 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 213 "parser/parsefstar.fsy"
                              None 
                   )
# 213 "parser/parsefstar.fsy"
                 : 'tyconQuals));
# 2025 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'ident)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'logicArrayArgs)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 215 "parser/parsefstar.fsy"
                             match _2.idText, _3 with 
                             | "tfun", None -> Some (LogicTag (Some Logic_tfun))
                             | "data", None -> Some (LogicTag (Some Logic_data))
                             | "array", Some larr -> Some (LogicTag (Some (Logic_array larr)))
                             | _ -> errorR(Error("Unexpected type qualifier: expected {data, array, tfun}", (rhs parseState 2))); None
                           
                   )
# 215 "parser/parsefstar.fsy"
                 : 'tyconQuals));
# 2042 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'name)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 223 "parser/parsefstar.fsy"
                             
                             Some (Extern _2)
                           
                   )
# 223 "parser/parsefstar.fsy"
                 : 'tyconQuals));
# 2055 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 228 "parser/parsefstar.fsy"
                              None 
                   )
# 228 "parser/parsefstar.fsy"
                 : 'logicArrayArgs));
# 2065 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'qname)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'qname)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'qname)) in
            let _8 = (let data = parseState.GetInput(8) in (Microsoft.FSharp.Core.Operators.unbox data : 'qname)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 230 "parser/parsefstar.fsy"
                             
                             Some {array_sel=_2;
                                   array_upd=_4;
                                   array_emp=_6;
                                   array_indom=_8}
                           
                   )
# 230 "parser/parsefstar.fsy"
                 : 'logicArrayArgs));
# 2084 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 238 "parser/parsefstar.fsy"
                               true 
                   )
# 238 "parser/parsefstar.fsy"
                 : 'recopt));
# 2094 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 239 "parser/parsefstar.fsy"
                               false 
                   )
# 239 "parser/parsefstar.fsy"
                 : 'recopt));
# 2104 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'letbinding)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'letbindings)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 243 "parser/parsefstar.fsy"
                             _2::_3 
                   )
# 243 "parser/parsefstar.fsy"
                 : 'letbindings));
# 2116 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 244 "parser/parsefstar.fsy"
                             [] 
                   )
# 244 "parser/parsefstar.fsy"
                 : 'letbindings));
# 2126 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'pattern)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'ascribeTypOpt)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'term)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 248 "parser/parsefstar.fsy"
                             
                             match _2 with 
                               | None -> (_1, _4)
                               | Some t -> (pattern (PatAscribed(_1, t)) (rhs2 parseState 1 2), _4)
                           
                   )
# 248 "parser/parsefstar.fsy"
                 : 'letbinding));
# 2143 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 255 "parser/parsefstar.fsy"
                                      _1 
                   )
# 255 "parser/parsefstar.fsy"
                 : 'pattern));
# 2154 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'listPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 256 "parser/parsefstar.fsy"
                                       _1 
                   )
# 256 "parser/parsefstar.fsy"
                 : 'pattern));
# 2165 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tuplePattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 257 "parser/parsefstar.fsy"
                                        _1 
                   )
# 257 "parser/parsefstar.fsy"
                 : 'pattern));
# 2176 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPattern)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatterns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 261 "parser/parsefstar.fsy"
                             
                             let hd = _1 in 
                             let r = rhs parseState 1 in 
                             match _2 with 
                               | [] -> hd
                               | _ -> pattern (PatApp(hd, _2)) (Range.union_ranges r (rhs parseState 1))
                           
                   )
# 261 "parser/parsefstar.fsy"
                 : 'appPattern));
# 2194 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPattern)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'consPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 271 "parser/parsefstar.fsy"
                             
                             let hd = _1 in 
                             let r = rhs parseState 1 in 
                             let tl = match _4 with 
                                 | None -> _3
                                 | Some tl -> pattern (consPat (rhs parseState 3) _3 tl) (rhs2 parseState 2 3) in
                               pattern (consPat (rhs parseState 2) hd tl) (rhs2 parseState 1 2)
                           
                   )
# 271 "parser/parsefstar.fsy"
                 : 'listPattern));
# 2214 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 281 "parser/parsefstar.fsy"
                            None 
                   )
# 281 "parser/parsefstar.fsy"
                 : 'consPattern));
# 2224 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'consPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 283 "parser/parsefstar.fsy"
                             
                             match _3 with 
                               | None -> Some _2
                               | Some tl -> Some (pattern (consPat (rhs parseState 1) _2 tl) (rhs2 parseState 1 3))
                           
                   )
# 283 "parser/parsefstar.fsy"
                 : 'consPattern));
# 2240 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'appPattern)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternListComma)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 291 "parser/parsefstar.fsy"
                            
                             let args = _1::_3::_4 in 
                             pattern (PatTuple(args)) (rhs2 parseState 1 4)
                           
                   )
# 291 "parser/parsefstar.fsy"
                 : 'tuplePattern));
# 2256 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPattern)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatterns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 298 "parser/parsefstar.fsy"
                            
                             let args = _2::_3 in 
                               pattern (PatApp(_1, args)) (rhs2 parseState 1 3)
                           
                   )
# 298 "parser/parsefstar.fsy"
                 : 'compositePattern));
# 2272 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'listPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 302 "parser/parsefstar.fsy"
                                       _1 
                   )
# 302 "parser/parsefstar.fsy"
                 : 'compositePattern));
# 2283 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tuplePattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 303 "parser/parsefstar.fsy"
                                        _1 
                   )
# 303 "parser/parsefstar.fsy"
                 : 'compositePattern));
# 2294 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 306 "parser/parsefstar.fsy"
                              [] 
                   )
# 306 "parser/parsefstar.fsy"
                 : 'atomicPatterns));
# 2304 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPattern)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatterns)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 307 "parser/parsefstar.fsy"
                                                        _1::_2 
                   )
# 307 "parser/parsefstar.fsy"
                 : 'atomicPatterns));
# 2316 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPattern')) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 310 "parser/parsefstar.fsy"
                                          pattern _1 (rhs parseState 1) 
                   )
# 310 "parser/parsefstar.fsy"
                 : 'atomicPattern));
# 2327 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'nonTvarPattern')) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 313 "parser/parsefstar.fsy"
                                           _1 
                   )
# 313 "parser/parsefstar.fsy"
                 : 'atomicPattern'));
# 2338 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tvar)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 314 "parser/parsefstar.fsy"
                                 PatTvar _1 
                   )
# 314 "parser/parsefstar.fsy"
                 : 'atomicPattern'));
# 2349 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'nonTvarPattern')) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 317 "parser/parsefstar.fsy"
                                           pattern _1 (rhs parseState 1) 
                   )
# 317 "parser/parsefstar.fsy"
                 : 'nonTvarPattern));
# 2360 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 320 "parser/parsefstar.fsy"
                                      PatWild 
                   )
# 320 "parser/parsefstar.fsy"
                 : 'nonTvarPattern'));
# 2370 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'constant)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 321 "parser/parsefstar.fsy"
                                    PatConst _1 
                   )
# 321 "parser/parsefstar.fsy"
                 : 'nonTvarPattern'));
# 2381 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 322 "parser/parsefstar.fsy"
                                 PatVar _1 
                   )
# 322 "parser/parsefstar.fsy"
                 : 'nonTvarPattern'));
# 2392 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'qname)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 323 "parser/parsefstar.fsy"
                                 PatName _1 
                   )
# 323 "parser/parsefstar.fsy"
                 : 'nonTvarPattern'));
# 2403 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternListSemiColon)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 324 "parser/parsefstar.fsy"
                                                              PatList _2 
                   )
# 324 "parser/parsefstar.fsy"
                 : 'nonTvarPattern'));
# 2414 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'ascriptionOrPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 325 "parser/parsefstar.fsy"
                                                             _2 
                   )
# 325 "parser/parsefstar.fsy"
                 : 'nonTvarPattern'));
# 2425 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recordPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 326 "parser/parsefstar.fsy"
                                                       PatRecord _2 
                   )
# 326 "parser/parsefstar.fsy"
                 : 'nonTvarPattern'));
# 2436 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'nonTvarPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typ)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 329 "parser/parsefstar.fsy"
                                                     PatAscribed(_1, _3) 
                   )
# 329 "parser/parsefstar.fsy"
                 : 'ascriptionOrPattern));
# 2448 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tvar)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'kind)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 330 "parser/parsefstar.fsy"
                                                    PatAscribed(pattern (PatTvar _1) (rhs parseState 1), _3) 
                   )
# 330 "parser/parsefstar.fsy"
                 : 'ascriptionOrPattern));
# 2460 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'compositePattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 331 "parser/parsefstar.fsy"
                                             _1.pattern 
                   )
# 331 "parser/parsefstar.fsy"
                 : 'ascriptionOrPattern));
# 2471 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 334 "parser/parsefstar.fsy"
                                      fun p -> p 
                   )
# 334 "parser/parsefstar.fsy"
                 : 'maybeAscribeKind));
# 2481 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'kind)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 335 "parser/parsefstar.fsy"
                                      fun p -> PatAscribed(pattern p (lhs parseState), _2) 
                   )
# 335 "parser/parsefstar.fsy"
                 : 'maybeAscribeKind));
# 2492 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 338 "parser/parsefstar.fsy"
                             [] 
                   )
# 338 "parser/parsefstar.fsy"
                 : 'patternListSemiColon));
# 2502 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternListSemiColon)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 339 "parser/parsefstar.fsy"
                                                                        _1::_3 
                   )
# 339 "parser/parsefstar.fsy"
                 : 'patternListSemiColon));
# 2514 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 342 "parser/parsefstar.fsy"
                             [] 
                   )
# 342 "parser/parsefstar.fsy"
                 : 'patternListComma));
# 2524 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'appPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternListComma)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 343 "parser/parsefstar.fsy"
                                                             _2::_3 
                   )
# 343 "parser/parsefstar.fsy"
                 : 'patternListComma));
# 2536 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 346 "parser/parsefstar.fsy"
                             [] 
                   )
# 346 "parser/parsefstar.fsy"
                 : 'recordPattern));
# 2546 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'lid)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPattern)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'recordPattern)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 347 "parser/parsefstar.fsy"
                                                                            (_1,_3)::_5 
                   )
# 347 "parser/parsefstar.fsy"
                 : 'recordPattern));
# 2559 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 350 "parser/parsefstar.fsy"
                                 binder (Variable(_1)) (rhs parseState 1) Type 
                   )
# 350 "parser/parsefstar.fsy"
                 : 'binder));
# 2570 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tvar)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 351 "parser/parsefstar.fsy"
                                 binder (Variable(_1)) (rhs parseState 1) Kind 
                   )
# 351 "parser/parsefstar.fsy"
                 : 'binder));
# 2581 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'ident)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTerm)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'refineOpt)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 353 "parser/parsefstar.fsy"
                             mkRefinedBinder _2 _4 _5 (rhs2 parseState 1 6) 
                   )
# 353 "parser/parsefstar.fsy"
                 : 'binder));
# 2594 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'tvar)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'kind)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 354 "parser/parsefstar.fsy"
                                                          binder (Annotated(_2, _4)) (rhs2 parseState 1 5) Kind 
                   )
# 354 "parser/parsefstar.fsy"
                 : 'binder));
# 2606 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'binder)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'binders)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 357 "parser/parsefstar.fsy"
                                          _1::_2 
                   )
# 357 "parser/parsefstar.fsy"
                 : 'binders));
# 2618 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 358 "parser/parsefstar.fsy"
                                          [] 
                   )
# 358 "parser/parsefstar.fsy"
                 : 'binders));
# 2628 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 361 "parser/parsefstar.fsy"
                                         (fun id binders kopt -> TyconAbstract(id, binders, kopt)) 
                   )
# 361 "parser/parsefstar.fsy"
                 : 'tyconDefn));
# 2638 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typ)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 362 "parser/parsefstar.fsy"
                                         (fun id binders kopt -> TyconAbbrev(id, binders, kopt, _2)) 
                   )
# 362 "parser/parsefstar.fsy"
                 : 'tyconDefn));
# 2649 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recordFieldDecl)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'recordFields)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 363 "parser/parsefstar.fsy"
                                                                             (fun id binders kopt -> TyconRecord(id, binders, kopt, _3::_4)) 
                   )
# 363 "parser/parsefstar.fsy"
                 : 'tyconDefn));
# 2661 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'constructors)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 364 "parser/parsefstar.fsy"
                                               (fun id binders kopt -> TyconVariant(id, binders, kopt, _2)) 
                   )
# 364 "parser/parsefstar.fsy"
                 : 'tyconDefn));
# 2672 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recordFieldDecl)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recordFields)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 369 "parser/parsefstar.fsy"
                             _2::_3 
                   )
# 369 "parser/parsefstar.fsy"
                 : 'recordFields));
# 2684 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 370 "parser/parsefstar.fsy"
                             [] 
                   )
# 370 "parser/parsefstar.fsy"
                 : 'recordFields));
# 2694 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 373 "parser/parsefstar.fsy"
                             [] 
                   )
# 373 "parser/parsefstar.fsy"
                 : 'constructors));
# 2704 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'constructors)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'constructorDecl)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 375 "parser/parsefstar.fsy"
                             _1@[_2] 
                   )
# 375 "parser/parsefstar.fsy"
                 : 'constructors));
# 2716 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'ident)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmTuple)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 379 "parser/parsefstar.fsy"
                             (_1, _3) 
                   )
# 379 "parser/parsefstar.fsy"
                 : 'recordFieldDecl));
# 2728 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'name)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'typ)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 383 "parser/parsefstar.fsy"
                             (_2,_4) 
                   )
# 383 "parser/parsefstar.fsy"
                 : 'constructorDecl));
# 2740 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'eitherQname')) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 386 "parser/parsefstar.fsy"
                                        Absyn.asLid _1 
                   )
# 386 "parser/parsefstar.fsy"
                 : 'eitherQname));
# 2751 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'eitherName)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 389 "parser/parsefstar.fsy"
                                      [_1] 
                   )
# 389 "parser/parsefstar.fsy"
                 : 'eitherQname'));
# 2762 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'name)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'eitherQname')) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 390 "parser/parsefstar.fsy"
                                                 _1::_3 
                   )
# 390 "parser/parsefstar.fsy"
                 : 'eitherQname'));
# 2774 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'idpath)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 393 "parser/parsefstar.fsy"
                                  Absyn.asLid _1 
                   )
# 393 "parser/parsefstar.fsy"
                 : 'lid));
# 2785 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'namepath)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 396 "parser/parsefstar.fsy"
                                    Absyn.asLid _1 
                   )
# 396 "parser/parsefstar.fsy"
                 : 'qname));
# 2796 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 399 "parser/parsefstar.fsy"
                                 _1 
                   )
# 399 "parser/parsefstar.fsy"
                 : 'eitherName));
# 2807 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'name)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 400 "parser/parsefstar.fsy"
                                 _1 
                   )
# 400 "parser/parsefstar.fsy"
                 : 'eitherName));
# 2818 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 404 "parser/parsefstar.fsy"
                             Sugar.ident(_1, rhs parseState 1)
                   )
# 404 "parser/parsefstar.fsy"
                 : 'ident));
# 2829 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 408 "parser/parsefstar.fsy"
                             Sugar.ident(_1, rhs parseState 1) 
                   )
# 408 "parser/parsefstar.fsy"
                 : 'name));
# 2840 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 412 "parser/parsefstar.fsy"
                             Sugar.ident(_1, rhs parseState 1) 
                   )
# 412 "parser/parsefstar.fsy"
                 : 'tvar));
# 2851 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'name)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 416 "parser/parsefstar.fsy"
                             [_1] 
                   )
# 416 "parser/parsefstar.fsy"
                 : 'namepath));
# 2862 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'name)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'namepath)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 418 "parser/parsefstar.fsy"
                             _1::_3 
                   )
# 418 "parser/parsefstar.fsy"
                 : 'namepath));
# 2874 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 422 "parser/parsefstar.fsy"
                             [_1] 
                   )
# 422 "parser/parsefstar.fsy"
                 : 'idpath));
# 2885 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'name)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'idpath)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 424 "parser/parsefstar.fsy"
                             _1::_3 
                   )
# 424 "parser/parsefstar.fsy"
                 : 'idpath));
# 2897 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 427 "parser/parsefstar.fsy"
                                        None 
                   )
# 427 "parser/parsefstar.fsy"
                 : 'ascribeTypOpt));
# 2907 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmCons)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 428 "parser/parsefstar.fsy"
                                        Some _2 
                   )
# 428 "parser/parsefstar.fsy"
                 : 'ascribeTypOpt));
# 2918 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 431 "parser/parsefstar.fsy"
                                         None 
                   )
# 431 "parser/parsefstar.fsy"
                 : 'ascribeKindOpt));
# 2928 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'kind)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 432 "parser/parsefstar.fsy"
                                       Some _2 
                   )
# 432 "parser/parsefstar.fsy"
                 : 'ascribeKindOpt));
# 2939 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'product)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 435 "parser/parsefstar.fsy"
                                   {_1 with level=Kind} 
                   )
# 435 "parser/parsefstar.fsy"
                 : 'kind));
# 2950 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicTerm)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 438 "parser/parsefstar.fsy"
                                      let tm:term = _1 in {tm with level=Kind} 
                   )
# 438 "parser/parsefstar.fsy"
                 : 'atomicKind));
# 2961 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'simpleTerm)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 441 "parser/parsefstar.fsy"
                                      {_1 with level=Type} 
                   )
# 441 "parser/parsefstar.fsy"
                 : 'typ));
# 2972 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'noSeqTerm)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 446 "parser/parsefstar.fsy"
                             _1 
                   )
# 446 "parser/parsefstar.fsy"
                 : 'term));
# 2983 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'noSeqTerm)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'term)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 449 "parser/parsefstar.fsy"
                             term (Seq(_1, _3)) (rhs2 parseState 1 3) Expr 
                   )
# 449 "parser/parsefstar.fsy"
                 : 'term));
# 2995 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'simpleTerm)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 453 "parser/parsefstar.fsy"
                                      _1 
                   )
# 453 "parser/parsefstar.fsy"
                 : 'noSeqTerm));
# 3006 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'term)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'term)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'term)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 456 "parser/parsefstar.fsy"
                            
                             term (If(_2, _4, _6)) (rhs2 parseState 1 6) Expr
                           
                   )
# 456 "parser/parsefstar.fsy"
                 : 'noSeqTerm));
# 3021 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'term)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternBranch)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternBranches)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 461 "parser/parsefstar.fsy"
                            
                             term (Match(_2, _4::_5)) (rhs2 parseState 1 5) Expr
                           
                   )
# 461 "parser/parsefstar.fsy"
                 : 'noSeqTerm));
# 3036 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : bool)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recopt)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'letbinding)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'letbindings)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'term)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 466 "parser/parsefstar.fsy"
                            
                             term (Let(_2, (_3::_4), _6)) (rhs2 parseState 1 6) Expr
                           
                   )
# 466 "parser/parsefstar.fsy"
                 : 'noSeqTerm));
# 3053 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'binders)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'qpat)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'noSeqTerm)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 471 "parser/parsefstar.fsy"
                            
                             term (QForall(_2,_4,_5)) (rhs2 parseState 1 5) Formula
                           
                   )
# 471 "parser/parsefstar.fsy"
                 : 'noSeqTerm));
# 3068 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'binders)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'qpat)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'noSeqTerm)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 476 "parser/parsefstar.fsy"
                            
                             term (QExists(_2,_4,_5)) (rhs2 parseState 1 5) Formula
                           
                   )
# 476 "parser/parsefstar.fsy"
                 : 'noSeqTerm));
# 3083 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternBranch)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternBranches)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 481 "parser/parsefstar.fsy"
                             
                             let x = Absyn.genident (Some (lhs parseState)) in 
                             term (Abs([pattern (PatVar x) (lhs parseState)], 
                                       term (Match(term (Var(Absyn.asLid [x])) (lhs parseState) Expr, _2::_3)) (rhs2 parseState 1 3) Expr))
                               (rhs2 parseState 1 3) Expr
                           
                   )
# 481 "parser/parsefstar.fsy"
                 : 'noSeqTerm));
# 3100 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicTerm)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 489 "parser/parsefstar.fsy"
                             mkApp (term (Var Const.assume_lid) (rhs parseState 1) Expr) [_2]
                               (rhs2 parseState 1 2)
                           
                   )
# 489 "parser/parsefstar.fsy"
                 : 'noSeqTerm));
# 3113 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 494 "parser/parsefstar.fsy"
                             [] 
                   )
# 494 "parser/parsefstar.fsy"
                 : 'qpat));
# 3123 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTerm)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'morePats)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 496 "parser/parsefstar.fsy"
                             _2::_3 
                   )
# 496 "parser/parsefstar.fsy"
                 : 'qpat));
# 3135 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 499 "parser/parsefstar.fsy"
                            [] 
                   )
# 499 "parser/parsefstar.fsy"
                 : 'morePats));
# 3145 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTerm)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'morePats)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 500 "parser/parsefstar.fsy"
                                                       _2::_3 
                   )
# 500 "parser/parsefstar.fsy"
                 : 'morePats));
# 3157 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmIff)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 503 "parser/parsefstar.fsy"
                                 _1 
                   )
# 503 "parser/parsefstar.fsy"
                 : 'simpleTerm));
# 3168 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPattern)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicPatterns)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'funArrow)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'term)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 506 "parser/parsefstar.fsy"
                            
                             _4 (Abs(_2::_3, _5)) (rhs2 parseState 1 5) 
                           
                   )
# 506 "parser/parsefstar.fsy"
                 : 'simpleTerm));
# 3184 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 511 "parser/parsefstar.fsy"
                             [] 
                   )
# 511 "parser/parsefstar.fsy"
                 : 'patternBranches));
# 3194 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternBranches)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'patternBranch)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 513 "parser/parsefstar.fsy"
                             _1@[_2] 
                   )
# 513 "parser/parsefstar.fsy"
                 : 'patternBranches));
# 3206 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'pattern)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'term)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 516 "parser/parsefstar.fsy"
                                                   (_2, _4) 
                   )
# 516 "parser/parsefstar.fsy"
                 : 'patternBranch));
# 3218 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 519 "parser/parsefstar.fsy"
                                  fun t r -> term t r Expr 
                   )
# 519 "parser/parsefstar.fsy"
                 : 'funArrow));
# 3228 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 520 "parser/parsefstar.fsy"
                                   fun t r -> term t r Type 
                   )
# 520 "parser/parsefstar.fsy"
                 : 'funArrow));
# 3238 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 521 "parser/parsefstar.fsy"
                                          fun t r -> term (Affine(term t r Expr)) r Expr 
                   )
# 521 "parser/parsefstar.fsy"
                 : 'funArrow));
# 3248 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmImplies)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmIff)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 525 "parser/parsefstar.fsy"
                            
                             term (Op("<==>", [_1; _3])) (rhs2 parseState 1 3) Formula
                           
                   )
# 525 "parser/parsefstar.fsy"
                 : 'tmIff));
# 3262 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmImplies)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 530 "parser/parsefstar.fsy"
                             _1 
                   )
# 530 "parser/parsefstar.fsy"
                 : 'tmIff));
# 3273 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmDisjunction)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmImplies)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 534 "parser/parsefstar.fsy"
                            
                             term (Op("==>", [_1; _3])) (rhs2 parseState 1 3) Formula
                           
                   )
# 534 "parser/parsefstar.fsy"
                 : 'tmImplies));
# 3287 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmDisjunction)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 539 "parser/parsefstar.fsy"
                             _1 
                   )
# 539 "parser/parsefstar.fsy"
                 : 'tmImplies));
# 3298 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmDisjunction)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmConjunction)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 543 "parser/parsefstar.fsy"
                             term (Op("\\/", [_1;_3])) (rhs2 parseState 1 3) Formula 
                   )
# 543 "parser/parsefstar.fsy"
                 : 'tmDisjunction));
# 3310 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmConjunction)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 546 "parser/parsefstar.fsy"
                             _1 
                   )
# 546 "parser/parsefstar.fsy"
                 : 'tmDisjunction));
# 3321 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmConjunction)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmTuple)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 550 "parser/parsefstar.fsy"
                             term (Op("/\\", [_1;_3])) (rhs2 parseState 1 3) Formula 
                   )
# 550 "parser/parsefstar.fsy"
                 : 'tmConjunction));
# 3333 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmTuple)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 553 "parser/parsefstar.fsy"
                             _1 
                   )
# 553 "parser/parsefstar.fsy"
                 : 'tmConjunction));
# 3344 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmTuple)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmEq)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 566 "parser/parsefstar.fsy"
                            
                             mkTuple _1 _3 (rhs2 parseState 1 3)
                           
                   )
# 566 "parser/parsefstar.fsy"
                 : 'tmTuple));
# 3358 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmEq)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 571 "parser/parsefstar.fsy"
                             _1 
                   )
# 571 "parser/parsefstar.fsy"
                 : 'tmTuple));
# 3369 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmEq)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmCons)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 575 "parser/parsefstar.fsy"
                            
                             term (Op("=", [_1; _3])) (rhs2 parseState 1 3) Un
                           
                   )
# 575 "parser/parsefstar.fsy"
                 : 'tmEq));
# 3383 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmEq)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmCons)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 580 "parser/parsefstar.fsy"
                            
                             term (Op("<>", [_1; _3])) (rhs2 parseState 1 3) Un
                           
                   )
# 580 "parser/parsefstar.fsy"
                 : 'tmEq));
# 3397 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmEq)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmCons)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 585 "parser/parsefstar.fsy"
                            
                             term (Op(":=", [_1; _3])) (rhs2 parseState 1 3) Un
                           
                   )
# 585 "parser/parsefstar.fsy"
                 : 'tmEq));
# 3411 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmCons)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 590 "parser/parsefstar.fsy"
                             _1 
                   )
# 590 "parser/parsefstar.fsy"
                 : 'tmEq));
# 3422 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmOr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmCons)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 594 "parser/parsefstar.fsy"
                             consTerm (rhs parseState 2) _1 _3 
                   )
# 594 "parser/parsefstar.fsy"
                 : 'tmCons));
# 3434 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmOr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 597 "parser/parsefstar.fsy"
                             _1 
                   )
# 597 "parser/parsefstar.fsy"
                 : 'tmCons));
# 3445 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmOr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmAnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 601 "parser/parsefstar.fsy"
                             term (Op("||", [_1; _3])) (rhs2 parseState 1 3) Un
                   )
# 601 "parser/parsefstar.fsy"
                 : 'tmOr));
# 3457 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmAnd)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 604 "parser/parsefstar.fsy"
                             _1 
                   )
# 604 "parser/parsefstar.fsy"
                 : 'tmOr));
# 3468 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmAnd)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'arithTerm)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 608 "parser/parsefstar.fsy"
                             term (Op("&&", [_1;_3])) (rhs2 parseState 1 3) Un
                   )
# 608 "parser/parsefstar.fsy"
                 : 'tmAnd));
# 3480 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'cmpTerm)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 611 "parser/parsefstar.fsy"
                             _1 
                   )
# 611 "parser/parsefstar.fsy"
                 : 'tmAnd));
# 3491 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'cmpTerm)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'comparisonOp)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'arithTerm)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 615 "parser/parsefstar.fsy"
                             term (Op(_2, [_1;_3])) (rhs2 parseState 1 3) Expr 
                   )
# 615 "parser/parsefstar.fsy"
                 : 'cmpTerm));
# 3504 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'arithTerm)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 617 "parser/parsefstar.fsy"
                             _1 
                   )
# 617 "parser/parsefstar.fsy"
                 : 'cmpTerm));
# 3515 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 620 "parser/parsefstar.fsy"
                                "<" 
                   )
# 620 "parser/parsefstar.fsy"
                 : 'comparisonOp));
# 3525 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 621 "parser/parsefstar.fsy"
                                   ">" 
                   )
# 621 "parser/parsefstar.fsy"
                 : 'comparisonOp));
# 3535 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 622 "parser/parsefstar.fsy"
                               "<=" 
                   )
# 622 "parser/parsefstar.fsy"
                 : 'comparisonOp));
# 3545 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 623 "parser/parsefstar.fsy"
                               ">=" 
                   )
# 623 "parser/parsefstar.fsy"
                 : 'comparisonOp));
# 3555 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'arithTerm)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'starDivModTerm)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 627 "parser/parsefstar.fsy"
                             term (Op(_2, [_1;_3])) (rhs2 parseState 1 3) Un
                   )
# 627 "parser/parsefstar.fsy"
                 : 'arithTerm));
# 3568 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'starDivModTerm)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 630 "parser/parsefstar.fsy"
                             _1 
                   )
# 630 "parser/parsefstar.fsy"
                 : 'arithTerm));
# 3579 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'starDivModTerm)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'sumType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 634 "parser/parsefstar.fsy"
                             term (Op("*", [_1;_3])) (rhs2 parseState 1 3) Un
                   )
# 634 "parser/parsefstar.fsy"
                 : 'starDivModTerm));
# 3591 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'starDivModTerm)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'sumType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 637 "parser/parsefstar.fsy"
                             term (Op(_2, [_1;_3])) (rhs2 parseState 1 3) Un
                   )
# 637 "parser/parsefstar.fsy"
                 : 'starDivModTerm));
# 3604 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'sumType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 640 "parser/parsefstar.fsy"
                             _1 
                   )
# 640 "parser/parsefstar.fsy"
                 : 'starDivModTerm));
# 3615 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'productOrSumDomain)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'sumTypeTail)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 644 "parser/parsefstar.fsy"
                             term (Sum([_1], _3)) (rhs2 parseState 1 3) Type 
                   )
# 644 "parser/parsefstar.fsy"
                 : 'sumType));
# 3627 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'product)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 647 "parser/parsefstar.fsy"
                             _1 
                   )
# 647 "parser/parsefstar.fsy"
                 : 'sumType));
# 3638 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'productOrSumDomain)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'prodArrow)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'product')) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 651 "parser/parsefstar.fsy"
                             _2 (Product([_1], _3)) (rhs2 parseState 1 3) 
                   )
# 651 "parser/parsefstar.fsy"
                 : 'product'));
# 3651 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTerm)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'prodArrow)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'product')) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 654 "parser/parsefstar.fsy"
                             
                             let b = binder (NoName _1) (rhs parseState 1) Un in
                               _2 (Product([b], _3)) (rhs2 parseState 1 3)
                           
                   )
# 654 "parser/parsefstar.fsy"
                 : 'product'));
# 3667 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTerm)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 659 "parser/parsefstar.fsy"
                             _1 
                   )
# 659 "parser/parsefstar.fsy"
                 : 'product'));
# 3678 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 662 "parser/parsefstar.fsy"
                                  fun t r -> term t r Type 
                   )
# 662 "parser/parsefstar.fsy"
                 : 'prodArrow));
# 3688 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 663 "parser/parsefstar.fsy"
                                   fun t r -> term t r Kind 
                   )
# 663 "parser/parsefstar.fsy"
                 : 'prodArrow));
# 3698 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 664 "parser/parsefstar.fsy"
                                          fun t r -> term (Affine(term t r Type)) r Type 
                   )
# 664 "parser/parsefstar.fsy"
                 : 'prodArrow));
# 3708 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicTerm)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'sumType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 668 "parser/parsefstar.fsy"
                             term (Sum([binder (NoName _1) (rhs parseState 1) Type], _3)) (rhs2 parseState 1 3) Type 
                   )
# 668 "parser/parsefstar.fsy"
                 : 'sumTypeTail));
# 3720 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'sumType)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 670 "parser/parsefstar.fsy"
                             _1 
                   )
# 670 "parser/parsefstar.fsy"
                 : 'sumTypeTail));
# 3731 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'productOrSumDomain)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'prodArrow)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'product)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 674 "parser/parsefstar.fsy"
                             let mkProd = _2 in mkProd (Product([_1], _3)) (rhs2 parseState 1 3) 
                   )
# 674 "parser/parsefstar.fsy"
                 : 'product));
# 3744 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTerm)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'prodArrow)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'product)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 677 "parser/parsefstar.fsy"
                             
                             let b = binder (NoName _1) (rhs parseState 1) Un in
                             let mkProd = _2 in 
                             mkProd (Product([b], _3)) (rhs2 parseState 1 3) 
                           
                   )
# 677 "parser/parsefstar.fsy"
                 : 'product));
# 3761 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'refinementTerm)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 683 "parser/parsefstar.fsy"
                             _1 
                   )
# 683 "parser/parsefstar.fsy"
                 : 'product));
# 3772 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'ident)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTerm)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'refineOpt)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 687 "parser/parsefstar.fsy"
                             mkRefinedBinder _1 _3 _4 (rhs2 parseState 1 4) 
                   )
# 687 "parser/parsefstar.fsy"
                 : 'productOrSumDomain));
# 3785 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tvar)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicKind)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 689 "parser/parsefstar.fsy"
                             binder (Annotated(_1, _3)) (rhs2 parseState 1 3) Kind
                   )
# 689 "parser/parsefstar.fsy"
                 : 'productOrSumDomain));
# 3797 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 692 "parser/parsefstar.fsy"
                                 None 
                   )
# 692 "parser/parsefstar.fsy"
                 : 'refineOpt));
# 3807 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'formula)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 693 "parser/parsefstar.fsy"
                                                 Some _2 
                   )
# 693 "parser/parsefstar.fsy"
                 : 'refineOpt));
# 3818 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'ident)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTerm)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'formula)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 697 "parser/parsefstar.fsy"
                            
                             term (Refine(binder (Annotated(_1, _3)) (rhs2 parseState 1 3) Type, _5)) 
                             (rhs2 parseState 1 6) Type
                           
                   )
# 697 "parser/parsefstar.fsy"
                 : 'refinementTerm));
# 3834 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recordExp)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 702 "parser/parsefstar.fsy"
                                                   _2 
                   )
# 702 "parser/parsefstar.fsy"
                 : 'refinementTerm));
# 3845 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'unaryOpTerm)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 704 "parser/parsefstar.fsy"
                                       _1 
                   )
# 704 "parser/parsefstar.fsy"
                 : 'refinementTerm));
# 3856 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTerm)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 709 "parser/parsefstar.fsy"
                             term (Op(_1, [_2])) (rhs2 parseState 1 3) Formula 
                   )
# 709 "parser/parsefstar.fsy"
                 : 'unaryOpTerm));
# 3868 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'appTerm)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 713 "parser/parsefstar.fsy"
                             _1 
                   )
# 713 "parser/parsefstar.fsy"
                 : 'unaryOpTerm));
# 3879 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicTerm)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicTerms)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 717 "parser/parsefstar.fsy"
                            
                             mkApp _1 _2 (rhs2 parseState 1 2)
                           
                   )
# 717 "parser/parsefstar.fsy"
                 : 'appTerm));
# 3893 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'noSeqTerm)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 723 "parser/parsefstar.fsy"
                             {_1 with level=Formula} 
                   )
# 723 "parser/parsefstar.fsy"
                 : 'formula));
# 3904 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 726 "parser/parsefstar.fsy"
                                      term Wild (rhs parseState 1) Un 
                   )
# 726 "parser/parsefstar.fsy"
                 : 'atomicTerm));
# 3914 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 727 "parser/parsefstar.fsy"
                                    term (Var Const.assert_lid) (rhs parseState 1) Expr 
                   )
# 727 "parser/parsefstar.fsy"
                 : 'atomicTerm));
# 3924 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'tvar)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 728 "parser/parsefstar.fsy"
                                    term (Tvar(_1)) (rhs parseState 1) Type 
                   )
# 728 "parser/parsefstar.fsy"
                 : 'atomicTerm));
# 3935 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'qname)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 729 "parser/parsefstar.fsy"
                                    term (Name _1) (rhs parseState 1) Un 
                   )
# 729 "parser/parsefstar.fsy"
                 : 'atomicTerm));
# 3946 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'constant)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 730 "parser/parsefstar.fsy"
                                    term (Const _1) (rhs parseState 1) Expr 
                   )
# 730 "parser/parsefstar.fsy"
                 : 'atomicTerm));
# 3957 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'projectionLHS)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'maybeFieldProjections)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 732 "parser/parsefstar.fsy"
                              
                             List.fold_left (fun e f -> 
                                               term (Project(e, Absyn.asLid [f])) (rhs2 parseState 1 3) Expr )
                               _1 _2
                           
                   )
# 732 "parser/parsefstar.fsy"
                 : 'atomicTerm));
# 3973 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 739 "parser/parsefstar.fsy"
                              [] 
                   )
# 739 "parser/parsefstar.fsy"
                 : 'maybeFieldProjections));
# 3983 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'maybeFieldProjections)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 741 "parser/parsefstar.fsy"
                             _1@[_3] 
                   )
# 741 "parser/parsefstar.fsy"
                 : 'maybeFieldProjections));
# 3995 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'lid)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 745 "parser/parsefstar.fsy"
                             term (Var(_1)) (rhs parseState 1) Un 
                   )
# 745 "parser/parsefstar.fsy"
                 : 'projectionLHS));
# 4006 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'term)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'maybeWithSort)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 747 "parser/parsefstar.fsy"
                             _3 _2 (rhs2 parseState 1 4) 
                   )
# 747 "parser/parsefstar.fsy"
                 : 'projectionLHS));
# 4018 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'semiColonTermList)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 749 "parser/parsefstar.fsy"
                             
                             mkConsList (rhs2 parseState 1 3) _2
                           
                   )
# 749 "parser/parsefstar.fsy"
                 : 'projectionLHS));
# 4031 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'projectionLHS)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 755 "parser/parsefstar.fsy"
                             term (Project(_1, Absyn.asLid[_3])) (rhs2 parseState 1 3) Expr 
                   )
# 755 "parser/parsefstar.fsy"
                 : 'projection));
# 4043 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'projectionLHS)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 757 "parser/parsefstar.fsy"
                             _1 
                   )
# 757 "parser/parsefstar.fsy"
                 : 'projection));
# 4054 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 760 "parser/parsefstar.fsy"
                            [] 
                   )
# 760 "parser/parsefstar.fsy"
                 : 'semiColonTermList));
# 4064 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'noSeqTerm)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'moreSemiColonTerms)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 762 "parser/parsefstar.fsy"
                             _1::_2 
                   )
# 762 "parser/parsefstar.fsy"
                 : 'semiColonTermList));
# 4076 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 765 "parser/parsefstar.fsy"
                             [] 
                   )
# 765 "parser/parsefstar.fsy"
                 : 'moreSemiColonTerms));
# 4086 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'noSeqTerm)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'moreSemiColonTerms)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 767 "parser/parsefstar.fsy"
                             _2::_3 
                   )
# 767 "parser/parsefstar.fsy"
                 : 'moreSemiColonTerms));
# 4098 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicTerm)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recordExpRest)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 771 "parser/parsefstar.fsy"
                             _2 _1 (lhs parseState) 
                   )
# 771 "parser/parsefstar.fsy"
                 : 'recordExp));
# 4110 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recordFieldAssignment)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recordFieldAssignments)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 775 "parser/parsefstar.fsy"
                            
                             (fun e r -> term (Record(Some e, _2::_3)) (Range.union_ranges r (rhs2 parseState 1 3)) Expr)
                           
                   )
# 775 "parser/parsefstar.fsy"
                 : 'recordExpRest));
# 4124 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmTuple)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recordFieldAssignments)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 780 "parser/parsefstar.fsy"
                            
                             (fun e r -> match e.term with 
                               | Var l -> term (Record(None, (l,_2)::_3)) (Range.union_ranges r (rhs2 parseState 1 3)) Expr
                               | _ -> errorR(Error("Record field names must be constant identifiers", lhs(parseState)));
                                 term (Record(None, _3)) (rhs2 parseState 1 3) Expr)
                           
                   )
# 780 "parser/parsefstar.fsy"
                 : 'recordExpRest));
# 4141 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'lid)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmTuple)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 789 "parser/parsefstar.fsy"
                             (_1,_3) 
                   )
# 789 "parser/parsefstar.fsy"
                 : 'recordFieldAssignment));
# 4153 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 792 "parser/parsefstar.fsy"
                            [] 
                   )
# 792 "parser/parsefstar.fsy"
                 : 'recordFieldAssignments));
# 4163 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'recordFieldAssignment)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recordFieldAssignments)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 794 "parser/parsefstar.fsy"
                            _2::_3 
                   )
# 794 "parser/parsefstar.fsy"
                 : 'recordFieldAssignments));
# 4175 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 797 "parser/parsefstar.fsy"
                               fun x r -> x 
                   )
# 797 "parser/parsefstar.fsy"
                 : 'maybeWithSort));
# 4185 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'hasSort)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'simpleTerm)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 799 "parser/parsefstar.fsy"
                               fun x r -> term (Ascribed(x,{_2 with level=_1})) (Range.union_ranges r (rhs2 parseState 1 2)) _1 
                   )
# 799 "parser/parsefstar.fsy"
                 : 'maybeWithSort));
# 4197 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 801 "parser/parsefstar.fsy"
                                   Expr 
                   )
# 801 "parser/parsefstar.fsy"
                 : 'hasSort));
# 4207 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 802 "parser/parsefstar.fsy"
                                   Type 
                   )
# 802 "parser/parsefstar.fsy"
                 : 'hasSort));
# 4217 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 805 "parser/parsefstar.fsy"
                                  [] 
                   )
# 805 "parser/parsefstar.fsy"
                 : 'atomicTerms));
# 4227 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicTerm)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicTerms)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 806 "parser/parsefstar.fsy"
                                                  _1::_2 
                   )
# 806 "parser/parsefstar.fsy"
                 : 'atomicTerms));
# 4239 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 809 "parser/parsefstar.fsy"
                                 None 
                   )
# 809 "parser/parsefstar.fsy"
                 : 'consTerm));
# 4249 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'tmTuple)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'consTerm)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 811 "parser/parsefstar.fsy"
                             
                             match _3 with 
                               | None -> Some _2
                               | Some tl -> Some (consTerm (rhs2 parseState 2 3) _2 tl)
                           
                   )
# 811 "parser/parsefstar.fsy"
                 : 'consTerm));
# 4265 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 818 "parser/parsefstar.fsy"
                                    [] 
                   )
# 818 "parser/parsefstar.fsy"
                 : 'tupleTerm));
# 4275 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'atomicTerm)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'tupleTerm)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 819 "parser/parsefstar.fsy"
                                                      _2::_3 
                   )
# 819 "parser/parsefstar.fsy"
                 : 'tupleTerm));
# 4287 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 822 "parser/parsefstar.fsy"
                                         Sugar.Const_unit 
                   )
# 822 "parser/parsefstar.fsy"
                 : 'constant));
# 4297 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : sbyte * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 824 "parser/parsefstar.fsy"
                             
                             if snd _1 then
                               errorR(Error("This number is outside the allowable range for 8-bit signed integers", lhs(parseState)));
                             Const_int8 (fst _1) 
                           
                   )
# 824 "parser/parsefstar.fsy"
                 : 'constant));
# 4312 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : byte)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 829 "parser/parsefstar.fsy"
                                 Const_uint8 _1 
                   )
# 829 "parser/parsefstar.fsy"
                 : 'constant));
# 4323 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : int16 * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 831 "parser/parsefstar.fsy"
                             
                             if snd _1 then 
                               errorR(Error("This number is outside the allowable range for 16-bit signed integers", lhs(parseState)));
                             Const_int16 (fst _1) 
                           
                   )
# 831 "parser/parsefstar.fsy"
                 : 'constant));
# 4338 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : uint16)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 836 "parser/parsefstar.fsy"
                                  Const_uint16 _1 
                   )
# 836 "parser/parsefstar.fsy"
                 : 'constant));
# 4349 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : int32 * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 838 "parser/parsefstar.fsy"
                             
                             if snd _1 then 
                               errorR(Error("This number is outside the allowable range for 32-bit signed integers", lhs(parseState)));
                             Const_int32 (fst _1) 
                           
                   )
# 838 "parser/parsefstar.fsy"
                 : 'constant));
# 4364 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : uint32)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 843 "parser/parsefstar.fsy"
                                  Const_uint32 _1 
                   )
# 843 "parser/parsefstar.fsy"
                 : 'constant));
# 4375 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : int64 * bool)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 845 "parser/parsefstar.fsy"
                             
                             if snd _1 then 
                               errorR(Error("This number is outside the allowable range for 64-bit signed integers", lhs(parseState)));
                             Const_int64 (fst _1) 
                           
                   )
# 845 "parser/parsefstar.fsy"
                 : 'constant));
# 4390 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : uint64)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 850 "parser/parsefstar.fsy"
                                  Const_uint64 _1 
                   )
# 850 "parser/parsefstar.fsy"
                 : 'constant));
# 4401 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : int64)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 851 "parser/parsefstar.fsy"
                                     Const_nativeint _1 
                   )
# 851 "parser/parsefstar.fsy"
                 : 'constant));
# 4412 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : uint64)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 852 "parser/parsefstar.fsy"
                                      Const_unativeint _1 
                   )
# 852 "parser/parsefstar.fsy"
                 : 'constant));
# 4423 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : single)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 853 "parser/parsefstar.fsy"
                                  Const_float32 _1 
                   )
# 853 "parser/parsefstar.fsy"
                 : 'constant));
# 4434 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : double)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 854 "parser/parsefstar.fsy"
                                  Const_float _1 
                   )
# 854 "parser/parsefstar.fsy"
                 : 'constant));
# 4445 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : char)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 855 "parser/parsefstar.fsy"
                                Const_char _1 
                   )
# 855 "parser/parsefstar.fsy"
                 : 'constant));
# 4456 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : byte[])) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 856 "parser/parsefstar.fsy"
                                  Const_bigint _1 
                   )
# 856 "parser/parsefstar.fsy"
                 : 'constant));
# 4467 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : System.Decimal)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 857 "parser/parsefstar.fsy"
                                   Const_decimal _1 
                   )
# 857 "parser/parsefstar.fsy"
                 : 'constant));
# 4478 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : byte[])) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 858 "parser/parsefstar.fsy"
                                  Const_bignum _1 
                   )
# 858 "parser/parsefstar.fsy"
                 : 'constant));
# 4489 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : byte[])) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 859 "parser/parsefstar.fsy"
                                  Const_string (_1,lhs(parseState)) 
                   )
# 859 "parser/parsefstar.fsy"
                 : 'constant));
# 4500 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : byte[])) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 860 "parser/parsefstar.fsy"
                                     Const_bytearray (_1,lhs(parseState)) 
                   )
# 860 "parser/parsefstar.fsy"
                 : 'constant));
# 4511 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 861 "parser/parsefstar.fsy"
                                Const_bool true 
                   )
# 861 "parser/parsefstar.fsy"
                 : 'constant));
# 4521 "parser\parsefstar.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 862 "parser/parsefstar.fsy"
                                 Const_bool false 
                   )
# 862 "parser/parsefstar.fsy"
                 : 'constant));
|]
# 4532 "parser\parsefstar.fs"
let tables () : Microsoft.FSharp.Text.Parsing.Tables<_> = 
  { reductions= _fsyacc_reductions ();
    endOfInputTag = _fsyacc_endOfInputTag;
    tagOfToken = tagOfToken;
    dataOfToken = _fsyacc_dataOfToken; 
    actionTableElements = _fsyacc_actionTableElements;
    actionTableRowOffsets = _fsyacc_actionTableRowOffsets;
    stateToProdIdxsTableElements = _fsyacc_stateToProdIdxsTableElements;
    stateToProdIdxsTableRowOffsets = _fsyacc_stateToProdIdxsTableRowOffsets;
    reductionSymbolCounts = _fsyacc_reductionSymbolCounts;
    immediateActions = _fsyacc_immediateActions;
    gotos = _fsyacc_gotos;
    sparseGotoTableRowOffsets = _fsyacc_sparseGotoTableRowOffsets;
    tagOfErrorTerminal = _fsyacc_tagOfErrorTerminal;
    parseError = (fun (ctxt:Microsoft.FSharp.Text.Parsing.ParseErrorContext<_>) -> 
                              match parse_error_rich with 
                              | Some f -> f ctxt
                              | None -> parse_error ctxt.Message);
    numTerminals = 193;
    productionToNonTerminalTable = _fsyacc_productionToNonTerminalTable  }
let engine lexer lexbuf startState = (tables ()).Interpret(lexer, lexbuf, startState)
let file lexer lexbuf : file =
    Microsoft.FSharp.Core.Operators.unbox ((tables ()).Interpret(lexer, lexbuf, 0))
